package com.xx.hbhconsumer.adapter;

import android.content.Context;
import android.view.View;

import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.respons.ActivityCouponBean;
import com.xx.hbhconsumer.data.http.respons.CouponBean;
import com.xx.hbhconsumer.databinding.ItemActivityCouponBinding;
import com.xx.hbhconsumer.databinding.ItemCouponBinding;
import com.xx.hbhconsumer.ui.activity.ActivityViewModel;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import java.math.BigDecimal;

public class ActivityCouponAdapter extends xxBaseRecyclerViewAdapter<ItemActivityCouponBinding, ActivityCouponBean> {
    private ActivityViewModel activityViewModel;
    public ActivityCouponAdapter(Context context, ActivityViewModel activityViewModel) {
        super(context);
        mContext = context;
        this.activityViewModel = activityViewModel;
    }

    @Override
    public int initLayout() {
        return R.layout.item_activity_coupon;
    }

    @Override
    protected void covert(ItemActivityCouponBinding dataBind, ActivityCouponBean data, int position) {
        //   将接口调出来的布局遍历上去
        dataBind.setActivityCouponBean(data);

        dataBind.tvReceive.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                activityViewModel.getCoupon(data.getBusinessId());
            }
        });
        dataBind.tvCouponName.setText(data.getCouponName());

        if ("1".equals(data.getCouponType())) {
            dataBind.ivCouponType.setVisibility(View.VISIBLE);
            dataBind.ivCouponType.setImageDrawable(mContext.getDrawable(R.mipmap.youhuiquan_tag_manjian));
            dataBind.tvCouponName.setText(data.getCouponName());
            dataBind.tvDiscountAmount.setText("￥" + new BigDecimal(String.valueOf(data.getDiscountAmount())).stripTrailingZeros().toPlainString());
        } else if ("2".equals(data.getCouponType())) {
            dataBind.ivCouponType.setVisibility(View.GONE);
        }

        if ("1".equals(data.getClaimStatus())) {
            dataBind.ivClaimed.setVisibility(View.VISIBLE);
            dataBind.llRight.setBackground(mContext.getDrawable(R.drawable.bg_grey_coupon_right));
            dataBind.llLeft.setBackground(mContext.getDrawable(R.drawable.bg_grey_coupon_left));
            dataBind.tvReceive.setTextColor(mContext.getColor(R.color.xx_text_hint));
        } else {
            dataBind.ivClaimed.setVisibility(View.GONE);
            dataBind.llRight.setBackground(mContext.getDrawable(R.drawable.bg_coupon_right));
            dataBind.llLeft.setBackground(mContext.getDrawable(R.drawable.bg_coupon_left));
            dataBind.tvReceive.setTextColor(mContext.getColor(R.color.xx_text));
        }

        String time = data.getCouponStartTime() + " - " + data.getCouponEndTime();
        dataBind.tvTime.setText(time);

        if ("1".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("全场商品适用");
        } else if ("2".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("指定品类");
        } else if ("3".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("指定店铺");
        } else if ("4".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("指定商家");
        } else if ("5".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("指定商品");
        }

        dataBind.tvDesc1.setText("1、每人最多可领" + data.getClaimAmount() + "次");
        dataBind.tvDesc2.setText("2、订单满" + new BigDecimal(data.getOrderAmount()).stripTrailingZeros().toPlainString() + "减" + new BigDecimal(data.getDiscountAmount()).stripTrailingZeros().toPlainString());

        dataBind.tvMoreInfo.setOnClickListener(v -> {
            if (dataBind.llDetail.getVisibility() == View.GONE) {
                dataBind.llDetail.setVisibility(View.VISIBLE);
            } else {
                dataBind.llDetail.setVisibility(View.GONE);
            }
        });

        dataBind.ivMoreInfoIcon.setOnClickListener(v -> {
            if (dataBind.llDetail.getVisibility() == View.GONE) {
                dataBind.llDetail.setVisibility(View.VISIBLE);
                dataBind.ivMoreInfoIcon.setImageDrawable(mContext.getDrawable(R.mipmap.huodong_icon_zhankai));

            } else {
                dataBind.llDetail.setVisibility(View.GONE);
                dataBind.ivMoreInfoIcon.setImageDrawable(mContext.getDrawable(R.mipmap.huodong_icon_zhedie));
            }
        });
    }
}
