package com.xx.hbhconsumer.adapter;

import android.content.Context;
import android.view.View;

import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.respons.AvailableCoupon;
import com.xx.hbhconsumer.databinding.ItemAvailableCouponBinding;
import com.xx.hbhconsumer.ui.order.ChooseCouponDialog;
import com.xx.hbhconsumer.ui.order.OrderDetailViewModel;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import java.math.BigDecimal;

public class AvailableCouponAdapter extends xxBaseRecyclerViewAdapter<ItemAvailableCouponBinding, AvailableCoupon> {

    private ChooseCouponDialog dialog;
    private OrderDetailViewModel viewModel;
    public AvailableCouponAdapter(Context context, ChooseCouponDialog dialog, OrderDetailViewModel viewModel) {
        super(context);
        mContext = context;
        this.dialog = dialog;
        this.viewModel = viewModel;
    }

    @Override
    public int initLayout() {
        return R.layout.item_available_coupon;
    }

    @Override
    protected void covert(ItemAvailableCouponBinding dataBind, AvailableCoupon data, int position) {
        //   将接口调出来的布局遍历上去
        dataBind.setAvailableCoupon(data);
        dataBind.tvCouponName.setText(data.getCouponName());
        dataBind.tvDiscountAmount.setText("￥" + new BigDecimal(String.valueOf(data.getDiscountAmount())).stripTrailingZeros().toPlainString());
        String time = data.getCouponStartTime() + " - " + data.getCouponEndTime();
        dataBind.tvCouponDate.setText(time);
        if (data.getCheckStatus()) {
            dataBind.rbCheck.setChecked(true);
        } else {
            dataBind.rbCheck.setChecked(false);
            dataBind.rgCheck.clearCheck();
        }
        if ("1".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("全场商品适用");
        } else if ("2".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("指定品类");
        } else if ("3".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("指定店铺");
        } else if ("4".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("指定商家");
        } else if ("5".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("指定商品");
        }
        dataBind.rbCheck.setOnClickListener(view -> {
            dialog.check(!dataBind.rbCheck.isSelected(), position);
        });

        dataBind.tvUse.setOnClickListener(view -> {
            viewModel.confirmCoupon(data);
            dialog.dismiss();
        });
    }
}
