package com.xx.hbhconsumer.adapter;

import android.content.Context;
import android.view.View;

import com.bumptech.glide.Glide;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.respons.CollectionBean;
import com.xx.hbhconsumer.databinding.ItemCollectionGoodsBinding;
import com.xx.hbhconsumer.ui.mycollection.MyCollectionViewModel;
import com.xx.hbhconsumer.utils.RetrofitClient;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import me.goldze.mvvmhabit.utils.StringUtils;


public class CollectionGoodsAdapter extends xxBaseRecyclerViewAdapter<ItemCollectionGoodsBinding, CollectionBean> {

    private MyCollectionViewModel myCollectionViewModel;

    public CollectionGoodsAdapter(Context context, MyCollectionViewModel myCollectionViewModel) {
        super(context);
        mContext = context;
        this.myCollectionViewModel = myCollectionViewModel;
    }

    @Override
    public int initLayout() {
        return R.layout.item_collection_goods;
    }

    @Override
    protected void covert(ItemCollectionGoodsBinding dataBind, CollectionBean data, int position) {
        //   将接口调出来的布局遍历上去
        dataBind.setCollectionBean(data);

        Glide.with(mContext).load(RetrofitClient.baseImgUrl + data.getFilePath())
                .into(dataBind.ivGoodsImg);

        dataBind.tvGoodsName.setText(data.getCommodityName());

        if (data.getEditState()) {
            dataBind.radioSelectedGroup.setVisibility(View.VISIBLE);
        } else {
            dataBind.radioSelectedGroup.setVisibility(View.GONE);
        }

        if (data.getChecked()) {
            dataBind.rbCheckState.setChecked(true);
        } else {
            dataBind.radioSelectedGroup.clearCheck();
        }
        dataBind.rbCheckState.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (data.getChecked()) {
                    data.setChecked(false);
                    dataBind.radioSelectedGroup.clearCheck();
                } else {
                    data.setChecked(true);
                }
                myCollectionViewModel.checkItem();
            }
        });

//        dataBind.ivGoodsImg.setOnClickListener(new View.OnClickListener() {
//            @Override
//            public void onClick(View v) {
//                if (data.getChecked()) {
//                    data.setChecked(false);
//                    dataBind.radioSelectedGroup.clearCheck();
//                } else {
//                    data.setChecked(true);
//                }
//                myCollectionViewModel.checkItem();
//            }
//        });

        String price = data.getCommodityPrice();
        if (!StringUtils.isEmpty(price) && price.contains(".")) {
            dataBind.tvPriceInteger.setText(price.split("\\.")[0]);
            dataBind.tvPriceDecimal.setText("." + price.split("\\.")[1]);
        }
    }
}
