package com.xx.hbhconsumer.adapter;

import android.content.Context;
import android.view.View;

import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.respons.AvailableCouponBean;
import com.xx.hbhconsumer.data.http.respons.CouponBean;
import com.xx.hbhconsumer.databinding.ItemCouponBinding;
import com.xx.hbhconsumer.ui.order.OrderListViewModel;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import java.math.BigDecimal;

public class CouponAdapter extends xxBaseRecyclerViewAdapter<ItemCouponBinding, AvailableCouponBean> {
    OrderListViewModel viewModel;
    public CouponAdapter(Context context, OrderListViewModel viewModel) {
        super(context);
        mContext = context;
        this.viewModel = viewModel;
    }

    @Override
    public int initLayout() {
        return R.layout.item_coupon;
    }

    @Override
    protected void covert(ItemCouponBinding dataBind, AvailableCouponBean data, int position) {
        //   将接口调出来的布局遍历上去
        dataBind.setAvailableCouponBean(data);
        if ("1".equals(data.getCouponType())) {
            dataBind.tvDiscountAmount.setText("￥" + new BigDecimal(String.valueOf(data.getDiscountAmount())).stripTrailingZeros().toPlainString());
            dataBind.tvDesc2.setText("2、订单满" + new BigDecimal(data.getOrderAmount()).stripTrailingZeros().toPlainString() + "减" + new BigDecimal(data.getDiscountAmount()).stripTrailingZeros().toPlainString());
        } else {
            dataBind.tvDiscountAmount.setText("赠品");
            dataBind.tvDesc2.setText("2、订单满" + new BigDecimal(data.getOrderAmount()).stripTrailingZeros().toPlainString() + "，赠" + data.getGiftName());
        }
        dataBind.tvCouponName.setText(data.getCouponName());
        dataBind.tvDate.setText(data.getCouponStartTime() + "-" + data.getCouponEndTime());
        dataBind.tvMoreInfo.setOnClickListener(v -> {
            if (dataBind.llDetail.getVisibility() == View.GONE) {
                dataBind.llDetail.setVisibility(View.VISIBLE);
            } else {
                dataBind.llDetail.setVisibility(View.GONE);
            }
        });

        if ("1".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("全场商品适用");
        } else if ("2".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("指定品类");
        } else if ("3".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("指定店铺");
        } else if ("4".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("指定商家");
        } else if ("5".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("指定商品");
        }

        if (data.getClaimAmount() == 0) {
            dataBind.tvDesc1.setText("1、每人限领次数不限");
        } else {
            dataBind.tvDesc1.setText("1、每人最多可领" + data.getClaimAmount() + "次");
        }

        dataBind.ivMoreInfoIcon.setOnClickListener(v -> {
            if (dataBind.llDetail.getVisibility() == View.GONE) {
                dataBind.llDetail.setVisibility(View.VISIBLE);
                dataBind.ivMoreInfoIcon.setImageDrawable(mContext.getDrawable(R.mipmap.huodong_icon_zhankai));

            } else {
                dataBind.llDetail.setVisibility(View.GONE);
                dataBind.ivMoreInfoIcon.setImageDrawable(mContext.getDrawable(R.mipmap.huodong_icon_zhedie));
            }
        });

        dataBind.tvReceive.setOnClickListener(view -> {
            viewModel.getCoupon(data.getBusinessId());
        });
    }
}
