package com.xx.hbhconsumer.adapter;

import android.content.Context;
import android.view.View;

import com.bumptech.glide.Glide;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.respons.CreditOrderBean;
import com.xx.hbhconsumer.databinding.ItemCreditOrderBinding;
import com.xx.hbhconsumer.ui.creditorder.CollectGoodsDialog;
import com.xx.hbhconsumer.ui.creditorder.CreditOrderListViewModel;
import com.xx.hbhconsumer.utils.RetrofitClient;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;


public class CreditOrderAdapter extends xxBaseRecyclerViewAdapter<ItemCreditOrderBinding, CreditOrderBean> {

    private CreditOrderListViewModel viewModel;

    public CreditOrderAdapter(Context context, CreditOrderListViewModel viewModel) {
        super(context);
        mContext = context;
        this.viewModel = viewModel;
    }

    @Override
    public int initLayout() {
        return R.layout.item_credit_order;
    }

    @Override
    protected void covert(ItemCreditOrderBinding dataBind, CreditOrderBean data, int position) {

        dataBind.setOrderBean(data);

        Glide.with(mContext).load(RetrofitClient.baseImgUrl + data.getIntegralCommodityImageUrl().get(0))
                .into(dataBind.ivGoodsImg);

        if ("0".equals(data.getStatus())) {
            dataBind.tvOrderState.setText("已完成");
            dataBind.tvOrderState.setTextColor(mContext.getColor(R.color.order_state_blue));
            dataBind.tvReceiveState.setVisibility(View.VISIBLE);
            dataBind.rlButton.setVisibility(View.GONE);
        } else if ("1".equals(data.getStatus())) {
            dataBind.tvOrderState.setText("待领取");
            dataBind.tvOrderState.setTextColor(mContext.getColor(R.color.order_state_yellow));
            dataBind.tvReceiveState.setVisibility(View.GONE);
            dataBind.rlButton.setVisibility(View.VISIBLE);
        }

        dataBind.tvGoodsName.setText(data.getIntegralName());
        dataBind.tvCreditNum.setText(String.valueOf(data.getGoodsPoint()));
        dataBind.tvGoodsNum.setText("x" + data.getPointGoodsNum());
        dataBind.tvTotalCredit.setText(String.valueOf(data.getConsumptionPoints()));

        dataBind.tvCollectGoods.setOnClickListener(view -> {
            CollectGoodsDialog dialog = new CollectGoodsDialog(view.getContext(), data.getBusinessId(), data.getIntegralName());
            dialog.show();
        });

    }
}
