package com.xx.hbhconsumer.adapter;

import android.content.Context;

import com.bumptech.glide.Glide;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.respons.GoodsBean;
import com.xx.hbhconsumer.databinding.ItemGoodsBinding;
import com.xx.hbhconsumer.utils.RetrofitClient;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import me.goldze.mvvmhabit.utils.StringUtils;


public class GoodsAdapter extends xxBaseRecyclerViewAdapter<ItemGoodsBinding, GoodsBean> {

    public GoodsAdapter(Context context) {
        super(context);
        mContext = context;
    }

    @Override
    public int initLayout() {
        return R.layout.item_goods;
    }

    @Override
    protected void covert(ItemGoodsBinding dataBind, GoodsBean data, int position) {
        //   将接口调出来的布局遍历上去
        dataBind.setGoodsBean(data);

        Glide.with(mContext).load(RetrofitClient.baseImgUrl + data.getCommodityPictureFile().getFilePath())
                .into(dataBind.ivGoodsImg);
        dataBind.tvGoodsName.setText(data.getCommodityName());
        String price = String.valueOf(data.getCommodityPrice());
        if (!StringUtils.isEmpty(price) && price.contains(".")) {
            dataBind.tvPriceInteger.setText(price.split("\\.")[0]);
            dataBind.tvPriceDecimal.setText("." + price.split("\\.")[1]);
        }

    }
}
