package com.xx.hbhconsumer.adapter;

import android.content.Context;

import com.bumptech.glide.Glide;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.respons.HotSalesBean;
import com.xx.hbhconsumer.databinding.ItemHotSalesTop3GoodsBinding;
import com.xx.hbhconsumer.utils.RetrofitClient;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import me.goldze.mvvmhabit.utils.StringUtils;


public class HotSalesTop3GoodsAdapter extends xxBaseRecyclerViewAdapter<ItemHotSalesTop3GoodsBinding, HotSalesBean> {

    public HotSalesTop3GoodsAdapter(Context context) {
        super(context);
        mContext = context;
    }

    @Override
    public int initLayout() {
        return R.layout.item_hot_sales_top3_goods;
    }

    @Override
    protected void covert(ItemHotSalesTop3GoodsBinding dataBind, HotSalesBean data, int position) {
        //   将接口调出来的布局遍历上去
        dataBind.setHotSalesBean(data);

        Glide.with(mContext).load(RetrofitClient.baseImgUrl + data.getFilePath())
                .into(dataBind.ivGoodsImg);

        if (position == 0) {
            dataBind.ivGoodsSort.setImageDrawable(mContext.getDrawable(R.mipmap.rexiao_img_tag1));
        } else if (position == 1) {
            dataBind.ivGoodsSort.setImageDrawable(mContext.getDrawable(R.mipmap.rexiao_img_tag2));
        } else if (position == 2) {
            dataBind.ivGoodsSort.setImageDrawable(mContext.getDrawable(R.mipmap.rexiao_img_tag3));
        }
        dataBind.tvGoodsName.setText(data.getCommodityName());

        String price = data.getCommodityPrice();
        if (!StringUtils.isEmpty(price) && price.contains(".")) {
            dataBind.tvPriceInteger.setText(price.split("\\.")[0]);
            dataBind.tvPriceDecimal.setText("." + price.split("\\.")[1]);
        }
    }
}
