package com.xx.hbhconsumer.adapter;

import android.content.Context;
import android.view.View;

import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.respons.MyCouponBean;
import com.xx.hbhconsumer.databinding.ItemMyCouponBinding;
import com.xx.hbhconsumer.ui.mycoupon.MyCouponViewModel;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import java.math.BigDecimal;

public class MyCouponAdapter extends xxBaseRecyclerViewAdapter<ItemMyCouponBinding, MyCouponBean> {
    private MyCouponViewModel viewMode;
    public MyCouponAdapter(Context context, MyCouponViewModel viewModel) {
        super(context);
        mContext = context;
        this.viewMode = viewModel;
    }

    @Override
    public int initLayout() {
        return R.layout.item_my_coupon;
    }

    @Override
    protected void covert(ItemMyCouponBinding dataBind, MyCouponBean data, int position) {
        //   将接口调出来的布局遍历上去
        dataBind.setMyCouponBean(data);
        if (viewMode.couponState == 0) {
            dataBind.tvCouponNumber.setText("券编号：" + data.getCouponNumber());
            if (data.getClaimAmount() == null) {
                dataBind.tvDesc1.setText("1、每人限领次数不限");
            } else {
                dataBind.tvDesc1.setText("1、每人最多可领" + data.getClaimAmount() + "次");
            }

            dataBind.tvReceive.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    if ("2".equals(data.getCouponType())) {
                        viewMode.showGiftQrCode(v, data.getBusinessId(), data.getGiftName());
                    } else {
                        viewMode.goCouponGoods(data.getCouponId());
                    }
                }
            });
            dataBind.tvDesc1.setVisibility(View.VISIBLE);
            dataBind.tvDesc2.setVisibility(View.VISIBLE);
        } else {
            dataBind.tvDesc1.setVisibility(View.GONE);
            dataBind.tvDesc2.setVisibility(View.GONE);
            dataBind.tvReceive.setText("已使用");
            dataBind.tvReceive.setTextColor(mContext.getColor(R.color.xx_text_hint));
            dataBind.tvCouponNumber.setText("订单编号：" + data.getOrderNumber());
        }
        dataBind.tvCouponName.setText(data.getCouponName());

        if ("1".equals(data.getCouponType())) {
            dataBind.ivCouponType.setImageDrawable(mContext.getDrawable(R.mipmap.youhuiquan_tag_manjian));
            dataBind.tvCouponContent.setText(new BigDecimal(data.getDiscountAmount()).stripTrailingZeros().toPlainString());
            if (viewMode.couponState == 0) {
                dataBind.tvDesc2.setText("2、订单满" + new BigDecimal(data.getOrderAmount()).stripTrailingZeros().toPlainString() + "减" + new BigDecimal(data.getDiscountAmount()).stripTrailingZeros().toPlainString());
            } else {
                dataBind.tvDesc2.setVisibility(View.GONE);
            }
        } else if ("2".equals(data.getCouponType())) {
            dataBind.ivCouponType.setImageDrawable(mContext.getDrawable(R.mipmap.youhuiquan_tag_manzeng));
            dataBind.tvCouponContent.setText("赠品");
            if (viewMode.couponState == 0) {
                dataBind.tvDesc2.setText("2、订单满" + new BigDecimal(data.getOrderAmount()).stripTrailingZeros().toPlainString() + "赠" + data.getGiftName());
            } else {
                dataBind.tvDesc2.setVisibility(View.GONE);
            }
        }



        String time = data.getCouponStartTime() + " - " + data.getCouponEndTime();
        dataBind.tvTime.setText(time);

        if ("1".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("全场商品适用");
        } else if ("2".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("指定品类");
        } else if ("3".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("指定店铺");
        } else if ("4".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("指定商家");
        } else if ("5".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("指定商品");
        }




        dataBind.tvMoreInfo.setOnClickListener(v -> {
            if (dataBind.llDetail.getVisibility() == View.GONE) {
                dataBind.llDetail.setVisibility(View.VISIBLE);
            } else {
                dataBind.llDetail.setVisibility(View.GONE);
            }
        });

        dataBind.ivMoreInfoIcon.setOnClickListener(v -> {
            if (dataBind.llDetail.getVisibility() == View.GONE) {
                dataBind.llDetail.setVisibility(View.VISIBLE);
                dataBind.ivMoreInfoIcon.setImageDrawable(mContext.getDrawable(R.mipmap.huodong_icon_zhankai));

            } else {
                dataBind.llDetail.setVisibility(View.GONE);
                dataBind.ivMoreInfoIcon.setImageDrawable(mContext.getDrawable(R.mipmap.huodong_icon_zhedie));
            }
        });
    }
}
