package com.xx.hbhconsumer.adapter;

import android.content.Context;
import android.view.View;

import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.respons.UnavailableCoupon;
import com.xx.hbhconsumer.databinding.ItemNotAvailableCouponBinding;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import java.math.BigDecimal;

public class NotAvailableCouponAdapter extends xxBaseRecyclerViewAdapter<ItemNotAvailableCouponBinding, UnavailableCoupon> {
    public NotAvailableCouponAdapter(Context context) {
        super(context);
        mContext = context;
    }

    @Override
    public int initLayout() {
        return R.layout.item_not_available_coupon;
    }

    @Override
    protected void covert(ItemNotAvailableCouponBinding dataBind, UnavailableCoupon data, int position) {
        //   将接口调出来的布局遍历上去
        dataBind.setUnavailableCoupon(data);
        dataBind.tvCouponName.setText(data.getCouponName());
        String time = data.getCouponStartTime() + " - " + data.getCouponEndTime();
        dataBind.tvCouponDate.setText(time);
        dataBind.tvMoreInfo.setOnClickListener(v -> {
            if (dataBind.llDetail.getVisibility() == View.GONE) {
                dataBind.llDetail.setVisibility(View.VISIBLE);
            } else {
                dataBind.llDetail.setVisibility(View.GONE);
            }
        });
        dataBind.tvDiscountAmount.setText("￥" + new BigDecimal(String.valueOf(data.getDiscountAmount())).stripTrailingZeros().toPlainString());
        if ("1".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("全场商品适用");
        } else if ("2".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("指定品类");
        } else if ("3".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("指定店铺");
        } else if ("4".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("指定商家");
        } else if ("5".equals(data.getApplyCommodity())) {
            dataBind.tvLimitation.setText("指定商品");
        }
        dataBind.ivMoreInfoIcon.setOnClickListener(v -> {
            if (dataBind.llDetail.getVisibility() == View.GONE) {
                dataBind.llDetail.setVisibility(View.VISIBLE);
                dataBind.ivMoreInfoIcon.setImageDrawable(mContext.getDrawable(R.mipmap.huodong_icon_zhankai));

            } else {
                dataBind.llDetail.setVisibility(View.GONE);
                dataBind.ivMoreInfoIcon.setImageDrawable(mContext.getDrawable(R.mipmap.huodong_icon_zhedie));
            }
        });
    }
}
