package com.xx.hbhconsumer.adapter;

import android.content.Context;
import android.view.View;

import com.bumptech.glide.Glide;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.respons.CouponBean;
import com.xx.hbhconsumer.data.http.respons.OrderBean;
import com.xx.hbhconsumer.databinding.ItemOrderBinding;
import com.xx.hbhconsumer.ui.order.OrderListViewModel;
import com.xx.hbhconsumer.ui.order.ReceiveCouponDialog;
import com.xx.hbhconsumer.utils.RetrofitClient;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import me.goldze.mvvmhabit.utils.StringUtils;


public class OrderAdapter extends xxBaseRecyclerViewAdapter<ItemOrderBinding, OrderBean> {

    private OrderListViewModel viewModel;

    public OrderAdapter(Context context, OrderListViewModel viewModel) {
        super(context);
        mContext = context;
        this.viewModel = viewModel;
    }

    @Override
    public int initLayout() {
        return R.layout.item_order;
    }

    @Override
    protected void covert(ItemOrderBinding dataBind, OrderBean data, int position) {

        if (data.getCommodityList() != null && !data.getCommodityList().isEmpty() && data.getCommodityList().get(0).getCommodityPictureList() != null && !data.getCommodityList().get(0).getCommodityPictureList().isEmpty()) {
            Glide.with(mContext).load(RetrofitClient.baseImgUrl + data.getCommodityList().get(0).getCommodityPictureList().get(0).getFilePath())
                    .into(dataBind.ivGoodsImg);
        }

        Glide.with(mContext).load(RetrofitClient.baseImgUrl + data.getMerchant().getCompanyLogoFile().getFilePath())
                .into(dataBind.ivShopLogo);


        //   将接口调出来的布局遍历上去
        dataBind.setOrderBean(data);
        if ("2".equals(data.getOrderStatus())) {
            dataBind.tvCancelOrder.setVisibility(View.GONE);
            dataBind.tvPay.setVisibility(View.GONE);
            dataBind.tvOrderState.setText("已完成");

            boolean showReceiveFlag = true;
            String giftName = "";
            for (CouponBean couponBean : data.getCouponList()) {
                if ("2".equals(couponBean.getCouponType())) {
                    showReceiveFlag = false;
                    giftName = couponBean.getGiftName();
                }
            }
            dataBind.tvReceiveCoupon.setVisibility(View.GONE);

            if (showReceiveFlag) {
                dataBind.tvReceiveGiftCoupon.setVisibility(View.VISIBLE);
                dataBind.llGift.setVisibility(View.GONE);
            } else {
                dataBind.tvReceiveGiftCoupon.setVisibility(View.GONE);
                dataBind.llGift.setVisibility(View.VISIBLE);
                dataBind.tvGift.setText("赠品：" + giftName);
            }


        } else if ("1".equals(data.getOrderStatus())) {
            dataBind.tvCancelOrder.setVisibility(View.VISIBLE);
            dataBind.tvPay.setVisibility(View.VISIBLE);
            dataBind.tvReceiveCoupon.setVisibility(View.VISIBLE);
            dataBind.llGift.setVisibility(View.GONE);
            dataBind.tvOrderState.setText("待付款");
            dataBind.tvReceiveGiftCoupon.setVisibility(View.GONE);

        } else if ("3".equals(data.getOrderStatus())) {
            dataBind.tvCancelOrder.setVisibility(View.GONE);
            dataBind.tvPay.setVisibility(View.GONE);
            dataBind.tvReceiveCoupon.setVisibility(View.GONE);
            dataBind.llGift.setVisibility(View.GONE);
            dataBind.tvOrderState.setText("交易关闭");
            dataBind.tvOrderState.setTextColor(mContext.getColor(R.color.xx_text_hint));
            dataBind.tvReceiveGiftCoupon.setVisibility(View.GONE);
        }

        dataBind.tvShopName.setText(data.getMerchant().getStoreName());
        dataBind.tvGoodsNum.setText("x" + data.getCommodityList().get(0).getCommodityQuantity());
        dataBind.tvGoodsName.setText(data.getCommodityList().get(0).getCommodityName());

        String price = data.getCommodityList().get(0).getPrice();
        if (!StringUtils.isEmpty(price) && price.contains(".")) {
            dataBind.tvPriceInteger.setText(price.split("\\.")[0]);
            dataBind.tvPriceDecimal.setText("." + price.split("\\.")[1]);
        }
        String actualPayment = String.valueOf(data.getOrderAmount());
        if (!StringUtils.isEmpty(actualPayment) && actualPayment.contains(".")) {
            dataBind.tvPayPriceInteger.setText(actualPayment.split("\\.")[0]);
            dataBind.tvPayPriceDecimal.setText("." + actualPayment.split("\\.")[1]);
        }

        dataBind.tvReceiveCoupon.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                viewModel.getAvailableCoupon(v.getContext(), "1", data.getBusinessId());

            }
        });

        dataBind.tvReceiveGiftCoupon.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                viewModel.getAvailableCoupon(v.getContext(), "2", data.getBusinessId());

            }
        });
    }
}
