package com.xx.hbhconsumer.adapter;

import android.content.Context;
import android.view.View;

import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.respons.DictValueBean;
import com.xx.hbhconsumer.data.http.respons.OrderBean;
import com.xx.hbhconsumer.data.http.respons.RecruitBean;
import com.xx.hbhconsumer.databinding.ItemNewsBinding;
import com.xx.hbhconsumer.databinding.ItemRecruitBinding;
import com.xx.hbhconsumer.ui.recruit.RecruitListViewModel;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class RecruitAdapter extends xxBaseRecyclerViewAdapter<ItemRecruitBinding, RecruitBean> {
    private Map<String, String> map = new HashMap<>();
    RecruitListViewModel viewModel;
    public RecruitAdapter(Context context, RecruitListViewModel viewModel) {
        super(context);
        mContext = context;
        this.viewModel = viewModel;
    }

    @Override
    public int initLayout() {
        return R.layout.item_recruit;
    }

    @Override
    protected void covert(ItemRecruitBinding dataBind, RecruitBean data, int position) {
        List<DictValueBean> list = viewModel.dictValueBeanList.getValue();
        for (DictValueBean dictValueBean : list) {
            map.put(dictValueBean.getDictValue(), dictValueBean.getDictLabel());
        }
        //   将接口调出来的布局遍历上去
        dataBind.setRecruitBean(data);
        dataBind.tvRecruitTitle.setText(data.getPostName());
        dataBind.tvAddress.setText(map.get(data.getWorkPlace()));
        // 1-内部招聘 2-商户招聘
        if ("1".equals(data.getRecruitmentType())) {
            dataBind.tvShopName.setVisibility(View.GONE);
            dataBind.tvEducation.setVisibility(View.VISIBLE);
            dataBind.tvExperience.setVisibility(View.VISIBLE);
        } else {
            dataBind.tvShopName.setText(data.getRecruitmentEnterprise());
            dataBind.tvShopName.setVisibility(View.VISIBLE);
            dataBind.tvEducation.setVisibility(View.GONE);
            dataBind.tvExperience.setVisibility(View.GONE);
        }

        if ("1".equals(data.getEducationalRequirement())) {
            dataBind.tvEducation.setText("学历：硕士及以上");
        } else if ("2".equals(data.getEducationalRequirement())) {
            dataBind.tvEducation.setText("学历：本科及以上");
        } else if ("3".equals(data.getEducationalRequirement())) {
            dataBind.tvEducation.setText("学历：专科及以上");
        } else if ("4".equals(data.getEducationalRequirement())) {
            dataBind.tvEducation.setText("学历：高中及以上");
        } else if ("5".equals(data.getEducationalRequirement())) {
            dataBind.tvEducation.setText("学历：初中及以上");
        } else if ("6".equals(data.getEducationalRequirement())) {
            dataBind.tvEducation.setText("学历：无");
        }


        if ("1".equals(data.getWorkExperience())) {
            dataBind.tvExperience.setText("经验：1年");
        } else if ("2".equals(data.getWorkExperience())) {
            dataBind.tvExperience.setText("经验：1-3年");
        } else if ("3".equals(data.getWorkExperience())) {
            dataBind.tvExperience.setText("经验：3-5年");
        } else if ("4".equals(data.getWorkExperience())) {
            dataBind.tvExperience.setText("经验：5-7年");
        } else if ("5".equals(data.getWorkExperience())) {
            dataBind.tvExperience.setText("经验：7-10年");
        } else if ("6".equals(data.getWorkExperience())) {
            dataBind.tvExperience.setText("经验：10年以上");
        } else if ("7".equals(data.getWorkExperience())) {
            dataBind.tvExperience.setText("经验：无");
        }

        dataBind.tvSalary.setText(data.getPostWage());
    }
}
