package com.xx.hbhconsumer.adapter;

import android.content.Context;

import com.bumptech.glide.Glide;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.respons.OrderBean;
import com.xx.hbhconsumer.data.http.respons.SearchGoodsBean;
import com.xx.hbhconsumer.databinding.ItemSearchGoodsBinding;
import com.xx.hbhconsumer.databinding.ItemSearchShopGoodsBinding;
import com.xx.hbhconsumer.utils.RetrofitClient;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import me.goldze.mvvmhabit.utils.StringUtils;


public class SearchGoodsAdapter extends xxBaseRecyclerViewAdapter<ItemSearchGoodsBinding, SearchGoodsBean> {

    public SearchGoodsAdapter(Context context) {
        super(context);
        mContext = context;
    }

    @Override
    public int initLayout() {
        return R.layout.item_search_goods;
    }

    @Override
    protected void covert(ItemSearchGoodsBinding dataBind, SearchGoodsBean data, int position) {
        //   将接口调出来的布局遍历上去
        dataBind.setSearchGoodsBean(data);

        Glide.with(mContext).load(RetrofitClient.baseImgUrl + data.getCommodityPictureFile().getFilePath())
                .into(dataBind.ivGoodsImg);
        dataBind.tvGoodsName.setText(data.getCommodityName());
        String price = String.valueOf(data.getCommodityPrice());
        if (!StringUtils.isEmpty(price) && price.contains(".")) {
            dataBind.tvPriceInteger.setText(price.split("\\.")[0]);
            dataBind.tvPriceDecimal.setText("." + price.split("\\.")[1]);
        }
    }
}
