package com.xx.hbhconsumer.adapter;

import android.content.Context;
import android.view.View;

import androidx.recyclerview.widget.LinearLayoutManager;

import com.bumptech.glide.Glide;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.respons.Commodity;
import com.xx.hbhconsumer.data.http.respons.OrderBean;
import com.xx.hbhconsumer.data.http.respons.SearchShopBean;
import com.xx.hbhconsumer.data.http.respons.ShopAndGoodsBean;
import com.xx.hbhconsumer.databinding.ItemOrderBinding;
import com.xx.hbhconsumer.databinding.ItemSearchShopBinding;
import com.xx.hbhconsumer.ui.search.SearchViewModel;
import com.xx.hbhconsumer.utils.RetrofitClient;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import java.util.ArrayList;
import java.util.List;


public class SearchShopAdapter extends xxBaseRecyclerViewAdapter<ItemSearchShopBinding, SearchShopBean> {

    private SearchViewModel searchViewModel;

    public SearchShopAdapter(Context context, SearchViewModel searchViewModel) {
        super(context);
        mContext = context;
        this.searchViewModel = searchViewModel;
    }

    @Override
    public int initLayout() {
        return R.layout.item_search_shop;
    }

    @Override
    protected void covert(ItemSearchShopBinding dataBind, SearchShopBean data, int position) {
        //   将接口调出来的布局遍历上去
        dataBind.setSearchShopBean(data);
        if (data.getLogoFile() != null) {
            Glide.with(mContext)
                    .load(RetrofitClient.baseImgUrl + data.getLogoFile().getFilePath())
                    .into(dataBind.ivShopLogo);
        }

        dataBind.tvShopName.setText(data.getStoreName());
        dataBind.rbLevel.setRating(Float.parseFloat(String.valueOf(data.getRating())));
        dataBind.rvGoodsList.setNestedScrollingEnabled(false);

        if (data.getCommodityList() == null || data.getCommodityList().isEmpty()) {
            dataBind.rvGoodsList.setVisibility(View.GONE);
            dataBind.rlNoData.setVisibility(View.VISIBLE);
        } else {
            dataBind.rvGoodsList.setVisibility(View.VISIBLE);
            dataBind.rlNoData.setVisibility(View.GONE);
        }

        //获取适配器上下文
        SearchShopGoodsAdapter orderListAdapter = new SearchShopGoodsAdapter(mContext);
        //把adapterset进去
        dataBind.rvGoodsList.setAdapter(orderListAdapter);
        orderListAdapter.mList = data.getCommodityList();
        orderListAdapter.notifyDataSetChanged();
//        orderListAdapter.setOnItemClick(new OnItemClick<Commodity>() {
//            @Override
//            public void itemClickCalBack(int position, Commodity data) {
//                searchViewModel.goGoodsDetail(data.get);
//            }
//        });
    }
}
