package com.xx.hbhconsumer.adapter

import android.content.Context
import android.graphics.Bitmap
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.bumptech.glide.Glide
import com.bumptech.glide.request.target.Target
import com.xx.hbhconsumer.R
import com.xx.hbhconsumer.data.http.respons.AdvertisingBean
import com.xx.hbhconsumer.data.http.respons.ShopBean
import com.xx.hbhconsumer.databinding.ItemBannerBinding
import com.xx.hbhconsumer.databinding.ItemShopBannerBinding
import com.xx.hbhconsumer.utils.RetrofitClient
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewViewHolder
import com.youth.banner.adapter.BannerAdapter

/**
 * banner 适配器械
 */
class ShopBannerAdapter(val context:Context, list:List<ShopBean> ) :
    BannerAdapter<ShopBean, xxBaseRecyclerViewViewHolder<ItemShopBannerBinding>>(list) {

    override fun onCreateHolder(
        parent: ViewGroup?,
        viewType: Int
    ): xxBaseRecyclerViewViewHolder<ItemShopBannerBinding> {
        var view:View=LayoutInflater.from(parent?.context).inflate(R.layout.item_shop_banner,parent,false)
       return xxBaseRecyclerViewViewHolder(parent?.context,view)
    }

    override fun onBindView(
        holder: xxBaseRecyclerViewViewHolder<ItemShopBannerBinding>?,
        data: ShopBean?,
        position: Int,
        size: Int
    ) {
        holder?.dataBind?.tvSlogan?.setText(data?.propaganda)
        holder?.dataBind?.tvShopName?.setText(data?.storeName)
        if (data?.coverImage != null) {
            holder?.dataBind?.imgBanner?.let {
                Glide.with(context).load(RetrofitClient.baseImgUrl + data?.coverImage)
                    .into(it)
            }
        }


    }
}
