package com.xx.hbhconsumer.adapter;

import android.content.Context;

import com.bumptech.glide.Glide;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.respons.OrderBean;
import com.xx.hbhconsumer.data.http.respons.ShopAndGoodsBean;
import com.xx.hbhconsumer.databinding.ItemShopBinding;
import com.xx.hbhconsumer.databinding.ItemShopGoodsBinding;
import com.xx.hbhconsumer.utils.RetrofitClient;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import me.goldze.mvvmhabit.utils.StringUtils;

public class ShopGoodsAdapter extends xxBaseRecyclerViewAdapter<ItemShopGoodsBinding, ShopAndGoodsBean.CommodityListDTO> {
    public ShopGoodsAdapter(Context context) {
        super(context);
        mContext = context;
    }

    @Override
    public int initLayout() {
        return R.layout.item_shop_goods;
    }

    @Override
    protected void covert(ItemShopGoodsBinding dataBind, ShopAndGoodsBean.CommodityListDTO data, int position) {
        //   将接口调出来的布局遍历上去
        dataBind.setCommodityListDTO(data);
        String price = data.getCommodityPrice();
        if (!StringUtils.isEmpty(price) && price.contains(".")) {
            dataBind.tvPriceInteger.setText(price.split("\\.")[0]);
            dataBind.tvPriceDecimal.setText("." + price.split("\\.")[1]);
        }


        if (data.getCoverImage() != null) {
            Glide.with(mContext)
                    .load(RetrofitClient.baseImgUrl + data.getCoverImage())
                    .into(dataBind.ivGoodsImg);
        }
    }
}
