package com.xx.hbhconsumer.data.http

import com.xx.hbhconsumer.data.http.respons.ActivityCenterBean
import com.xx.hbhconsumer.data.http.respons.ActivityCouponBean
import com.xx.hbhconsumer.data.http.respons.AdvertisingBean
import com.xx.hbhconsumer.data.http.respons.AppInformationBean
import com.xx.hbhconsumer.data.http.respons.AppVersionBean
import com.xx.hbhconsumer.data.http.respons.AvailableCouponBean
import com.xx.hbhconsumer.data.http.respons.BoothBean
import com.xx.hbhconsumer.data.http.respons.CategoryBean
import com.xx.hbhconsumer.data.http.respons.ClaimedCoupon
import com.xx.hbhconsumer.data.http.respons.CollectionBean
import com.xx.hbhconsumer.data.http.respons.CouponGoodsBean
import com.xx.hbhconsumer.data.http.respons.CreditDetailBean
import com.xx.hbhconsumer.data.http.respons.CreditGoodsBean
import com.xx.hbhconsumer.data.http.respons.CreditGoodsDetailBean
import com.xx.hbhconsumer.data.http.respons.CreditOrderBean
import com.xx.hbhconsumer.data.http.respons.CreditRecordBean
import com.xx.hbhconsumer.data.http.respons.DictValueBean
import com.xx.hbhconsumer.data.http.respons.Filebean
import com.xx.hbhconsumer.data.http.respons.GoodsBean
import com.xx.hbhconsumer.data.http.respons.GoodsDetailBean
import com.xx.hbhconsumer.data.http.respons.GuessLikeGoodsBean
import com.xx.hbhconsumer.data.http.respons.HomeActivityBean
import com.xx.hbhconsumer.data.http.respons.HotSalesBean
import com.xx.hbhconsumer.data.http.respons.LowPriceGoodsBean
import com.xx.hbhconsumer.data.http.respons.MemberInfoBean
import com.xx.hbhconsumer.data.http.respons.MerchantBean
import com.xx.hbhconsumer.data.http.respons.MessageBean
import com.xx.hbhconsumer.data.http.respons.MyCouponBean
import com.xx.hbhconsumer.data.http.respons.NewCommodityBean
import com.xx.hbhconsumer.data.http.respons.OrderBean
import com.xx.hbhconsumer.data.http.respons.ParkBean
import com.xx.hbhconsumer.data.http.respons.RecruitBean
import com.xx.hbhconsumer.data.http.respons.RegisterBean
import com.xx.hbhconsumer.data.http.respons.SearchGoodsBean
import com.xx.hbhconsumer.data.http.respons.SearchShopBean
import com.xx.hbhconsumer.data.http.respons.ShopAndGoodsBean
import com.xx.hbhconsumer.data.http.respons.ShopBean
import com.xx.hbhconsumer.data.http.respons.ShopDetailBean
import com.xx.hbhconsumer.data.http.respons.ShopGoodsBean
import com.xx.hbhconsumer.data.http.respons.UserInfoBean
import com.xx.hbhconsumer.data.http.respons.VersionBean
import io.reactivex.rxjava3.core.Observable
import me.goldze.mvvmhabit.http.BasePageResponse
import me.goldze.mvvmhabit.http.BaseResponse
import okhttp3.MultipartBody
import okhttp3.RequestBody
import okhttp3.ResponseBody
import retrofit2.Call
import retrofit2.http.Body
import retrofit2.http.DELETE
import retrofit2.http.GET
import retrofit2.http.Headers
import retrofit2.http.Multipart
import retrofit2.http.POST
import retrofit2.http.PUT
import retrofit2.http.Part
import retrofit2.http.Path
import retrofit2.http.Query
import retrofit2.http.Streaming
import retrofit2.http.Url


interface ApiService {
    /**
     * 获取版本
     */
    @Headers("Content-type:application/json")
    @POST("app/system/version/current")
    open fun getLineVersion(@Body requestBody: RequestBody): Observable<BaseResponse<VersionBean>>

    /**
     * 获取车辆列表
     */
    @Headers("Content-type:application/json")
    @GET("carInfo/list")
    open fun getParkList(): Observable<BaseResponse<List<ParkBean>>>

    /**
     * 删除车辆信息
     */
    @Headers("Content-type:application/json")
    @DELETE("carInfo/deleteLogical/{businessId}")
    open fun deletePark(
        @Path("businessId") id: String
    ): Observable<BaseResponse<Boolean>>

    /**
     * 提交停车信息
     */
    @Headers("Content-type:application/json")
    @POST("carInfo/add")
    fun postParkMsg(@Body requestBody: RequestBody): Observable<BaseResponse<Boolean>>
    /**
     * 下载文件
     *
     * @param url
     * @return
     */
    @Streaming
    @GET
    fun download(@Url url: String?): Observable<ResponseBody>

    /**
     * 根据字典类型查询字典数据信息
     * @param dictType 字典类型
     * @return 字典列表
     */
    @Headers("Content-type:application/json")
    @GET("system/dict/data/type/{dictType}")
    fun getDictValueByDictType(@Path("dictType") dictType: String): Observable<BaseResponse<List<DictValueBean>>>

    @Streaming
    @GET
    fun downloadFileWithUrlSync(@Url url: String?): Call<ResponseBody?>?

    /**
     * 验证是否注册
     */
    @Headers("Content-type:application/json")
    @POST("app/user/check-phone")
    fun checkRegister(@Body requestBody: RequestBody): Observable<BaseResponse<Boolean>>


    /**
     * 登陆
     */
    @Headers("Content-type:application/json")
    @GET("app/agreement/{basic}")
    open fun agreement(@Path(value="basic") basic: String): Observable<BaseResponse<String>>

    /**
     * 登陆
     */
    @Headers("Content-type:application/json")
    @POST("app/agreement/getStaticPageList")
    open fun getStaticPageList(@Body requestBody: RequestBody): Observable<BaseResponse<List<String>>>



    /**
     * 登陆
     */
    @Headers("Content-type:application/json")
    @POST("app/user/login")
    open fun Login(@Body requestBody: RequestBody): Observable<BaseResponse<String>>
    /**
     * 修改密码
     */
    @Headers("Content-type:application/json")
    @POST("app/user/update-password")
    open fun ChangePwd(@Body requestBody: RequestBody): Observable<BaseResponse<String>>
    /**
     * 忘记密码
     */
    @Headers("Content-type:application/json")
    @POST("app/user/forget-password")
    open fun ForegetPwd(@Body requestBody: RequestBody): Observable<BaseResponse<String>>

    /**
     * 获取验证码
     */
    @Headers("Content-type:application/json")
    @GET("app/user/send-verification-code")
    open fun getCode(@Query("phone") phone: String): Observable<BaseResponse<String>>

    /**
     * 更改手机号
     */
    @Headers("Content-type:application/json")
    @POST("app/user/update-phone")
    open fun changePhone(@Body requestBody: RequestBody): Observable<BaseResponse<String>>

    /**
     * 更改手机号
     */
    @Headers("Content-type:application/json")
    @PUT("app/user/update-user")
    open fun updateUser(@Body requestBody: RequestBody): Observable<BaseResponse<String>>

    /**
     * 注册
     */
    @Headers("Content-type:application/json")
    @POST("app/user/register")
    open fun register(@Body requestBody: RequestBody): Observable<BaseResponse<RegisterBean>>


    /**
     * 获取用户信息
     */
    @Headers("Content-type:application/json")
    @GET("app/getInfo")
    open fun getUserInfo(): Observable<BaseResponse<UserInfoBean>>

    /**
     * 获取协议
     * 旧接口:app/agreement/getBasicList
     * 新接口:app/agreement/getStaticPageList
     */
    @Headers("Content-type:application/json")
    @POST("app/agreement/getStaticPageList")
    open fun getProtocols(@Body requestBody: RequestBody): Observable<BaseResponse<List<String>>>


    /**
     * 获取展位管理列表
     * status:状态 0启用 1停用
     * affiliatedCompany:所属公司
     */
    @Headers("Content-type:application/json")
    @GET("app/booth/list-all")
    open fun getBoothList(
        @Query("status") status: String,
        @Query("affiliatedCompany") affiliatedCompany: String
    ): Observable<BaseResponse<List<BoothBean>>>

    /**
     * 上传
     */
    @Multipart
    @Headers("clientType:fy_authority")
    @POST("common/upload")
    fun upLoadFile(@Part file: MultipartBody.Part): Observable<BaseResponse<Filebean>>

    /**
     * 上传
     */
    @Multipart
    @Headers("clientType:fy_authority")
    @POST("common/uploads")
    fun upLoadFiles(@Part file: List<MultipartBody.Part>): Observable<BaseResponse<List<Filebean>>>

    /**
     * APP广告位查询
     */
    @Headers("Content-type:application/json")
    @GET("app/message/getMessageList")
    fun getMessageList(@Query("flag") flag: Int, @Query("pageNum") num: Int): Observable<BasePageResponse<MessageBean>>
    /**
     * APP广告位查询
     */
    @Headers("Content-type:application/json")
    @PUT("app/message/unread")
    fun messageUnread(@Body requestBody: RequestBody): Observable<BaseResponse<Integer>>

    /**
     * APP广告位查询
     */
    @Headers("Content-type:application/json")
    @POST("app/message/editAllUnread")
    fun messageAllRead(): Observable<BaseResponse<Integer>>

    /**
     * APP广告位查询
     */
    @Headers("Content-type:application/json")
    @POST("app/adList/list")
    fun postADList(@Body requestBody: RequestBody): Observable<BaseResponse<List<AdvertisingBean>>>

    /**
     * APP广告位查询
     */
    @Headers("Content-type:application/json")
    @GET("app/recommend/lowPrice/{affiliatedCompany}")
    fun lowPriceList(@Path(value="affiliatedCompany") affiliatedCompany: String, @Query("pageNum") num: Int): Observable<BasePageResponse<LowPriceGoodsBean>>

    /**
     * APP广告位查询
     */
    @Headers("Content-type:application/json")
    @GET("app/recommend/like/{affiliatedCompany}")
    fun guessLikeGood(@Path(value="affiliatedCompany") affiliatedCompany: String): Observable<BaseResponse<List<GuessLikeGoodsBean>>>

    /**
     * 获取商户管理详细信息
     */
    @Headers("Content-type:application/json")
    @GET("app/storeRecommend/storeTop/{affiliatedCompany}")
    fun getTopShop(@Path("affiliatedCompany") affiliatedCompany:String?): Observable<BaseResponse<ShopBean>>

    /**
     * 获取商户管理详细信息
     */
    @Headers("Content-type:application/json")
    @POST("app/commodity/category-tree")
    fun getCategoryTree(@Body requestBody: RequestBody): Observable<BaseResponse<List<CategoryBean>>>

    /**
     * 获取商户管理详细信息
     */
    @Headers("Content-type:application/json")
    @GET("app/storeRecommend/story/{affiliatedCompany}")
    fun getTopShopList(@Path("affiliatedCompany") affiliatedCompany:String?): Observable<BaseResponse<List<ShopBean>>>

    @Headers("Content-type:application/json")
    @GET("app/storeRecommend/winnow/{affiliatedCompany}")
    fun getShopList(@Path("affiliatedCompany") affiliatedCompany:String?): Observable<BaseResponse<List<ShopAndGoodsBean>>>


    @Headers("Content-type:application/json")
    @POST("app/commodity/consumer-app/merchant-commodity")
    fun getShopGoodsList(@Body requestBody: RequestBody): Observable<BasePageResponse<ShopGoodsBean>>

    @Headers("Content-type:application/json")
    @GET("app/commodity/consumer-app/six-commodity")
    fun getSixCommodity(@Query("merchantId") merchantId:String?): Observable<BaseResponse<List<ShopGoodsBean>>>

    @Headers("Content-type:application/json")
    @GET("app/merchant/{businessId}")
    fun getShopDetail(@Path("businessId") businessId:String?): Observable<BaseResponse<ShopDetailBean>>

    @Headers("Content-type:application/json")
    @POST("app/commodity/consumer-app/list-by-category")
    fun listShopGoodsByCategory(@Body requestBody: RequestBody, @Query("pageNum") num: Int): Observable<BasePageResponse<GoodsBean>>

    @Headers("Content-type:application/json")
    @GET("app/commodity/consumer-app/detail/{businessId}")
    fun queryGoodsDetail(@Path("businessId") id:String?): Observable<BaseResponse<GoodsDetailBean>>

    @Headers("Content-type:application/json")
    @POST("app/commodity/consumer-app/list")
    fun searchGoods(@Body requestBody: RequestBody): Observable<BasePageResponse<SearchGoodsBean>>

    @Headers("Content-type:application/json")
    @GET("app/merchant/get-merchant-of-consumer-app")
    fun searchShop(@Query("searchWord") searchWord:String?, @Query("affiliatedCompany") affiliatedCompany: String?): Observable<BasePageResponse<SearchShopBean>>


    @Headers("Content-type:application/json")
    @POST("app/merchant/get-merchant-of-consumer-app")
    fun searchMerchant(@Body requestBody: RequestBody): Observable<BasePageResponse<SearchShopBean>>

    /**
     * 获取商户管理详细信息
     */
    @Headers("Content-type:application/json")
    @GET("app/merchant/{businessId}")
    fun getMerchantById(@Path("businessId") id:String?): Observable<BaseResponse<MerchantBean>>


    /**
     * 获取三级分类
     */
    @Headers("Content-type:application/json")
    @POST("app/commodity/category-tree")
    fun postCategory(@Body requestBody: RequestBody): Observable<BaseResponse<List<CategoryBean>>>


    /**
     * 新增商品
     */
    @Headers("Content-type:application/json")
    @POST("app/commodity/merchant-app/add")
    fun postAddProduct(@Body requestBody: RequestBody): Observable<BaseResponse<Boolean>>

    @Headers("Content-type:application/json")
    @GET("app/MemberCollection/list")
    fun memberCollectionList(): Observable<BasePageResponse<CollectionBean>>

    @Headers("Content-type:application/json")
    @POST("app/MemberCollection")
    fun memberCollection(@Body requestBody: RequestBody): Observable<BaseResponse<String>>

    @Headers("Content-type:application/json")
    @DELETE("app/MemberCollection/cancelCollect/{businessIds}")
    fun cancelCollection(@Path("businessIds") businessIds: String): Observable<BaseResponse<Integer>>

    @Headers("Content-type:application/json")
    @GET("app/myHome/list")
    fun memberInfo(): Observable<BaseResponse<MemberInfoBean>>

    @Headers("Content-type:application/json")
    @GET("app/memberSign/{companyId}")
    fun memberSign(@Path("companyId") companyId: String):  Observable<BaseResponse<Boolean>>

    @Headers("Content-type:application/json")
    @GET("app/recommend/newCommodity/{affiliatedCompany}")
    fun newCommodity(@Path("affiliatedCompany") affiliatedCompany: String, @Query("pageNum") num: Int):  Observable<BasePageResponse<NewCommodityBean>>

    @Headers("Content-type:application/json")
    @GET("app/recommend/sale/{affiliatedCompany}")
    fun hotSales(@Path("affiliatedCompany") affiliatedCompany: String, @Query("pageNum") num: Int):  Observable<BasePageResponse<HotSalesBean>>

    @Headers("Content-type:application/json")
    @GET("app/order/consumer-app/list")
    fun getOrderList(@Query("orderStatus") orderStatus: String, @Query("pageNum") num: Int):  Observable<BasePageResponse<OrderBean>>

    @Headers("Content-type:application/json")
    @GET("app/order/consumer-app/order-info/{businessId}")
    fun getOrderDetail(@Path("businessId") businessId: String):  Observable<BaseResponse<OrderBean>>

    @Headers("Content-type:application/json")
    @PUT("app/order/consumer-app/close/{businessId}")
    fun closeOrder(@Path("businessId") businessId: String):  Observable<BaseResponse<Boolean>>

    @Headers("Content-type:application/json")
    @PUT("app/information/addView")
    fun addView(@Body requestBody: RequestBody):  Observable<BaseResponse<String>>


    @Headers("Content-type:application/json")
    @POST("app/order/consumer-app/claimed-coupon")
    fun getClaimedCoupon(@Body requestBody: RequestBody):  Observable<BaseResponse<ClaimedCoupon>>


    @Headers("Content-type:application/json")
    @GET("app/myCoupon/listUse")
    fun getUsedCouponList(@Query("pageNum") num: Int):  Observable<BasePageResponse<MyCouponBean>>

    @Headers("Content-type:application/json")
    @GET("app/myCoupon/listUnUse")
    fun getUnUsedCouponList(@Query("pageNum") num: Int):  Observable<BasePageResponse<MyCouponBean>>

    @Headers("Content-type:application/json")
    @GET("app/pointExchange/list")
    fun getCreditOrderList(@Query("status") status: String, @Query("pageNum") num: Int):  Observable<BasePageResponse<CreditOrderBean>>

    @Headers("Content-type:application/json")
    @GET("app/pointExchange/{businessId}")
    fun getCreditOrderDetail(@Path("businessId") businessId: String):  Observable<BaseResponse<CreditOrderBean>>


    @Headers("Content-type:application/json")
    @GET("app/getCoupon/getCouponAppList")
    fun getCouponAppList(@Query("pageNum") num: Int): Observable<BasePageResponse<ActivityCouponBean>>

    @Headers("Content-type:application/json")
    @GET("app/getCoupon/{businessId}")
    fun getCoupon(@Path("businessId") businessId: String):  Observable<BaseResponse<Int>>

    @Headers("Content-type:application/json")
    @GET("app/myPoint/pointCommodity/list")
    fun getCreditGoodsList():  Observable<BasePageResponse<CreditGoodsBean>>

    @Headers("Content-type:application/json")
    @POST("app/myPoint/IntegralScheduleList")
    fun getCreditRecordList(@Body requestBody: RequestBody, @Query("pageNum") num: Int):  Observable<BasePageResponse<CreditRecordBean>>

    @Headers("Content-type:application/json")
    @GET("app/myPoint/getMyPoint")
    fun getMyPoint():  Observable<BaseResponse<CreditDetailBean>>

    @Headers("Content-type:application/json")
    @GET("app/pointExchange/pointCommodity/list")
    fun getAllCreditGoodsList(@Query("pageNum") num: Int):  Observable<BasePageResponse<CreditGoodsBean>>

    @Headers("Content-type:application/json")
    @GET("app/pointExchange/pointCommodity/listTop")
    fun getTopCreditGoodsList():  Observable<BasePageResponse<CreditGoodsBean>>

    @Headers("Content-type:application/json")
    @GET("app/pointExchange/getIntegralCommodity/{businessId}")
    fun getCreditGoodsDetail(@Path("businessId") businessId: String):  Observable<BaseResponse<CreditGoodsDetailBean>>


    @Headers("Content-type:application/json")
    @POST("app/pointExchange/addPointOrder")
    fun creditExchange(@Body requestBody: RequestBody):  Observable<BaseResponse<Int>>

    @Headers("Content-type:application/json")
    @POST("app/recruitment/queryAppRecruitmentList")
    fun queryAppRecruitmentList(@Body requestBody: RequestBody):  Observable<BasePageResponse<RecruitBean>>
    @Headers("Content-type:application/json")
    @GET("app/recruitment/{businessId}")
    fun queryAppRecruitmentDetail(@Path("businessId") businessId: String):  Observable<BaseResponse<RecruitBean>>

    @Headers("Content-type:application/json")
    @POST("app/recruitment/add")
    fun recruitment(@Body requestBody: RequestBody):  Observable<BaseResponse<Integer>>


    @Headers("Content-type:application/json")
    @POST("app/information/queryAppInformationList")
    fun queryAppInformationList(@Body requestBody: RequestBody):  Observable<BaseResponse<List<AppInformationBean>>>

    @Headers("Content-type:application/json")
    @POST("app/information/getAppInformationList")
    fun getAppInformationList(@Body requestBody: RequestBody):  Observable<BaseResponse<List<AppInformationBean>>>

    /**
     * 查询活动列表信息
     */
    @Headers("Content-type:application/json")
    @POST("app/activity/queryAppActivityList")
    fun getActivityList(@Body requestBody: RequestBody, @Query("pageNum") num: Int): Observable<BasePageResponse<ActivityCenterBean>>
    /**
     * 查询活动列表信息
     */
    @Headers("Content-type:application/json")
    @PUT("app/user/closure-with-reason")
    fun logoff(@Body requestBody: RequestBody): Observable<BaseResponse<Boolean>>


    /**
     * 查询活动列表信息
     */
    @Headers("Content-type:application/json")
    @GET("app/system-info/get-version")
    fun getVersion(): Observable<BaseResponse<String>>
    /**
     * 查询活动列表信息
     */
    @Headers("Content-type:application/json")
    @POST("app/commodity/consumer-app/commodity-of-coupon")
    fun getCouponGoodsList(@Body requestBody: RequestBody): Observable<BasePageResponse<CouponGoodsBean>>

    /**
     * 查询活动列表信息
     */
    @Headers("Content-type:application/json")
    @POST("app/myHome/uploadPicture")
    fun uploadPicture(@Body requestBody: RequestBody): Observable<BaseResponse<Integer>>
        /**
     * 查询活动列表信息
     */
    @Headers("Content-type:application/json")
    @PUT("app/order/consumer-app/submit-order")
    fun submitOrder(@Body requestBody: RequestBody): Observable<BaseResponse<Boolean>>


    /**
     * 查询活动列表信息
     */
    @Headers("Content-type:application/json")
    @GET("app/activity/getAppActivityHomePageByShopId")
    fun getAppActivityHomePageByShopId(@Query("activityShop") num: String): Observable<BaseResponse<HomeActivityBean>>

    /**
     * 查询活动列表信息
     */
    @Headers("Content-type:application/json")
    @POST("app/order/consumer-app/available-coupons")
    fun getAvailableCoupons(@Body requestBody: RequestBody): Observable<BaseResponse<List<AvailableCouponBean>>>

    /**
     * 查询活动列表信息
     */
    @Headers("Content-type:application/json")
    @POST("app/system/version/current")
    fun getAppVersion(@Body requestBody: RequestBody): Observable<BaseResponse<AppVersionBean>>


}