package com.xx.hbhconsumer.data.http.requst;

import com.xx.hbhconsumer.data.http.BaseRespons;
import com.xx.hbhconsumer.data.http.respons.CreditDetailBean;
import com.xx.hbhconsumer.data.http.respons.CreditGoodsBean;
import com.xx.hbhconsumer.data.http.respons.CreditGoodsDetailBean;
import com.xx.hbhconsumer.data.http.respons.CreditRecordBean;
import com.xx.hbhconsumer.data.http.respons.MemberInfoBean;

import io.reactivex.rxjava3.core.Observable;
import me.goldze.mvvmhabit.http.ApiParams;
import me.goldze.mvvmhabit.http.BasePageResponse;
import me.goldze.mvvmhabit.http.BaseResponse;
import okhttp3.RequestBody;

public class CreditRequest extends BaseRespons {

    /**
     * 获取会员信息
     * @return
     */
    public Observable<BaseResponse<MemberInfoBean>> memberInfo() {
        return getApiService().memberInfo();
    }

    /**
     * 低价好物商品列表
     */
    public Observable<BaseResponse<Integer>> creditExchange(String integralGoodsId, String consumptionPoints, String pointGoodsNum) {
        ApiParams<CreditExchangeRequestBody> apiParams = new ApiParams<>();
        CreditExchangeRequestBody requestBody = new CreditExchangeRequestBody(integralGoodsId, consumptionPoints, pointGoodsNum);
        RequestBody body = apiParams.setParams(requestBody);
        return getApiService().creditExchange(body);
    }
    /**
     * 低价好物商品列表
     */
    public Observable<BaseResponse<CreditGoodsDetailBean>> getCreditGoodsDetail(String businessId) {
        return getApiService().getCreditGoodsDetail(businessId);
    }

    /**
     * 低价好物商品列表
     */
    public Observable<BasePageResponse<CreditGoodsBean>> getAllCreditGoodsList(int pageNum) {
        return getApiService().getAllCreditGoodsList(pageNum);
    }

    /**
     * 低价好物商品列表
     */
    public Observable<BasePageResponse<CreditGoodsBean>> getTopCreditGoodsList() {
        return getApiService().getTopCreditGoodsList();
    }

    /**
     * 低价好物商品列表
     */
    public Observable<BaseResponse<CreditDetailBean>> getMyPoint() {
        return getApiService().getMyPoint();
    }
    /**
     * 低价好物商品列表
     */
    public Observable<BasePageResponse<CreditGoodsBean>> getCreditGoodsList() {
        return getApiService().getCreditGoodsList();
    }
        /**
     * 低价好物商品列表
     */
    public Observable<BasePageResponse<CreditRecordBean>> getCreditRecordList(String incomeType, String beginTime, Integer pageNum) {
        ApiParams<GetCreditRecordListRequestBody> apiParams = new ApiParams<>();
        GetCreditRecordListRequestBody requestBody = new GetCreditRecordListRequestBody(incomeType, beginTime);
        RequestBody body=apiParams.setParams(requestBody);
        return getApiService().getCreditRecordList(body, pageNum);
    }

    public class GetCreditRecordListRequestBody {
        public String incomeType;
        public String beginTime;

        public GetCreditRecordListRequestBody(String incomeType, String beginTime) {
            this.incomeType = incomeType;
            this.beginTime = beginTime;
        }
    }
    public class CreditExchangeRequestBody {
        public String integralGoodsId;
        public String consumptionPoints;
        public String pointGoodsNum;

        public CreditExchangeRequestBody(String integralGoodsId, String consumptionPoints, String pointGoodsNum) {
            this.integralGoodsId = integralGoodsId;
            this.consumptionPoints = consumptionPoints;
            this.pointGoodsNum = pointGoodsNum;
        }
    }

}
