package com.xx.hbhconsumer.data.http.requst;

import com.xx.hbhconsumer.data.http.BaseRespons;
import com.xx.hbhconsumer.data.http.respons.CreditGoodsDetailBean;
import com.xx.hbhconsumer.data.http.respons.GoodsBean;
import com.xx.hbhconsumer.data.http.respons.GoodsDetailBean;
import com.xx.hbhconsumer.data.http.respons.ShopAndGoodsBean;
import com.xx.hbhconsumer.data.http.respons.ShopGoodsBean;

import java.util.List;

import io.reactivex.rxjava3.core.Observable;
import me.goldze.mvvmhabit.http.ApiParams;
import me.goldze.mvvmhabit.http.BasePageResponse;
import me.goldze.mvvmhabit.http.BaseResponse;
import okhttp3.RequestBody;

public class GoodsRequest extends BaseRespons {


    public Observable<BaseResponse<String>> memberCollection(String merchantCommodityId, String flag) {
        ApiParams<MemberCollectionRequestBody> apiParams = new ApiParams<>();
        MemberCollectionRequestBody requestBody = new MemberCollectionRequestBody(flag, merchantCommodityId);
        RequestBody body = apiParams.setParams(requestBody);
        return getApiService().memberCollection(body);
    }

    public Observable<BaseResponse<Integer>> cancelCollection(String merchantCommodityId) {

        return getApiService().cancelCollection(merchantCommodityId);
    }

    public Observable<BasePageResponse<GoodsBean>> listShopGoodsByCategory(String categoryId, String searchWord, String affiliatedCompany, int pageNum) {
        ApiParams<ListShopGoodsByCategoryRequestBody> apiParams = new ApiParams<>();
        ListShopGoodsByCategoryRequestBody requestBody = new ListShopGoodsByCategoryRequestBody(categoryId, searchWord, affiliatedCompany);
        RequestBody body = apiParams.setParams(requestBody);
        return getApiService().listShopGoodsByCategory(body, pageNum);
    }

    public Observable<BaseResponse<GoodsDetailBean>> getGoodsDetail(String businessId) {
        return getApiService().queryGoodsDetail(businessId);
    }

    public Observable<BaseResponse<List<ShopGoodsBean>>> getSixCommodity(String merchantId) {
        return getApiService().getSixCommodity(merchantId);
    }

    public Observable<BasePageResponse<ShopGoodsBean>> getShopGoodsList(List<String> categoryIdList, String merchantId, String searchWord, String sortRules) {
        ApiParams<ShopGoodsListRequestBody> apiParams = new ApiParams<>();
        ShopGoodsListRequestBody requestBody = new ShopGoodsListRequestBody(categoryIdList, merchantId, searchWord, sortRules);
        RequestBody body = apiParams.setParams(requestBody);
        return getApiService().getShopGoodsList(body);
    }

    public class ShopGoodsListRequestBody {
        public List<String> categoryIdList;
        public String merchantId;
        public String searchWord;
        public String sortRules;


        public ShopGoodsListRequestBody(List<String> categoryIdList, String merchantId, String searchWord, String sortRules) {
            this.categoryIdList = categoryIdList;
            this.merchantId = merchantId;
            this.searchWord = searchWord;
            this.sortRules = sortRules;
        }
    }

    class ListShopGoodsByCategoryRequestBody {
        String categoryId;
        String searchWord;
        String affiliatedCompany;

        public ListShopGoodsByCategoryRequestBody(String categoryId, String searchWord, String affiliatedCompany) {
            this.categoryId = categoryId;
            this.searchWord = searchWord;
            this.affiliatedCompany = affiliatedCompany;
        }
    }

    class MemberCollectionRequestBody {
        String flag;
        String merchantCommodityId;

        public MemberCollectionRequestBody(String flag, String merchantCommodityId) {
            this.flag = flag;
            this.merchantCommodityId = merchantCommodityId;
        }
    }
}
