package com.xx.hbhconsumer.data.http.requst

import com.xx.hbhconsumer.data.http.respons.UserInfoBean
import com.xx.hbhconsumer.data.http.BaseRespons
import com.xx.hbhconsumer.data.http.respons.VersionBean
import com.xx.xxviewlibrary.model.VersionBody
import io.reactivex.rxjava3.core.Observable
import me.goldze.mvvmhabit.http.ApiParams
import me.goldze.mvvmhabit.http.BaseResponse

class LoginRequest: BaseRespons() {

    fun checkVersion(): Observable<BaseResponse<VersionBean>> {
        return apiService.getLineVersion(
            /**
             * appType类型 1-企业端 2-商户端 3-消费者端
             * terminalType终端版本 1-IOS 2-Android
             */
            ApiParams<VersionBody>().setParams(
                VersionBody("3", "2")
            )
        )
    }

    /**
     * 登陆
     */
    fun Login(user:String, pwd:String ): Observable<me.goldze.mvvmhabit.http.BaseResponse<String>>
    {
        return apiService.Login(ApiParams<LoginRequestBody>().setParams(LoginRequestBody(user,pwd,"13")))
    }

    /**
     * 获取用户信息
     */
    fun getUserInfo(): Observable<me.goldze.mvvmhabit.http.BaseResponse<UserInfoBean>>
    {
        return apiService.getUserInfo()
    }



    /**
     * 登陆入参
     * userType : 10 系统用户，01 企业用户，02商户用户，13消费者用户
     */
    class LoginRequestBody(var phone: String, var password: String,var userType:String  )


    /**
     * 获取协议内容
     */
    fun getProtocols(): Observable<BaseResponse<List<String>>>
    {
        return apiService.getProtocols(ApiParams<Array<String>>().setParams(arrayOf("6","7","14","9","10")))
    }
}