package com.xx.hbhconsumer.data.http.requst;

import com.xx.hbhconsumer.data.http.BaseRespons;
import com.xx.hbhconsumer.data.http.respons.AppInformationBean;
import com.xx.hbhconsumer.data.http.respons.RecruitBean;

import java.util.List;

import io.reactivex.rxjava3.core.Observable;
import me.goldze.mvvmhabit.http.ApiParams;
import me.goldze.mvvmhabit.http.BaseResponse;
import okhttp3.RequestBody;
import okhttp3.ResponseBody;
import retrofit2.Call;

public class NewsRequest extends BaseRespons {

    public Observable<BaseResponse<List<AppInformationBean>>> queryAppInformationList() {
        ApiParams<QueryAppInformationListRequestBody> apiParams = new ApiParams<>();
        QueryAppInformationListRequestBody requestBody = new QueryAppInformationListRequestBody("1");
        RequestBody body=apiParams.setParams(requestBody);
        return getApiService().getAppInformationList(body);
    }

    public Call<ResponseBody> downloadFileWithUrlSync(String url) {
        return getApiService().downloadFileWithUrlSync(url);
    }

    public Observable<BaseResponse<String>> addView(String businessId) {
        AddViewRequestBody addViewRequestBody = new AddViewRequestBody(businessId);
        ApiParams<AddViewRequestBody> apiParams = new ApiParams<AddViewRequestBody>();
        RequestBody body = apiParams.setParams(addViewRequestBody);
        return getApiService().addView(body);
    }

    public class AddViewRequestBody {
        public String businessId;

        public AddViewRequestBody(String businessId) {
            this.businessId = businessId;
        }
    }

    public class QueryAppInformationListRequestBody {
        public String appSide;

        public QueryAppInformationListRequestBody(String appSide) {
            this.appSide = appSide;
        }
    }
    public class RecruitmentRequestBody {
        public String appSide;
        public String recruitmentId;
        public String resumeFileId;

        public RecruitmentRequestBody(String appSide, String recruitmentId, String resumeFileId) {
            this.appSide = appSide;
            this.recruitmentId = recruitmentId;
            this.resumeFileId = resumeFileId;
        }
    }
}
