package com.xx.hbhconsumer.ui.activity;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.scwang.smart.refresh.layout.api.RefreshLayout;
import com.scwang.smart.refresh.layout.listener.OnLoadMoreListener;
import com.scwang.smart.refresh.layout.listener.OnRefreshListener;
import com.xx.hbhconsumer.BR;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.ActivityCenterListAdapter;
import com.xx.hbhconsumer.adapter.ActivityCouponAdapter;
import com.xx.hbhconsumer.data.http.requst.ActivityRequest;
import com.xx.hbhconsumer.data.http.respons.ActivityCenterBean;
import com.xx.hbhconsumer.databinding.FragmentActivityBinding;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseFragment;

public class ActivityFragment extends BaseFragment<FragmentActivityBinding, ActivityViewModel> implements OnRefreshListener, OnLoadMoreListener {


    @Override
    public int viewModelType() {
        return 1;
    }

    @Override
    public int initContentView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return R.layout.fragment_activity;
    }

    @Override
    public int initVariableId() {
        return BR.activityViewModel;
    }

    //    重写初始方法调用参数
    @Override
    public void initData() {
        super.initData();
        binding.refresh.setOnRefreshListener(this);
        binding.refresh.setOnLoadMoreListener(this);
        viewModel.couponList.observe(this, couponBeanList -> {
            if (couponBeanList != null && couponBeanList.size() > 5) {
                binding.tvMore.setVisibility(View.VISIBLE);
                binding.ivMore.setVisibility(View.VISIBLE);
            } else {
                binding.tvMore.setVisibility(View.GONE);
                binding.ivMore.setVisibility(View.GONE);
            }
            ActivityCouponAdapter couponAdapter = new ActivityCouponAdapter(getActivity(), viewModel);
            binding.rvCouponList.setAdapter(couponAdapter);
            couponAdapter.mList = couponBeanList;
        });

        //展示活动列表
        ActivityCenterListAdapter adapter = new ActivityCenterListAdapter(getContext());

        binding.rvDblList.setAdapter(adapter);
        adapter.setOnItemClick(new xxBaseRecyclerViewAdapter.OnItemClick<ActivityCenterBean>() {
            @Override
            public void itemClickCalBack(int position, ActivityCenterBean data) {
                viewModel.goActivityDetail(data.getActivityUrl());
            }
        });

        binding.refresh.setEnableRefresh(false);

        viewModel.activityList.observe(this, activityCenterBeans -> {
            if (activityCenterBeans != null && !activityCenterBeans.isEmpty()) {
                adapter.mList = activityCenterBeans;
                adapter.notifyDataSetChanged();
            }
            if (viewModel.page == 1) {
                binding.refresh.finishRefresh();
            } else {
                binding.refresh.finishLoadMore();
            }
            if (viewModel.page == viewModel.totalPage) {
                binding.refresh.setEnableLoadMore(false);
            } else {
                binding.refresh.setEnableLoadMore(true);
            }
        });
    }

    @Override
    public ActivityViewModel initViewModel() {
        ActivityRequest lm = new ActivityRequest();
        return new ActivityViewModel(getActivity().getApplication(), lm);
    }

    @Override
    public void onLoadMore(@NonNull RefreshLayout refreshLayout) {
        viewModel.page++;

        if (viewModel.page > viewModel.totalPage) {
            binding.tvNoMore.setVisibility(View.VISIBLE);
        } else if (viewModel.page == viewModel.totalPage) {
            binding.refresh.setEnableLoadMore(false);
            viewModel.getActivityCenterList();
            binding.tvNoMore.setVisibility(View.VISIBLE);
        } else {
            viewModel.getActivityCenterList();
        }
    }

    @Override
    public void onRefresh(@NonNull RefreshLayout refreshLayout) {
        viewModel.page=1;
        viewModel.getActivityCenterList();
        binding.refresh.setEnableLoadMore(true);
    }
}