package com.xx.hbhconsumer.ui.category;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;

import androidx.recyclerview.widget.GridLayoutManager;

import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.FirstCategoryAdapter;
import com.xx.hbhconsumer.adapter.SecondCategoryAdapter;
import com.xx.hbhconsumer.adapter.SecondCategoryTextAdapter;
import com.xx.hbhconsumer.adapter.ThirdCategoryAdapter;
import com.xx.hbhconsumer.data.http.requst.CategoryRequest;
import com.xx.hbhconsumer.data.http.respons.CategoryBean;
import com.xx.hbhconsumer.databinding.ActivityCategoryBinding;
import com.xx.hbhconsumer.ui.shop.ShopSearchActivity;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;

public class CategoryActivity extends BaseActivity<ActivityCategoryBinding, CategoryViewModel> {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_category;
    }

    @Override
    public int initVariableId() {
        return BR.categoryViewModel;
    }

    @Override
    public void initData() {
        super.initData();

        //获取适配器上下文
        FirstCategoryAdapter firstCategoryAdapter = new FirstCategoryAdapter(this);
        //把adapterset进去
        binding.rvFirstCategoryList.setAdapter(firstCategoryAdapter);
        firstCategoryAdapter.setOnItemClick((position, data) -> {
            viewModel.changeSecondCategoryList(position);
            firstCategoryAdapter.notifyDataSetChanged();
        });
        viewModel.categoryBeanList.observe(this, categoryBeanList -> {
            firstCategoryAdapter.mList = categoryBeanList;
            firstCategoryAdapter.notifyDataSetChanged();
        });


        viewModel.secondBeanList.observe(this, secondBeanList -> {

            //获取适配器上下文
            GridLayoutManager manager = new GridLayoutManager(this,2);
            binding.rvSecondCategoryList.setLayoutManager(manager);

            //获取适配器上下文
            ThirdCategoryAdapter thirdCategoryAdapter = new ThirdCategoryAdapter(this);

            //把adapterset进去
            binding.rvSecondCategoryList.setAdapter(thirdCategoryAdapter);
            thirdCategoryAdapter.mList = secondBeanList;
            thirdCategoryAdapter.setOnItemClick((position, data) -> {
                viewModel.goGoodsList(data.getCategoryId());
            });
        });


        viewModel.secondBeanList.observe(this, categoryBeanList -> {

            if (categoryBeanList.isEmpty()) {
                binding.rlNoData.setVisibility(View.VISIBLE);
                binding.rvSecondCategoryList.setVisibility(View.GONE);
            } else {
                binding.rlNoData.setVisibility(View.GONE);
                binding.rvSecondCategoryList.setVisibility(View.VISIBLE);
            }

            //获取适配器上下文
            GridLayoutManager manager = new GridLayoutManager(this,2);
            binding.rvSecondCategoryList.setLayoutManager(manager);

            //获取适配器上下文
            ThirdCategoryAdapter thirdCategoryAdapter = new ThirdCategoryAdapter(this);

            //把adapterset进去
            binding.rvSecondCategoryList.setAdapter(thirdCategoryAdapter);
            thirdCategoryAdapter.mList = categoryBeanList;
            thirdCategoryAdapter.setOnItemClick((position, data) -> {
                viewModel.goGoodsList(data.getCategoryId());
            });
        });

    }

    @Override
    public CategoryViewModel initViewModel() {
        CategoryRequest lm = new CategoryRequest();
        String merchantId = getIntent().getStringExtra("merchantId");
        return new CategoryViewModel(getApplication(), lm, merchantId);
    }
}
