package com.xx.hbhconsumer.ui.coupon;

import android.os.Bundle;
import android.view.View;

import androidx.annotation.NonNull;

import com.scwang.smart.refresh.layout.api.RefreshLayout;
import com.scwang.smart.refresh.layout.listener.OnLoadMoreListener;
import com.scwang.smart.refresh.layout.listener.OnRefreshListener;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.MoreCouponAdapter;
import com.xx.hbhconsumer.data.http.requst.CouponRequest;
import com.xx.hbhconsumer.databinding.ActivityCouponListBinding;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;

public class CouponListActivity extends BaseActivity<ActivityCouponListBinding, CouponListViewModel> implements OnRefreshListener, OnLoadMoreListener {

    @Override
    public void initData() {
        super.initData();

        binding.refresh.setOnRefreshListener(this);
        binding.refresh.setOnLoadMoreListener(this);

        MoreCouponAdapter couponAdapter = new MoreCouponAdapter(CouponListActivity.this, viewModel);
        binding.rvCouponList.setAdapter(couponAdapter);
        viewModel.couponList.observe(this, couponBeanList -> {
            if (couponBeanList.isEmpty()) {
                binding.rlNoData.setVisibility(View.VISIBLE);
                binding.rvCouponList.setVisibility(View.GONE);
            } else {
                binding.rlNoData.setVisibility(View.GONE);
                binding.rvCouponList.setVisibility(View.VISIBLE);
            }
            couponAdapter.mList = couponBeanList;
            couponAdapter.notifyDataSetChanged();

            if (viewModel.page == 1) {
                binding.refresh.finishRefresh();
            } else {
                binding.refresh.finishLoadMore();
            }
            if (viewModel.page == viewModel.totalPage) {
                binding.refresh.setEnableLoadMore(false);
                binding.tvNoMore.setVisibility(View.VISIBLE);
            } else {
                binding.refresh.setEnableLoadMore(true);
                binding.tvNoMore.setVisibility(View.GONE);
            }
        });
    }

    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_coupon_list;
    }

    @Override
    public int initVariableId() {
        return BR.couponListViewModel;
    }

    @Override
    public CouponListViewModel initViewModel() {
        CouponRequest lm = new CouponRequest();
        return new CouponListViewModel(getApplication(), lm);
    }

    @Override
    public void onLoadMore(@NonNull RefreshLayout refreshLayout) {
        viewModel.page++;
        if (viewModel.page > viewModel.totalPage) {
            binding.tvNoMore.setVisibility(View.VISIBLE);
        } else if (viewModel.page == viewModel.totalPage) {
            binding.refresh.setEnableLoadMore(false);
            viewModel.loadData();
            binding.tvNoMore.setVisibility(View.VISIBLE);
        } else {
            viewModel.loadData();
        }
    }

    @Override
    public void onRefresh(@NonNull RefreshLayout refreshLayout) {
        viewModel.page=1;
        viewModel.loadData();
        binding.refresh.setEnableLoadMore(true);
    }
}
