package com.xx.hbhconsumer.ui.coupon;

import android.app.Application;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.CouponRequest;
import com.xx.hbhconsumer.data.http.respons.ActivityCouponBean;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;
import me.goldze.mvvmhabit.utils.ToastUtils;

public class CouponListViewModel extends BaseViewModel<CouponRequest> {
    public int page = 1;
    public int totalPage = 1;
    public MutableLiveData<List<ActivityCouponBean>> couponList = new  MutableLiveData<>(new ArrayList<>());

    public CouponListViewModel(@NonNull Application application) {
        super(application);
    }

    public CouponListViewModel(@NonNull Application application, CouponRequest model) {
        super(application, model);
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        loadData();
    }

    public void getCoupon(String couponId) {
        model.getCoupon(couponId)
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(CouponListViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<Integer>() {
                    @Override
                    public void onSuccess(Integer resultBean) {
                        ToastUtils.showShort("领取成功");
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                });
    }

    public void loadData() {
        model.getCouponAppList(page)
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(CouponListViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<ActivityCouponBean>() {
                    @Override
                    public void onSuccess(List<ActivityCouponBean> resultBean) {
                        List<ActivityCouponBean> list = new ArrayList<>();
                        for (ActivityCouponBean activityCouponBean : resultBean) {
                            if ("1".equals(activityCouponBean.getCouponType())) {
                                list.add(activityCouponBean);
                            }
                        }
                        if (page == 1) {
                            couponList.postValue(list);
                        } else {
                            List<ActivityCouponBean> activityCouponBeanList = couponList.getValue();
                            activityCouponBeanList.addAll(list);
                            couponList.postValue(activityCouponBeanList);
                        }
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                    @Override
                    public void getTotal(int total) {
                        totalPage = (total - 1) / 10 + 1;
                    }


                });
    }
}
