package com.xx.hbhconsumer.ui.credit;

import android.os.Bundle;
import android.view.View;

import androidx.annotation.NonNull;

import com.google.android.material.tabs.TabLayout;
import com.scwang.smart.refresh.layout.api.RefreshLayout;
import com.scwang.smart.refresh.layout.listener.OnLoadMoreListener;
import com.scwang.smart.refresh.layout.listener.OnRefreshListener;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.CreditAdapter;
import com.xx.hbhconsumer.adapter.YearAdapter;
import com.xx.hbhconsumer.data.http.requst.CreditRequest;
import com.xx.hbhconsumer.databinding.ActivityCreditDetailBinding;

import java.util.ArrayList;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;

public class CreditDetailActivity extends BaseActivity<ActivityCreditDetailBinding, CreditDetailViewModel> implements OnRefreshListener, OnLoadMoreListener {

    @Override
    public void initData() {
        super.initData();
        binding.refresh.setOnRefreshListener(this);
        binding.refresh.setOnLoadMoreListener(this);
        /*切换状态Tab*/
        binding.tabLayout.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            public void onTabSelected(TabLayout.Tab tab) {
                switch (tab.getPosition()) {
                    case 0:
                        viewModel.page = 1;
                        viewModel.incomeType = "1";
                        viewModel.loadCreditRecordList();
                        break;
                    case 1:
                        viewModel.page = 1;
                        viewModel.incomeType = "2";
                        viewModel.loadCreditRecordList();
                        break;
                }
            }
            @Override
            public void onTabUnselected(TabLayout.Tab tab) {
            }
            @Override
            public void onTabReselected(TabLayout.Tab tab) {
            }
        });

        CreditAdapter creditAdapter = new CreditAdapter(this);
        //把adapterset进去
        binding.rvCreditRecordList.setAdapter(creditAdapter);

        viewModel.creditRecordBeanList.observe(this, creditRecordBeanList -> {
            if (creditRecordBeanList != null && !creditRecordBeanList.isEmpty()) {
                binding.llNoData.setVisibility(View.GONE);
                binding.rvCreditRecordList.setVisibility(View.VISIBLE);
                binding.refresh.setEnableLoadMore(true);
            } else {
                binding.llNoData.setVisibility(View.VISIBLE);
                binding.rvCreditRecordList.setVisibility(View.GONE);
                binding.refresh.setEnableLoadMore(false);
            }
            if (viewModel.page == 1) {
                binding.refresh.finishRefresh();
            } else {
                binding.refresh.finishLoadMore();
            }

            if (viewModel.page == viewModel.totalPage) {
                binding.refresh.setEnableLoadMore(false);
            } else {
                binding.refresh.setEnableLoadMore(true);
            }
            creditAdapter.mList = creditRecordBeanList;
            creditAdapter.notifyDataSetChanged();

        });

        viewModel.credit.observe(this, credit -> {
            binding.tvCreditNum.setText(String.valueOf(credit));
        });
        viewModel.checkYearFlag.observe(this, checkYearFlag -> {
            if (checkYearFlag) {
                binding.rlCheckYear.setVisibility(View.VISIBLE);
            } else {
                binding.rlCheckYear.setVisibility(View.GONE);
            }
        });


        YearAdapter yearAdapter = new YearAdapter(this);
        binding.rvYearList.setAdapter(yearAdapter);
        yearAdapter.setOnItemClick((position, data) -> {
            viewModel.checkYear(data);
        });
        viewModel.yearBeanList.observe(this, yearBeanList -> {
            yearAdapter.mList = yearBeanList;
            yearAdapter.notifyDataSetChanged();
        });

        viewModel.year.observe(this, year -> {
            binding.tvYear.setText(year + "年");
        });
    }

    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_credit_detail;
    }

    @Override
    public int initVariableId() {
        return BR.creditDetailViewModel;
    }

    @Override
    public CreditDetailViewModel initViewModel() {
        CreditRequest lm = new CreditRequest();
        return new CreditDetailViewModel(getApplication(), lm);
    }

    @Override
    public void onLoadMore(RefreshLayout refreshLayout) {
        viewModel.page++;

        if (viewModel.page > viewModel.totalPage) {

        } else if (viewModel.page == viewModel.totalPage) {
            binding.refresh.setEnableLoadMore(false);
            viewModel.loadCreditRecordList();

        } else {
            viewModel.loadCreditRecordList();
        }
    }

    @Override
    public void onRefresh(@NonNull RefreshLayout refreshLayout) {
        viewModel.page=1;
        viewModel.loadCreditRecordList();
        binding.refresh.setEnableLoadMore(true);

    }
}
