package com.xx.hbhconsumer.ui.credit

import android.content.Context
import android.view.Gravity
import android.view.View
import android.view.WindowManager
import com.xx.hbhconsumer.R
import com.xx.hbhconsumer.databinding.DialogCreditExchangeBinding
import com.xx.xxviewlibrary.base.xxBaseDialog
import me.jessyan.autosize.utils.AutoSizeUtils

class CreditExchangeDialog(context:Context, var data: Int, var integralCommodityType: String): xxBaseDialog<DialogCreditExchangeBinding>(context) {

    override fun InitView(): DialogSet {
        return DialogSet(
            R.layout.dialog_credit_exchange,true,
            Gravity.BOTTOM,true, WindowManager.LayoutParams.MATCH_PARENT,
            AutoSizeUtils.dp2px(context,
            269.0F));
    }

    override fun InitData() {
        binding.creditExchangeDialog = this

        binding.btnCancel.setOnClickListener {
            dismiss()
        }

        binding.tvCreditNum.setText(data.toString())
        binding.tvTotalCredit.setText(data.toString())

        if ("1".equals(integralCommodityType)) {
            binding.ivNumAdd.visibility = View.VISIBLE
            binding.ivNumSub.visibility = View.VISIBLE
        } else {
            binding.ivNumAdd.visibility = View.INVISIBLE
            binding.ivNumSub.visibility = View.INVISIBLE
        }

        binding.ivNumAdd.setOnClickListener {
            var num: Int = binding.tvNum.text.toString().toInt()
            binding.tvNum.text = (num + 1).toString()
            binding.tvTotalCredit.setText(((num + 1) * data).toString())
            binding.tvCreditNum.setText(((num + 1) * data).toString())
        }

        binding.ivNumSub.setOnClickListener {
            var num: Int = binding.tvNum.text.toString().toInt()
            if (num > 1) {
                binding.tvNum.text = (num - 1).toString()
                binding.tvTotalCredit.setText(((num - 1) * data).toString())
                binding.tvCreditNum.setText(((num - 1) * data).toString())
            }
        }

        binding.btnConfirm.setOnClickListener {
            DialogClickListener.dialogClickBack(0, binding.tvNum.text.toString().toInt());
            dismiss()
        }
    }
}