package com.xx.hbhconsumer.ui.credit;

import android.os.Bundle;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.GridLayoutManager;

import com.scwang.smart.refresh.layout.api.RefreshLayout;
import com.scwang.smart.refresh.layout.listener.OnLoadMoreListener;
import com.scwang.smart.refresh.layout.listener.OnRefreshListener;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.CreditGoodsAdapter;
import com.xx.hbhconsumer.adapter.CreditGoodsSmallAdapter;
import com.xx.hbhconsumer.data.http.requst.CreditRequest;
import com.xx.hbhconsumer.databinding.ActivityCreditsExchangeBinding;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;

public class CreditsExchangeActivity extends BaseActivity<ActivityCreditsExchangeBinding, CreditsExchangeViewModel> implements OnRefreshListener, OnLoadMoreListener {

    @Override
    public void initData() {
        super.initData();
        binding.refresh.setOnRefreshListener(this);
        binding.refresh.setOnLoadMoreListener(this);
        GridLayoutManager manager = new GridLayoutManager(this,2);
        binding.rvAllGoodsList.setLayoutManager(manager);
        CreditGoodsAdapter creditGoodsAdapter = new CreditGoodsAdapter(this);
        binding.rvAllGoodsList.setAdapter(creditGoodsAdapter);
        creditGoodsAdapter.setOnItemClick((position, data) -> viewModel.goCreditsGoodsDetail(data.getBusinessId()));
        viewModel.creditGoodsBeanList.observe(this, creditGoodsBeanList -> {
            creditGoodsAdapter.mList = creditGoodsBeanList;
            creditGoodsAdapter.notifyDataSetChanged();

            if (viewModel.page == 1) {
                binding.refresh.finishRefresh();
            } else {
                binding.refresh.finishLoadMore();
            }
        });


        CreditGoodsSmallAdapter creditGoodsSmallAdapter = new CreditGoodsSmallAdapter(this);
        GridLayoutManager manager1 = new GridLayoutManager(this,3);
        binding.rvRecommendList.setLayoutManager(manager1);
        binding.rvRecommendList.setAdapter(creditGoodsSmallAdapter);
        creditGoodsSmallAdapter.setOnItemClick((position, data) -> viewModel.goCreditsGoodsDetail(data.getBusinessId()));
        viewModel.topCreditGoodsBeanList.observe(this, topCreditGoodsBeanList -> {
            creditGoodsSmallAdapter.mList = topCreditGoodsBeanList;
            creditGoodsSmallAdapter.notifyDataSetChanged();
        });
    }

    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_credits_exchange;
    }

    @Override
    public int initVariableId() {
        return BR.creditsExchangeViewModel;
    }

    @Override
    public CreditsExchangeViewModel initViewModel() {
        CreditRequest lm = new CreditRequest();
        return new CreditsExchangeViewModel(getApplication(), lm);
    }

    @Override
    public void onLoadMore(@NonNull RefreshLayout refreshLayout) {
        viewModel.page++;
        if (viewModel.page > viewModel.totalPage) {
            binding.tvNoMore.setVisibility(View.VISIBLE);
        } else if (viewModel.page == viewModel.totalPage) {
            binding.refresh.setEnableLoadMore(false);
            viewModel.loadAllGoodsList();
            binding.tvNoMore.setVisibility(View.VISIBLE);
        } else {
            viewModel.loadAllGoodsList();
        }
    }

    @Override
    public void onRefresh(@NonNull RefreshLayout refreshLayout) {
        viewModel.page=1;
        viewModel.loadAllGoodsList();
        binding.refresh.setEnableLoadMore(true);
    }
}
