package com.xx.hbhconsumer.ui.credit;

import android.app.Application;
import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.adapter.CreditGoodsSmallAdapter;
import com.xx.hbhconsumer.data.http.requst.CreditRequest;
import com.xx.hbhconsumer.data.http.requst.PhoneRequest;
import com.xx.hbhconsumer.data.http.respons.CreditGoodsBean;
import com.xx.hbhconsumer.data.http.respons.CreditRecordBean;
import com.xx.hbhconsumer.ui.order.OrderDetailActivity;
import com.xx.xxviewlibrary.utils.AddImgAdapter;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class CreditsExchangeViewModel extends BaseViewModel<CreditRequest> {
    public int page = 1;
    public int totalPage = 1;
    public MutableLiveData<List<CreditGoodsBean>> creditGoodsBeanList = new  MutableLiveData<>(new ArrayList<>());
    public MutableLiveData<List<CreditGoodsBean>> topCreditGoodsBeanList = new  MutableLiveData<>(new ArrayList<>());

    public CreditsExchangeViewModel(@NonNull Application application) {
        super(application);
    }

    public CreditsExchangeViewModel(@NonNull Application application, CreditRequest model) {
        super(application, model);
    }
    public void goCreditsGoodsDetail(String goodsId) {
        Bundle bundle = new Bundle();
        bundle.putString("goodsId", goodsId);
        startActivity(CreditsGoodsDetailActivity.class, bundle);
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        loadTopCreditGoodsList();
        loadAllGoodsList();
    }

    public void loadAllGoodsList() {
        model.getAllCreditGoodsList(page)
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(CreditsExchangeViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<CreditGoodsBean>() {
                    @Override
                    public void onSuccess(List<CreditGoodsBean> resultBean) {
                        if (page == 1) {
                            creditGoodsBeanList.postValue(resultBean);
                        } else {
                            List<CreditGoodsBean> list = creditGoodsBeanList.getValue();
                            list.addAll(resultBean);
                            creditGoodsBeanList.postValue(list);
                        }

                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                    @Override
                    public void getTotal(int total) {
                        totalPage = (total - 1) / 10 + 1;
                    }

                });
    }

    private void loadTopCreditGoodsList() {
        model.getTopCreditGoodsList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(CreditsExchangeViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<CreditGoodsBean>() {
                    @Override
                    public void onSuccess(List<CreditGoodsBean> resultBean) {
                        topCreditGoodsBeanList.postValue(resultBean);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                    @Override
                    public void getTotal(int total) {

                    }

                });
    }
}
