package com.xx.hbhconsumer.ui.credit;

import android.os.Bundle;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.ViewGroup;

import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.CreditAdapter;
import com.xx.hbhconsumer.adapter.ImageBannerAdapter;
import com.xx.hbhconsumer.data.http.requst.CreditRequest;
import com.xx.hbhconsumer.data.http.requst.OrderRequest;
import com.xx.hbhconsumer.databinding.ActivityCreditsGoodsDetailBinding;
import com.xx.hbhconsumer.ui.home.BannerAdapter;
import com.youth.banner.indicator.CircleIndicator;

import java.util.ArrayList;
import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;

public class CreditsGoodsDetailActivity extends BaseActivity<ActivityCreditsGoodsDetailBinding, CreditsGoodsDetailViewModel> {
    private static final String TAG = "CreditsGoodsDetailActiv";
    @Override
    public void initData() {
        super.initData();

        DisplayMetrics displayMetrics = new DisplayMetrics();
        getWindowManager().getDefaultDisplay().getMetrics(displayMetrics);
        int screenWidth = displayMetrics.widthPixels;

        ViewGroup.LayoutParams layoutParams = binding.bannerGoodsImg.getLayoutParams();
        Log.i(TAG, "initData: height = " + layoutParams.height + ", width = " + layoutParams.width);
        layoutParams.height = screenWidth;
        binding.bannerGoodsImg.setLayoutParams(layoutParams);
        binding.bannerGoodsImg.addBannerLifecycleObserver(this).setIndicator(new CircleIndicator(this));
        viewModel.creditGoodsDetailBean.observe(this, creditGoodsDetailBean -> {
            if (creditGoodsDetailBean != null) {

                binding.bar.tv_title.setText(creditGoodsDetailBean.getIntegralCommodityName());
                ImageBannerAdapter bannerAdapter=new ImageBannerAdapter(this, creditGoodsDetailBean.getIntegralCommodityImageUrl());
                binding.bannerGoodsImg.setAdapter(bannerAdapter);

                binding.tvCreditNum.setText(String.valueOf(creditGoodsDetailBean.getCommodityPrice()));
                binding.tvCreditGoodsName.setText(creditGoodsDetailBean.getIntegralCommodityName());

                String baseHtml = "<!DOCTYPE html><html><head><meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0\"></head><body style=\"margin: 0; padding: 0;\">";
                binding.wvGoodsDetail.loadDataWithBaseURL(null, baseHtml + creditGoodsDetailBean.getCommodityDescription() + "</body></html>", "text/html", "utf-8", null);
            }
        });
    }

    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_credits_goods_detail;
    }

    @Override
    public int initVariableId() {
        return BR.creditsGoodsDetailViewModel;
    }

    @Override
    public CreditsGoodsDetailViewModel initViewModel() {
        CreditRequest lm = new CreditRequest();
        String goodsId = getIntent().getStringExtra("goodsId");
        return new CreditsGoodsDetailViewModel(getApplication(), lm, goodsId);
    }
}
