package com.xx.hbhconsumer.ui.credit;

import android.os.Bundle;

import androidx.recyclerview.widget.GridLayoutManager;

import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.CreditAdapter;
import com.xx.hbhconsumer.adapter.CreditGoodsAdapter;
import com.xx.hbhconsumer.data.http.requst.CreditRequest;
import com.xx.hbhconsumer.data.http.respons.CreditGoodsBean;
import com.xx.hbhconsumer.databinding.ActivityMyCreditBinding;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;

public class MyCreditActivity extends BaseActivity<ActivityMyCreditBinding, MyCreditViewModel> {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_my_credit;
    }

    @Override
    public int initVariableId() {
        return BR.myCreditViewModel;
    }

    @Override
    public void initData() {
        super.initData();
        viewModel.integralTotal.observe(this, integralTotal -> binding.tvCreditNum.setText(String.valueOf(integralTotal)));


        GridLayoutManager manager = new GridLayoutManager(this,2);
        binding.rvCreditGoodsList.setLayoutManager(manager);
        //获取适配器上下文
        CreditGoodsAdapter creditGoodsAdapter = new CreditGoodsAdapter(this);
        //把adapterset进去
        binding.rvCreditGoodsList.setAdapter(creditGoodsAdapter);
        creditGoodsAdapter.setOnItemClick(new xxBaseRecyclerViewAdapter.OnItemClick<CreditGoodsBean>() {
            @Override
            public void itemClickCalBack(int position, CreditGoodsBean data) {
                viewModel.goCreditsGoodsDetail(data.getBusinessId());
            }
        });
        viewModel.creditGoodsBeanList.observe(this, creditGoodsBeanList -> {

            creditGoodsAdapter.mList = creditGoodsBeanList;
            creditGoodsAdapter.notifyDataSetChanged();
        });

        viewModel.creditRecordBeanList.observe(this, creditRecordBeanList -> {
            CreditAdapter creditAdapter = new CreditAdapter(this);
            //把adapterset进去
            binding.rvCreditList.setAdapter(creditAdapter);
            creditAdapter.mList = creditRecordBeanList;
        });
    }

    @Override
    public MyCreditViewModel initViewModel() {
        CreditRequest lm = new CreditRequest();
        return new MyCreditViewModel(getApplication(), lm);
    }
}
