package com.xx.hbhconsumer.ui.credit;

import android.app.Application;
import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.CreditRequest;
import com.xx.hbhconsumer.data.http.respons.CreditGoodsBean;
import com.xx.hbhconsumer.data.http.respons.CreditRecordBean;
import com.xx.hbhconsumer.data.http.respons.MemberInfoBean;
import com.xx.hbhconsumer.ui.mine.MineViewModel;
import com.xx.hbhconsumer.ui.useragreement.UserAgreementActivity;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class MyCreditViewModel extends BaseViewModel<CreditRequest> {
    public MutableLiveData<Integer> integralTotal = new MutableLiveData<>(0);
    public MutableLiveData<List<CreditGoodsBean>> creditGoodsBeanList = new  MutableLiveData<>(new ArrayList<>());
    public MutableLiveData<List<CreditRecordBean>> creditRecordBeanList = new  MutableLiveData<>(new ArrayList<>());

    public MyCreditViewModel(@NonNull Application application) {
        super(application);
    }

    public MyCreditViewModel(@NonNull Application application, CreditRequest model) {
        super(application, model);
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        loadGoodsList();
        loadCreditRecordList();
        memberInfo();
    }

    /**
     *  获取积分
     */
    private void memberInfo() {
        model.memberInfo().compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MyCreditViewModel.this)
                .doOnSubscribe((Consumer<Disposable>) disposable -> {
                }).subscribe(new ApiDisposableObserver<MemberInfoBean>() {
                    @Override
                    public void onSuccess(MemberInfoBean resultBean) {
                        integralTotal.postValue(resultBean.getUsableIntegral());
                    }
                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                });
    }

    private void loadCreditRecordList() {
        model.getCreditRecordList(null, "2023", 1)
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MyCreditViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<CreditRecordBean>() {
                    @Override
                    public void onSuccess(List<CreditRecordBean> resultBean) {
                        if (resultBean != null && resultBean.size() <= 3) {
                            creditRecordBeanList.postValue(resultBean);
                        }
                        if (resultBean != null && resultBean.size() > 3) {
                            creditRecordBeanList.postValue(resultBean.subList(0, 3));
                        }

                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                    @Override
                    public void getTotal(int total) {

                    }

                });
    }

    private void loadGoodsList() {
        model.getCreditGoodsList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MyCreditViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<CreditGoodsBean>() {
                    @Override
                    public void onSuccess(List<CreditGoodsBean> resultBean) {
                        creditGoodsBeanList.postValue(resultBean);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                    @Override
                    public void getTotal(int total) {
                        
                    }

                });
    }

    public void goCreditsGoodsDetail(String goodsId) {
        Bundle bundle = new Bundle();
        bundle.putString("goodsId", goodsId);
        startActivity(CreditsGoodsDetailActivity.class, bundle);
    }

    public BindingCommand goCreditDetail = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(CreditDetailActivity.class);
        }

    });

    public BindingCommand goCreditDescription = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            Bundle bundle = new Bundle();
            bundle.putString("basic", "9");
            bundle.putString("basicName", "积分说明");
            startActivity(UserAgreementActivity.class, bundle);
        }

    });

    public BindingCommand goCreditsExchange = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(CreditsExchangeActivity.class);
        }

    });
}
