package com.xx.hbhconsumer.ui.creditorder;

import android.os.Bundle;
import android.view.View;

import com.bumptech.glide.Glide;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.requst.CreditOrderRequest;
import com.xx.hbhconsumer.databinding.ActivityCreditOrderDetailBinding;
import com.xx.hbhconsumer.utils.RetrofitClient;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;

public class CreditOrderDetailActivity extends BaseActivity<ActivityCreditOrderDetailBinding, CreditOrderDetailViewModel> {

    @Override
    public void initData() {
        super.initData();
        viewModel.orderBean.observe(this, orderBean -> {

            if (orderBean != null) {
                if (orderBean.getIntegralCommodityImageUrl() != null && !orderBean.getIntegralCommodityImageUrl().isEmpty()) {
                    Glide.with(this)
                            .load(RetrofitClient.baseImgUrl + orderBean.getIntegralCommodityImageUrl().get(0))
                            .into(binding.ivGoodsImg);
                }

                if ("0".equals(orderBean.getStatus())) {
                    binding.ivOrderStateIcon.setImageDrawable(getDrawable(R.mipmap.dingdanxiangqing_icon_wancheng));
                    binding.tvOrderState.setText("订单状态：已完成");
                } else if ("1".equals(orderBean.getStatus())) {
                    binding.ivOrderStateIcon.setImageDrawable(getDrawable(R.mipmap.jifendingdan_icon_dailing));
                    binding.tvOrderState.setText("订单状态：待领取");
                }
                binding.tvCreditNum.setText((orderBean.getConsumptionPoints() / orderBean.getPointGoodsNum())+ "");
                binding.tvGoodsName.setText(orderBean.getIntegralName());
                binding.tvGoodsNum.setText("x" + orderBean.getPointGoodsNum());
                binding.tvTotalCredit.setText(orderBean.getConsumptionPoints() + " 积分");
                binding.tvOrderNumber.setText(orderBean.getPointOrderNumber() + "");
                binding.tvOrderTime.setText(orderBean.getCreateTime());
                if ("2".equals(orderBean.getIntegralCommodityType())) {
                    binding.rlCouponNumber.setVisibility(View.VISIBLE);
                } else {
                    binding.rlCouponNumber.setVisibility(View.GONE);
                }
                binding.tvCouponNumber.setText(orderBean.getCouponNumber());
            }
        });
    }

    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_credit_order_detail;
    }

    @Override
    public int initVariableId() {
        return BR.creditOrderDetailViewModel;
    }


    @Override
    public CreditOrderDetailViewModel initViewModel() {
        CreditOrderRequest model = new CreditOrderRequest();
        String orderId = getIntent().getStringExtra("orderId");
        return new CreditOrderDetailViewModel(getApplication(), model, orderId);
    }
}
