package com.xx.hbhconsumer.ui.creditorder;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.scwang.smart.refresh.layout.api.RefreshLayout;
import com.scwang.smart.refresh.layout.listener.OnLoadMoreListener;
import com.scwang.smart.refresh.layout.listener.OnRefreshListener;
import com.xx.hbhconsumer.BR;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.CreditOrderAdapter;
import com.xx.hbhconsumer.data.http.requst.CreditOrderRequest;
import com.xx.hbhconsumer.databinding.FragmentCreditOrderListBinding;

import me.goldze.mvvmhabit.base.BaseFragment;

public class CreditOrderListFragment extends BaseFragment<FragmentCreditOrderListBinding, CreditOrderListViewModel> implements OnRefreshListener, OnLoadMoreListener {

    public static CreditOrderListFragment newInstance(Integer orderType) {
        Bundle args = new Bundle();
        args.putInt("orderStatus", orderType);
        CreditOrderListFragment fragment = new CreditOrderListFragment();
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void initData() {

        binding.refresh.setOnRefreshListener(this);
        binding.refresh.setOnLoadMoreListener(this);

        //获取适配器上下文
        CreditOrderAdapter orderListAdapter = new CreditOrderAdapter(getActivity(), viewModel);
        //把adapterset进去
        binding.rvOrderList.setAdapter(orderListAdapter);
        orderListAdapter.setOnItemClick((position, data) -> viewModel.goOrderDetail(data.getBusinessId()));
        viewModel.orderList.observe(this, orderBeanList -> {
            if (orderBeanList == null || orderBeanList.isEmpty()) {
               binding.rlNoData.setVisibility(View.VISIBLE);
               binding.rvOrderList.setVisibility(View.GONE);
            } else {
                binding.rlNoData.setVisibility(View.GONE);
                binding.rvOrderList.setVisibility(View.VISIBLE);
            }
            orderListAdapter.mList = orderBeanList;
            orderListAdapter.notifyDataSetChanged();

            if (viewModel.page == 1) {
                binding.refresh.finishRefresh();
            } else {
                binding.refresh.finishLoadMore();
            }
            if (viewModel.page == viewModel.totalPage) {
                binding.refresh.setEnableLoadMore(false);
            } else {
                binding.refresh.setEnableLoadMore(true);
            }
        });
    }

    @Override
    public int viewModelType() {
        return 1;
    }

    @Override
    public int initContentView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return R.layout.fragment_credit_order_list;
    }

    @Override
    public int initVariableId() {
        return BR.orderListViewModel;
    }

    @Override
    public CreditOrderListViewModel initViewModel() {
        CreditOrderRequest model = new CreditOrderRequest();
        Bundle args = getArguments();
        Integer orderStatus = args.getInt("orderStatus");
        String status = "";
        if (orderStatus == 1) {
            status = "1";
        } else if (orderStatus == 2) {
            status = "0";
        }
        return new CreditOrderListViewModel(getActivity().getApplication(), model, status);
    }

    @Override
    public void onLoadMore(@NonNull RefreshLayout refreshLayout) {
        viewModel.page++;

        if (viewModel.page > viewModel.totalPage) {
//            binding.tvNoMore.setVisibility(View.VISIBLE);
        } else if (viewModel.page == viewModel.totalPage) {
            binding.refresh.setEnableLoadMore(false);
            viewModel.loadData();
//            binding.tvNoMore.setVisibility(View.VISIBLE);
        } else {
            viewModel.loadData();
        }
    }

    @Override
    public void onRefresh(@NonNull RefreshLayout refreshLayout) {
        viewModel.page=1;
        viewModel.loadData();
        binding.refresh.setEnableLoadMore(true);
    }
}
