package com.xx.hbhconsumer.ui.goods;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.Nullable;
import androidx.recyclerview.widget.GridLayoutManager;

import com.xx.hbhconsumer.BR;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.FirstCategoryAdapter;
import com.xx.hbhconsumer.adapter.ThirdCategoryAdapter;
import com.xx.hbhconsumer.data.http.requst.CategoryRequest;
import com.xx.hbhconsumer.databinding.FragmentGoodBinding;
import me.goldze.mvvmhabit.base.BaseFragment;

public class GoodFragment extends BaseFragment<FragmentGoodBinding, GoodViewModel> {


    @Override
    public int viewModelType() {
        return 1;
    }

    @Override
    public int initContentView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return R.layout.fragment_good;
    }

    @Override
    public int initVariableId() {
        return BR.goodViewModel;
    }

    //    重写初始方法调用参数
    @Override
    public void initData() {
        super.initData();
        //获取适配器上下文
        FirstCategoryAdapter firstCategoryAdapter = new FirstCategoryAdapter(getActivity());
        //把adapterset进去
        binding.rvFirstCategoryList.setAdapter(firstCategoryAdapter);
        firstCategoryAdapter.setOnItemClick((position, data) -> {
            viewModel.changeSecondCategoryList(position);
            firstCategoryAdapter.notifyDataSetChanged();
        });
        viewModel.categoryBeanList.observe(this, categoryBeanList -> {
            firstCategoryAdapter.mList = categoryBeanList;
            firstCategoryAdapter.notifyDataSetChanged();
        });


        viewModel.secondBeanList.observe(this, secondBeanList -> {

            if (secondBeanList.isEmpty()) {
                binding.rlNoData.setVisibility(View.VISIBLE);
                binding.tvNoMore.setVisibility(View.GONE);
                binding.rvSecondCategoryList.setVisibility(View.GONE);
            } else {
                binding.rlNoData.setVisibility(View.GONE);
                binding.tvNoMore.setVisibility(View.VISIBLE);
                binding.rvSecondCategoryList.setVisibility(View.VISIBLE);
            }

            //获取适配器上下文
            GridLayoutManager manager = new GridLayoutManager(getActivity(),2);
            binding.rvSecondCategoryList.setLayoutManager(manager);

            //获取适配器上下文
            ThirdCategoryAdapter thirdCategoryAdapter = new ThirdCategoryAdapter(getActivity());

            //把adapterset进去
            binding.rvSecondCategoryList.setAdapter(thirdCategoryAdapter);
            thirdCategoryAdapter.mList = secondBeanList;
            thirdCategoryAdapter.setOnItemClick((position, data) -> {
                viewModel.goGoodsList(data.getCategoryId());
            });
        });
    }

    @Override
    public GoodViewModel initViewModel() {
        CategoryRequest lm = new CategoryRequest();
        return new GoodViewModel(getActivity().getApplication(), lm);
    }
}