package com.xx.hbhconsumer.ui.hbh;

import android.app.Application;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.NewsRequest;
import com.xx.hbhconsumer.data.http.respons.AppInformationBean;

import java.util.LinkedHashSet;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;
import me.goldze.mvvmhabit.utils.StringUtils;

public class HbhViewModel extends BaseViewModel<NewsRequest> {

    public MutableLiveData<LinkedHashSet<String>> newsTypeList = new  MutableLiveData<>(new LinkedHashSet<>());

    public HbhViewModel(@NonNull Application application) {
        super(application);
    }

    public HbhViewModel(@NonNull Application application, NewsRequest model) {
        super(application, model);
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        loadData();
    }

    public void loadData() {
        model.queryAppInformationList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(HbhViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<AppInformationBean>>() {
                    @Override
                    public void onSuccess(List<AppInformationBean> resultBean) {
                        LinkedHashSet<String> result = new LinkedHashSet<>();
                        for (AppInformationBean appInformationBean : resultBean) {
                            if (!StringUtils.isEmpty(appInformationBean.getClassificationId())) {
                                result.add(appInformationBean.getClassificationId() + "," + appInformationBean.getClassificationName());
                            }
                        }
                        newsTypeList.postValue(result);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                });
    }

}
