package com.xx.hbhconsumer.ui.home;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.Nullable;
import androidx.lifecycle.Observer;
import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.LinearLayoutManager;

import com.bumptech.glide.Glide;
import com.xx.hbhconsumer.BR;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.GuessLikeGoodsAdapter;
import com.xx.hbhconsumer.adapter.LowPricedGoodsAdapter;
import com.xx.hbhconsumer.data.http.requst.HomeRequest;
import com.xx.hbhconsumer.data.http.respons.AdvertisingBean;
import com.xx.hbhconsumer.data.http.respons.GuessLikeGoodsBean;
import com.xx.hbhconsumer.data.http.respons.LowPriceGoodsBean;
import com.xx.hbhconsumer.data.local.LocalData;
import com.xx.hbhconsumer.databinding.FragmentHomeBinding;
import com.xx.hbhconsumer.utils.RetrofitClient;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;
import com.youth.banner.indicator.CircleIndicator;
import com.youth.banner.listener.OnBannerListener;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseFragment;

public class HomeFragment extends BaseFragment<FragmentHomeBinding, HomeViewModel> {
    @Override
    public void initData() {
        super.initData();
        binding.banner.addBannerLifecycleObserver(this).setIndicator(new CircleIndicator(requireContext()));
        String affiliatedCompany = LocalData.getAffiliatedCompany();
        if ("1".equals(affiliatedCompany)) {
            binding.tvArea.setText("环渤海河西");
        } else {
            binding.tvArea.setText("环渤海滨海");
        }
        viewModel.areaId.observe(this, new Observer<String>() {
            @Override
            public void onChanged(String areaId) {
                if ("1".equals(areaId)) {
                    binding.tvAreaHexi.setBackground(getContext().getDrawable(R.drawable.bg_button_blue_all_radius_8));
                    binding.tvAreaBinghai.setBackground(getContext().getDrawable(R.drawable.bg_button_grey_all_radius_8));

                    binding.tvAreaHexi.setTextColor(getContext().getColor(R.color.foreground));
                    binding.tvAreaBinghai.setTextColor(getContext().getColor(R.color.price_black));

                    binding.tvArea.setText("环渤海河西");
                } else {
                    binding.tvAreaHexi.setBackground(getContext().getDrawable(R.drawable.bg_button_grey_all_radius_8));
                    binding.tvAreaBinghai.setBackground(getContext().getDrawable(R.drawable.bg_button_blue_all_radius_8));

                    binding.tvAreaHexi.setTextColor(getContext().getColor(R.color.price_black));
                    binding.tvAreaBinghai.setTextColor(getContext().getColor(R.color.foreground));
                    binding.tvArea.setText("环渤海滨海");
                }
            }
        });

        viewModel.chooseAreaFlag.observe(this, new Observer<Boolean>() {
            @Override
            public void onChanged(Boolean chooseAreaFlag) {
                if (chooseAreaFlag) {
                    binding.rlChooseArea.setVisibility(View.VISIBLE);
                    binding.ivChooseAreaIcon.setImageDrawable(getContext().getDrawable(R.mipmap.home_icon_xiajiantou2));
                } else {
                    binding.rlChooseArea.setVisibility(View.GONE);
                    binding.ivChooseAreaIcon.setImageDrawable(getContext().getDrawable(R.mipmap.home_icon_xiajiantou));
                }
            }
        });

        viewModel.hasUnReadMessage.observe(this, new Observer<Boolean>() {
            @Override
            public void onChanged(Boolean hasUnReadMessageFlag) {
                if (hasUnReadMessageFlag) {
                    binding.ivMessage.setImageDrawable(getContext().getDrawable(R.mipmap.wode_icon_xiaoxi2));
                } else {
                    binding.ivMessage.setImageDrawable(getContext().getDrawable(R.mipmap.wode_icon_xiaoxi1));
                }
            }
        });

        viewModel.AdvertisingList.observe(this, new Observer<List<AdvertisingBean>>() {
            @Override
            public void onChanged(List<AdvertisingBean> advertisingBeans) {

                if (advertisingBeans == null || advertisingBeans.isEmpty()) {
                    binding.banner.setVisibility(View.GONE);
                    binding.ivBanner.setVisibility(View.VISIBLE);
                } else {
                    binding.banner.setVisibility(View.VISIBLE);
                    binding.ivBanner.setVisibility(View.GONE);

                    BannerAdapter bannerAdapter=new BannerAdapter(requireContext(), advertisingBeans);
                    binding.banner.setAdapter(bannerAdapter);
                    bannerAdapter.setOnBannerListener(new OnBannerListener<AdvertisingBean>() {
                        @Override
                        public void OnBannerClick(AdvertisingBean data, int position) {
                            if ("0".equals(data.getRotographType())) {
                                viewModel.goGoodsDetail(data.getUrlId());
                            } else if ("1".equals(data.getRotographType())) {
                                viewModel.goShopDetail(data.getUrlId());
                            } else if ("2".equals(data.getRotographType())) {
                                viewModel.goNewsDetail(data.getUrlId());
                            } else if ("3".equals(data.getRotographType())) {
                                viewModel.goPdfDetail(data.getBusinessId(), data.getUrlId(), data.getInformationTitle());
                            }
                        }
                    });
                }
            }
        });


        LowPricedGoodsAdapter lowPricedGoodsAdapter = new LowPricedGoodsAdapter(getActivity());
        LinearLayoutManager layoutManager = new LinearLayoutManager(getActivity());
        layoutManager.setOrientation(LinearLayoutManager.HORIZONTAL);
        binding.rvLowPricedGoods.setLayoutManager(layoutManager);
        //把adapterset进去
        binding.rvLowPricedGoods.setAdapter(lowPricedGoodsAdapter);
        lowPricedGoodsAdapter.setOnItemClick((position, data) -> viewModel.goGoodsDetail(data.getBusinessId()));
        viewModel.LowPriceGoodsList.observe(this, lowPriceGoodsBeanList -> {
            //获取适配器上下文
            if (lowPriceGoodsBeanList.isEmpty()) {
                binding.rvLowPricedGoods.setVisibility(View.GONE);
                binding.rlLowPricedGoods.setVisibility(View.GONE);
            } else {

                binding.rvLowPricedGoods.setVisibility(View.VISIBLE);
                binding.rlLowPricedGoods.setVisibility(View.VISIBLE);

                if (lowPriceGoodsBeanList.size() < 6) {
                    binding.tvMore.setVisibility(View.GONE);
                    binding.ivMore.setVisibility(View.GONE);
                }

                lowPricedGoodsAdapter.mList = lowPriceGoodsBeanList;
                lowPricedGoodsAdapter.notifyDataSetChanged();
            }

        });


        GridLayoutManager manager = new GridLayoutManager(getActivity(),2);
        binding.rvGuessLike.setLayoutManager(manager);
        //获取适配器上下文
        GuessLikeGoodsAdapter rvGuessLikeListAdapter = new GuessLikeGoodsAdapter(getActivity());
        //把adapterset进去
        binding.rvGuessLike.setAdapter(rvGuessLikeListAdapter);
        rvGuessLikeListAdapter.setOnItemClick(new xxBaseRecyclerViewAdapter.OnItemClick<GuessLikeGoodsBean>() {
            @Override
            public void itemClickCalBack(int position, GuessLikeGoodsBean data) {
                viewModel.goGoodsDetail(data.getBusinessId());
            }
        });
        viewModel.GuessLikeGoodsList.observe(this, guessLikeGoodsBeanList -> {
            //获取适配器上下文
            if (guessLikeGoodsBeanList.isEmpty()) {
                binding.rvGuessLike.setVisibility(View.GONE);
                binding.rlGuessLike.setVisibility(View.GONE);
            } else {
                binding.rvGuessLike.setVisibility(View.VISIBLE);
                binding.rlGuessLike.setVisibility(View.VISIBLE);
                rvGuessLikeListAdapter.mList = guessLikeGoodsBeanList;
                rvGuessLikeListAdapter.notifyDataSetChanged();
            }
        });

        viewModel.homeActivityBean.observe(this, homeActivityBean -> {
            if (homeActivityBean == null) {
                binding.llActivity.setVisibility(View.GONE);
            } else {
                binding.llActivity.setVisibility(View.VISIBLE);
                Glide.with(this).load(RetrofitClient.baseImgUrl + homeActivityBean.getActivityCover())
                        .into(binding.ivActivity);
            }
        });
    }

    @Override
    public int viewModelType() {
        return 1;
    }

    @Override
    public int initContentView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return R.layout.fragment_home;
    }

    @Override
    public int initVariableId() {
        return BR.homeViewModel;
    }

    @Override
    public HomeViewModel initViewModel() {
        HomeRequest lm = new HomeRequest();
        return new HomeViewModel(getActivity().getApplication(), lm);
    }
}
