package com.xx.hbhconsumer.ui.hotsales;

import android.os.Bundle;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.lifecycle.Observer;

import com.scwang.smart.refresh.layout.api.RefreshLayout;
import com.scwang.smart.refresh.layout.listener.OnLoadMoreListener;
import com.scwang.smart.refresh.layout.listener.OnRefreshListener;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.HotSalesGoodsAdapter;
import com.xx.hbhconsumer.adapter.HotSalesTop3GoodsAdapter;
import com.xx.hbhconsumer.data.http.requst.HotSalesRequest;
import com.xx.hbhconsumer.data.http.respons.HotSalesBean;
import com.xx.hbhconsumer.databinding.ActivityHotSalesBinding;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;

public class HotSalesActivity extends BaseActivity<ActivityHotSalesBinding, HotSalesViewModel> implements OnRefreshListener, OnLoadMoreListener {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_hot_sales;
    }

    @Override
    public int initVariableId() {
        return BR.hotSalesViewModel;
    }

    @Override
    public void initData() {
        super.initData();
        binding.refresh.setOnRefreshListener(this);
        binding.refresh.setOnLoadMoreListener(this);

        HotSalesTop3GoodsAdapter hotSalesTop3GoodsAdapter = new HotSalesTop3GoodsAdapter(HotSalesActivity.this);
        HotSalesGoodsAdapter hotSalesGoodsAdapter = new HotSalesGoodsAdapter(HotSalesActivity.this);
        binding.rvGoodsTop3List.setAdapter(hotSalesTop3GoodsAdapter);
        binding.rvGoodsList.setAdapter(hotSalesGoodsAdapter);
        hotSalesTop3GoodsAdapter.setOnItemClick((position, data) -> viewModel.goShopGoodsDetail(data.getBusinessId()));
        hotSalesGoodsAdapter.setOnItemClick((position, data) -> viewModel.goShopGoodsDetail(data.getBusinessId()));
        viewModel.hotSalesList.observe(this, new Observer<List<HotSalesBean>>() {
            @Override
            public void onChanged(List<HotSalesBean> hotSalesBeanList) {

                if (hotSalesBeanList.isEmpty()) {
                    binding.refresh.setEnableLoadMore(false);
                } else {
                    binding.refresh.setEnableLoadMore(true);
                }

                if (hotSalesBeanList.isEmpty()) {
                    binding.llNoData.setVisibility(View.VISIBLE);
                    binding.rvGoodsList.setVisibility(View.GONE);
                } else {
                    binding.llNoData.setVisibility(View.GONE);
                    binding.rvGoodsList.setVisibility(View.VISIBLE);
                }

                if (hotSalesBeanList.size() <= 3) {
                    hotSalesTop3GoodsAdapter.mList = hotSalesBeanList;
                    hotSalesTop3GoodsAdapter.notifyDataSetChanged();

                    if (hotSalesBeanList.isEmpty()) {
                        binding.llNoData.setVisibility(View.VISIBLE);
                        binding.rvGoodsList.setVisibility(View.GONE);
                    } else {
                        binding.llNoData.setVisibility(View.GONE);
                        binding.rvGoodsList.setVisibility(View.VISIBLE);
                    }

                    if (viewModel.page == 1) {
                        binding.refresh.finishRefresh();
                    } else {
                        binding.refresh.finishLoadMore();
                    }

                } else {
                    hotSalesTop3GoodsAdapter.mList = hotSalesBeanList.subList(0, 3);
                    hotSalesTop3GoodsAdapter.notifyDataSetChanged();
                    hotSalesGoodsAdapter.mList = hotSalesBeanList.subList(3, hotSalesBeanList.size());
                    hotSalesGoodsAdapter.notifyDataSetChanged();
                    if (viewModel.page == 1) {
                        binding.refresh.finishRefresh();
                    } else {
                        binding.refresh.finishLoadMore();
                    }

                    if (viewModel.page == viewModel.totalPage) {
                        binding.refresh.setEnableLoadMore(false);
                        binding.tvNoMore.setVisibility(View.VISIBLE);
                    }
                }

            }
        });

    }

    @Override
    public HotSalesViewModel initViewModel() {
        HotSalesRequest lm = new HotSalesRequest();
        return new HotSalesViewModel(getApplication(), lm);
    }

    @Override
    public void onLoadMore(@NonNull RefreshLayout refreshLayout) {
        viewModel.page++;
        if (viewModel.page > viewModel.totalPage) {
            binding.tvNoMore.setVisibility(View.VISIBLE);
        } else if (viewModel.page == viewModel.totalPage) {
            binding.refresh.setEnableLoadMore(false);
            viewModel.loadData();
        } else {
            viewModel.loadData();
        }

    }

    @Override
    public void onRefresh(@NonNull RefreshLayout refreshLayout) {
        viewModel.page=1;
        viewModel.loadData();
        binding.refresh.setEnableLoadMore(true);
    }
}
