package com.xx.hbhconsumer.ui.login;

import static me.goldze.mvvmhabit.utils.Utils.Interceptor_TOKEN;
import static me.goldze.mvvmhabit.utils.Utils.getContext;

import android.Manifest;
import android.app.Application;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.text.Html;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.core.content.FileProvider;
import androidx.databinding.ObservableField;
import androidx.lifecycle.MutableLiveData;

import com.tbruyelle.rxpermissions3.RxPermissions;
import com.xx.hbhconsumer.data.http.requst.LoginRequest;
import com.xx.hbhconsumer.data.http.respons.CollectionBean;
import com.xx.hbhconsumer.data.http.respons.UserInfoBean;
import com.xx.hbhconsumer.data.http.respons.VersionBean;
import com.xx.hbhconsumer.data.local.LocalData;
import com.xx.hbhconsumer.data.staticdata.StaticData;
import com.xx.hbhconsumer.ui.main.MainActivity;
import com.xx.hbhconsumer.ui.privacyclause.PrivacyClauseActivity;
import com.xx.hbhconsumer.ui.pwd.ForgetPwdActivity;
import com.xx.hbhconsumer.ui.pwd.PwdActivity;
import com.xx.hbhconsumer.ui.register.RegisterActivity;
import com.xx.hbhconsumer.ui.useragreement.UserAgreementActivity;
import com.xx.hbhconsumer.utils.RetrofitClient;
import com.xx.xxviewlibrary.comm.CommTextDialog;
import com.xx.xxviewlibrary.comm.RefuseDialogBean;
import com.xx.xxviewlibrary.utils.CommUtilsKt;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.core.Observer;
import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import io.reactivex.rxjava3.schedulers.Schedulers;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;
import me.goldze.mvvmhabit.utils.StringUtils;
import me.goldze.mvvmhabit.utils.ToastUtils;
import okhttp3.ResponseBody;

public class LoginViewModel extends BaseViewModel<LoginRequest> {
    RxPermissions rxPermissions;
    public MutableLiveData<Boolean> consentAgreementFlag = new  MutableLiveData<>(false);
    //用户名的绑定
    public ObservableField<String> userName = new ObservableField<>("");
    //密码的绑定
    public ObservableField<String> password = new ObservableField<>("");

    public MutableLiveData<String> openInstall=new MutableLiveData<>("");

    /*隐私条款字段*/
    public MutableLiveData<String> agreeContent = new MutableLiveData<>(null);
    public boolean isAgree = false;
    public LoginViewModel(@NonNull Application application, LoginRequest model) {
        super(application, model);
    }

    @Override
    public void onCreate() {
        super.onCreate();
        String token = LocalData.getToken();
        if (!StringUtils.isEmpty(token)) {
            Interceptor_TOKEN = token;
            getuserInfo();
        }
    }
    /**
     * 获取协议内容
     *
     */
    public void getProtocols()
    {
        model.getProtocols().compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                .doOnSubscribe(LoginViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<String>>() {

                    @Override
                    public void onSuccess(List<String> resultBean) {
                        StaticData.Protocols=resultBean;
                        if (StaticData.Protocols.size()>=3)
                        {
                            Bundle bundle= new Bundle();
                            bundle.putString("title", "隐私条款");
                            bundle.putString("URL", RetrofitClient.baseH5Url + StaticData.Protocols.get(2));
                            Log.v("路径路径啊",bundle.toString());
                            CharSequence htmlText = Html.fromHtml(bundle.toString());
                            /*为隐私条款赋值*/
                            agreeContent.setValue(htmlText.toString());
                        }
                    }

                    @Override
                    public void onError(String Error) {

                    }
                });

    }
    //跳转开店页面
    public BindingCommand goMerchantEnter = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            Bundle bundle=new Bundle();
//            bundle.putInt("pageStep", R.id.registerMaterialFragment);
//            startActivity(MerchantEnterActivity.class,bundle);
        }
    });

    public BindingCommand consentAgreement = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            if (consentAgreementFlag.getValue()) {
                consentAgreementFlag.postValue(false);
            } else {
                consentAgreementFlag.postValue(true);
            }

        }

    });


    public BindingCommand goPrivacyClause = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            Bundle bundle = new Bundle();
            bundle.putString("basic", "14");
            bundle.putString("basicName", "隐私条款");
            startActivity(UserAgreementActivity.class, bundle);
        }

    });

    public BindingCommand goUserAgreement = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            Bundle bundle = new Bundle();
            bundle.putString("basicName", "用户协议");
            bundle.putString("basic", "10");
            startActivity(UserAgreementActivity.class, bundle);
        }

    });

    //跳转首页
    public BindingCommand goRegister = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(RegisterActivity.class);
        }

    });

    //跳转忘记密码
    public BindingCommand forgetPwd = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(ForgetPwdActivity.class);
        }

    });
    //登陆
    public BindingCommand login = new BindingCommand(new BindingAction() {
        @Override
        public void call() {

            if (TextUtils.isEmpty(userName.get().toString())) {
                ToastUtils.showShort("请输入账号！");
            }else if (TextUtils.isEmpty(password.get().toString())) {
                ToastUtils.showShort("请输入密码！");
            }else if (!consentAgreementFlag.getValue()) {
                ToastUtils.showShort("请勾选同意协议");
            }else {
//                model.Login(/*userName.get().toString(), password.get().toString()*/"18622655123","Aa123456")
                model.Login(userName.get().toString(), password.get().toString())
                        .compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                        .doOnSubscribe(LoginViewModel.this)
                        .doOnSubscribe(new Consumer<Disposable>() {
                            @Override
                            public void accept(Disposable disposable) throws Exception {
                                showDialog("正在请求...");
                            }
                        }).subscribe(new ApiDisposableObserver<String>() {
                            @Override
                            public void onSuccess(String resultBean) {
                                //是指token
                                Interceptor_TOKEN = "Bearer " + resultBean;
                                SharedPreferences sharedPreferences = getContext().getSharedPreferences("AppNamePreferences", Context.MODE_PRIVATE);
                                SharedPreferences.Editor editor = sharedPreferences.edit();
                                editor.putString("username", userName.get());
                                editor.putString("password", password.get());
                                editor.putString("token", Interceptor_TOKEN);
                                editor.apply();
                                getuserInfo();
                            }

                            @Override
                            public void onError(String Error) {
                                dismissDialog();
                            }

                        });
            }
        }
    });



    public void getuserInfo()
    {
        model.getUserInfo()
                .compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                .doOnSubscribe(LoginViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<UserInfoBean>() {
                    @Override
                    public void onSuccess(UserInfoBean resultBean) {
                        LocalData.saveToken(Interceptor_TOKEN);
                        //将用户信息存储到本地
                        LocalData.saveUser(resultBean.getUser());
                        dismissDialog();
                        if (resultBean.getUser().getNeedChangeTimeLongPassword()) {
                            Bundle bundle = new Bundle();
                            bundle.putBoolean("needChangeTimeLongPassword", true);
                            startActivity(PwdActivity.class, bundle);
                            finish();
                        } else {
                            startActivity(MainActivity.class);
                            finish();
                        }



                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }

    /**
     * 获取最新APK版本号
     *
     * @param view
     */
    public void checkVersion(View view) {
        Log.v("版本更新", "版本更新");
        model.checkVersion().compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(LoginViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<VersionBean>() {

                    @Override
                    public void onSuccess(VersionBean resultBean) {
                        /*强制更新标识位变更--重置用户登录*/
                        StaticData.updateLogin = 1;
                        Log.v("当前版本号", resultBean.getAppVersion());
                        StaticData.appVersionNumber = resultBean.getAppVersion();
                        if (CommUtilsKt.checkVersionUpdata(CommUtilsKt.getVersion(view.getContext()), resultBean.getAppVersion())) {
                            if (resultBean.getPushFlag().equals("1")) {
                                showCommTextDialog(new RefuseDialogBean("有新版本,是否更新?", "去更新", null, "更新提示"), new CommTextDialog.onAcceptCallBack() {
                                    @Override
                                    public void refuseBack() {
                                        finish();
                                    }

                                    @Override
                                    public void acceptBack() {
                                        /*强制更新标识位变更--禁止用户登录*/
                                        StaticData.updateLogin = 0;
                                        rxPermissions
                                                .request(Manifest.permission.WRITE_EXTERNAL_STORAGE)
                                                .subscribe(granted -> {
                                                    if (granted) {
                                                        // 处理权限已授予的情况
                                                        updataApk(view.getContext(), resultBean.getVersionFile(), view.getContext().getFilesDir().getPath() + resultBean.getVersionFile().substring(
                                                                resultBean.getVersionFile().lastIndexOf("/")));
                                                    } else {
                                                        // 处理权限被拒绝的情况
                                                        ToastUtils.showShort("请开启文件相关权限");
                                                    }
                                                });

                                    }
                                });
                            } else {
                                showCommTextDialog(new RefuseDialogBean("有新版本,是否更新?", "去更新", "取消", "更新提示"), new CommTextDialog.onAcceptCallBack() {
                                    @Override
                                    public void refuseBack() {
                                        /*强制更新标识位变更--重置用户登录*/
                                        StaticData.updateLogin = 1;
                                    }

                                    @Override
                                    public void acceptBack() {
                                        /*强制更新标识位变更--可以用户登录*/
                                        StaticData.updateLogin = 0;
                                        rxPermissions
                                                .request(Manifest.permission.WRITE_EXTERNAL_STORAGE)
                                                .unsubscribeOn(Schedulers.io()) // 使订阅不可取消
                                                .subscribe(granted -> {
                                                    if (granted) {
                                                        updataApk(view.getContext(), resultBean.getVersionFile(), view.getContext().getFilesDir().getPath() + resultBean.getVersionFile().substring(
                                                                resultBean.getVersionFile().lastIndexOf("/")));
                                                    } else {
                                                        ToastUtils.showShort("请开启文件相关权限");
                                                    }
                                                });
                                    }
                                });
                            }

                        } else {
                            /*强制更新标识位变更--重置用户登录*/
                            StaticData.updateLogin = 1;
                        }


                    }

                    @Override
                    public void onError(String Error) {

                        /*强制更新标识位变更--重置用户登录*/
                        StaticData.updateLogin = 1;
                    }
                });
    }

    /**
     * 下载APK
     *
     * @param context
     * @param url     　下载地址
     * @param name    　文件名字
     */
    public void updataApk(Context context, String url, String name) {
        /*执行传参方法*/
        showDialog("正在下载...");

        model.downFile(url, name).subscribe(new Observer<ResponseBody>() {
            @Override
            public void onSubscribe(@io.reactivex.rxjava3.annotations.NonNull Disposable d) {
                Log.e("下载", "onSubscribe");

            }

            @Override
            public void onNext(@io.reactivex.rxjava3.annotations.NonNull ResponseBody responseBody) {

            }

            @Override
            public void onError(@io.reactivex.rxjava3.annotations.NonNull Throwable e) {
                ToastUtils.showShort("下载失败");
                dismissDialog();
            }

            @Override
            public void onComplete() {
                Log.e("下载要成功", "onComplete");
                dismissDialog();
                ToastUtils.showShort("下载成功");
                installApk(context, name);
            }
        });
    }

    //跳转安装ＡＰＰ
    private void installApk(Context context, String path) {
        Intent intent = new Intent(Intent.ACTION_VIEW);
        intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        File file = new File(Uri.parse(path).getPath());
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
            intent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION);
            Uri uri = FileProvider.getUriForFile(context, "com.xx.hbhconsumer.fileProvider", file);
            intent.setDataAndType(uri, "application/vnd.android.package-archive");
        } else {
            intent.setDataAndType(Uri.fromFile(file), "application/vnd.android.package-archive");
        }
        context.startActivity(intent);

    }
}


