package com.xx.hbhconsumer.ui.logoff;

import android.app.Application;
import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.ForgetPwdRequest;

import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.utils.StringUtils;
import me.goldze.mvvmhabit.utils.ToastUtils;

public class LogoffFirstStepViewModel extends BaseViewModel<ForgetPwdRequest> {
    public ObservableField<String> otherReason = new ObservableField<>("");
    public MutableLiveData<Integer> logoffType = new MutableLiveData<>();
    public LogoffFirstStepViewModel(@NonNull Application application) {
        super(application);
    }

    public LogoffFirstStepViewModel(@NonNull Application application, ForgetPwdRequest model) {
        super(application, model);
    }

    // 跳转登录页
    public BindingCommand next = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            if (logoffType == null || logoffType.getValue() == null) {
                ToastUtils.showShort("请选择注销原因");
                return;
            }

            if (logoffType.getValue() == 3 && StringUtils.isEmpty(otherReason.get())) {
                ToastUtils.showShort("请填写注销原因");
            } else {
                Bundle bundle=new Bundle();
                bundle.putString("accountClosureReason", otherReason.get());
                bundle.putString("accountClosureMark", logoffType.getValue().toString());
                startActivity(LogoffSecondStepActivity.class, bundle);
            }
        }

    });


    // 跳转登录页
    public BindingCommand selectUnbindPhone = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            logoffType.postValue(1);
        }

    });

    public BindingCommand selectSecurityReason = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            logoffType.postValue(2);
        }

    });

    public BindingCommand selectOther = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            logoffType.postValue(3);
        }

    });
}
