package com.xx.hbhconsumer.ui.logoff;

import static me.goldze.mvvmhabit.utils.Utils.Interceptor_TOKEN;

import android.app.Application;
import android.content.Intent;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.LogoffRequest;
import com.xx.hbhconsumer.data.local.LocalData;
import com.xx.hbhconsumer.ui.login.LoginActivity;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;
import me.goldze.mvvmhabit.utils.ToastUtils;

public class LogoffSecondStepViewModel extends BaseViewModel<LogoffRequest> {
    String accountClosureMark;
    String accountClosureReason;

    public MutableLiveData<Boolean> logoutFlag = new MutableLiveData<>(false);

    public LogoffSecondStepViewModel(@NonNull Application application) {
        super(application);
    }

    public LogoffSecondStepViewModel(@NonNull Application application, LogoffRequest model, String accountClosureReason, String accountClosureMark) {
        super(application, model);
        this.accountClosureReason = accountClosureReason;
        this.accountClosureMark = accountClosureMark;
    }

    // 触发确认按钮
    public BindingCommand confirm = new BindingCommand(new BindingAction() {
        @Override
        public void call() {

            model.logoff(accountClosureReason, accountClosureMark)
                    .compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                    .doOnSubscribe(LogoffSecondStepViewModel.this)
                    .doOnSubscribe(new Consumer<Disposable>() {
                        @Override
                        public void accept(Disposable disposable) throws Exception {

                        }
                    }).subscribe(new ApiDisposableObserver<Boolean>() {
                        @Override
                        public void onSuccess(Boolean resultBean) {
                            ToastUtils.showShort("注销成功");
                            LocalData.delAllData();
                            logoutFlag.postValue(true);
                        }

                        @Override
                        public void onError(String Error) {
                            dismissDialog();
                        }

                    });

        }

    });
}