package com.xx.hbhconsumer.ui.lowprice;

import android.os.Bundle;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.GridLayoutManager;

import com.scwang.smart.refresh.layout.api.RefreshLayout;
import com.scwang.smart.refresh.layout.listener.OnLoadMoreListener;
import com.scwang.smart.refresh.layout.listener.OnRefreshListener;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.LowPriceNomalGoodsAdapter;
import com.xx.hbhconsumer.data.http.requst.HomeRequest;
import com.xx.hbhconsumer.databinding.ActivityLowPriceBinding;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;

public class LowPriceActivity extends BaseActivity<ActivityLowPriceBinding, LowPriceViewModel> implements OnRefreshListener, OnLoadMoreListener {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_low_price;
    }

    @Override
    public int initVariableId() {
        return BR.lowPriceViewModel;
    }

    @Override
    public void initData() {
        super.initData();
        binding.refresh.setOnRefreshListener(this);
        binding.refresh.setOnLoadMoreListener(this);
        GridLayoutManager manager = new GridLayoutManager(LowPriceActivity.this,2);
        binding.rvGoodsList.setLayoutManager(manager);

        LowPriceNomalGoodsAdapter orderListAdapter = new LowPriceNomalGoodsAdapter(LowPriceActivity.this);

        binding.rvGoodsList.setAdapter(orderListAdapter);
        orderListAdapter.setOnItemClick((position, data) -> viewModel.goGoodsDetail(data.getBusinessId()));
        viewModel.newCommodityList.observe(this, collectionBeanList -> {
            orderListAdapter.mList = collectionBeanList;
            orderListAdapter.notifyDataSetChanged();
            if (viewModel.page == 1) {
                binding.refresh.finishRefresh();
            } else {
                binding.refresh.finishLoadMore();
            }
            if (viewModel.page == viewModel.totalPage) {
                binding.refresh.setEnableLoadMore(false);
            } else {
                binding.refresh.setEnableLoadMore(true);
            }
        });
    }

    @Override
    public LowPriceViewModel initViewModel() {
        HomeRequest lm = new HomeRequest();
        return new LowPriceViewModel(getApplication(), lm);
    }

    @Override
    public void onLoadMore(@NonNull RefreshLayout refreshLayout) {
        viewModel.page++;

        if (viewModel.page > viewModel.totalPage) {
            binding.tvNoMore.setVisibility(View.VISIBLE);
        } else if (viewModel.page == viewModel.totalPage) {
            binding.refresh.setEnableLoadMore(false);
            viewModel.loadData();
            binding.tvNoMore.setVisibility(View.VISIBLE);
        } else {
            viewModel.loadData();
        }
    }

    @Override
    public void onRefresh(@NonNull RefreshLayout refreshLayout) {
        viewModel.page=1;
        viewModel.loadData();
        binding.refresh.setEnableLoadMore(true);
    }
}
