package com.xx.hbhconsumer.ui.map;

import android.app.Application;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.MapRequest;
import com.xx.hbhconsumer.data.http.respons.DictValueBean;
import com.xx.hbhconsumer.data.http.respons.YearBean;
import com.xx.hbhconsumer.data.local.LocalData;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;
import me.goldze.mvvmhabit.utils.StringUtils;
import me.goldze.mvvmhabit.utils.ToastUtils;

public class MapViewModel extends BaseViewModel<MapRequest> {

    public MutableLiveData<Boolean> checkMapFlag = new MutableLiveData<>(false);
    public MutableLiveData<String> mapId = new MutableLiveData<>("");
    public MutableLiveData<String> region = new MutableLiveData<>("");
    public MutableLiveData<List<DictValueBean>> mapList = new MutableLiveData<>(new ArrayList<>());

    public String maptyep="";


    public MapViewModel(@NonNull Application application) {
        super(application);
    }

    public MapViewModel(@NonNull Application application, MapRequest model) {
        super(application, model);
    }

    @Override
    public void onCreate() {
        super.onCreate();
        loadList();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
    }

    private void loadList() {
        model.getDictValueByDictType("owning_region")
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MapViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<DictValueBean>>() {
                    @Override
                    public void onSuccess(List<DictValueBean> recruitBeans) {
                        List<DictValueBean> newList = new ArrayList<>();
                        for (DictValueBean dictValueBean : recruitBeans) {
                            if (LocalData.getAffiliatedCompany().equals("2") && dictValueBean.getDictLabel().equals("滨海宏达公司")) {
                                if (dictValueBean.getDictValue().equals(maptyep))
                                {
                                    dictValueBean.setChecked(true);
                                    checkMap(dictValueBean);
                                }
                                newList.add(dictValueBean);

                            } else if (!dictValueBean.getDictLabel().equals("滨海宏达公司")) {
                                if (!StringUtils.isEmpty(dictValueBean.getRemark())) {
                                    if (dictValueBean.getDictValue().equals(maptyep))
                                    {
                                        dictValueBean.setChecked(true);
                                        checkMap(dictValueBean);
                                    }
                                    newList.add(dictValueBean);
                                }
                            }
                        }
                        if (newList.isEmpty()) {
                            ToastUtils.showShort("暂无地图数据");
                        }
                        mapList.postValue(newList);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }
                });
    }

    public BindingCommand closeCheckMap = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            checkMapFlag.postValue(false);
        }
    });

    public void checkMap(DictValueBean data) {

        List<DictValueBean> list = new ArrayList<>();
        for (DictValueBean yearBean : mapList.getValue()) {
            if (data.getDictLabel().equals(yearBean.getDictLabel())) {
                yearBean.setChecked(true);
            } else {
                yearBean.setChecked(false);
            }
            list.add(yearBean);
        }
        mapList.postValue(list);

        region.postValue(data.getDictLabel());
        mapId.postValue(data.getRemark());
        checkMapFlag.postValue(false);
    }

    public BindingCommand checkMap = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            checkMapFlag.postValue(!checkMapFlag.getValue());
        }
    });

}
