package com.xx.hbhconsumer.ui.messagecenter;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.scwang.smart.refresh.layout.api.RefreshLayout;
import com.scwang.smart.refresh.layout.listener.OnLoadMoreListener;
import com.scwang.smart.refresh.layout.listener.OnRefreshListener;
import com.xx.hbhconsumer.BR;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.MessageAdapter;
import com.xx.hbhconsumer.data.http.requst.MessageRequest;
import com.xx.hbhconsumer.databinding.FragmentMessageListBinding;

import me.goldze.mvvmhabit.base.BaseFragment;

public class MessageListFragment extends BaseFragment<FragmentMessageListBinding, MessageListViewModel> implements OnRefreshListener, OnLoadMoreListener {

    public static MessageListFragment newInstance(Integer flag) {
        Bundle args = new Bundle();
        args.putInt("flag", flag);
        MessageListFragment fragment = new MessageListFragment();
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void initData() {

        binding.refresh.setOnRefreshListener(this);
        binding.refresh.setOnLoadMoreListener(this);

        //获取适配器上下文
        MessageAdapter messageAdapter = new MessageAdapter(getActivity());

        //把adapterset进去
        binding.rvMessageList.setAdapter(messageAdapter);


        messageAdapter.setOnItemClick((position, data) -> viewModel.goMessageDetail(data));
        viewModel.messageBeanList.observe(this, messageBeanList -> {
            if (messageBeanList == null || messageBeanList.isEmpty()) {
                binding.llNoData.setVisibility(View.VISIBLE);
                binding.rvMessageList.setVisibility(View.GONE);
            } else {
                binding.llNoData.setVisibility(View.GONE);
                binding.rvMessageList.setVisibility(View.VISIBLE);
            }
            if (viewModel.page == 1) {
                binding.refresh.finishRefresh();
            } else {
                binding.refresh.finishLoadMore();
            }
            if (viewModel.page == viewModel.totalPage) {
                binding.refresh.setEnableLoadMore(false);
            } else {
                binding.refresh.setEnableLoadMore(true);
            }
            messageAdapter.mList = messageBeanList;
            messageAdapter.notifyDataSetChanged();
        });
    }

    @Override
    public int viewModelType() {
        return 1;
    }

    @Override
    public int initContentView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return R.layout.fragment_message_list;
    }

    @Override
    public int initVariableId() {
        return BR.messageListViewModel;
    }

    @Override
    public MessageListViewModel initViewModel() {
        MessageRequest model = new MessageRequest();
        Bundle args = getArguments();
        Integer flag = args.getInt("flag");
        return new MessageListViewModel(getActivity().getApplication(), model, flag);
    }

    @Override
    public void onLoadMore(@NonNull RefreshLayout refreshLayout) {
        viewModel.page++;
        if (viewModel.page > viewModel.totalPage) {
            binding.tvNoMore.setVisibility(View.VISIBLE);
        } else if (viewModel.page == viewModel.totalPage) {
            binding.refresh.setEnableLoadMore(false);
            viewModel.getMessageList();
            binding.tvNoMore.setVisibility(View.VISIBLE);
        } else {
            viewModel.getMessageList();
        }
    }

    @Override
    public void onRefresh(@NonNull RefreshLayout refreshLayout) {
        viewModel.page=1;
        viewModel.getMessageList();
        binding.refresh.setEnableLoadMore(true);
    }
}
