package com.xx.hbhconsumer.ui.messagecenter;

import android.app.Application;
import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.google.gson.Gson;
import com.xx.hbhconsumer.data.http.requst.MessageRequest;
import com.xx.hbhconsumer.data.http.respons.ActivityCouponBean;
import com.xx.hbhconsumer.data.http.respons.MessageBean;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class MessageListViewModel extends BaseViewModel<MessageRequest> {
    public int page = 1;
    public int totalPage = 1;
    private Integer flag;

    public MutableLiveData<List<MessageBean>> messageBeanList = new MutableLiveData<>(new ArrayList<>());
    public MessageListViewModel(@NonNull Application application, MessageRequest model, Integer flag) {
        super(application, model);
        this.flag = flag;
    }
    public void goMessageDetail(MessageBean data) {
        messageUnread(data);
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        getMessageList();
    }

    private void messageUnread(MessageBean data) {
        model.messageUnread(data.getBusinessId())
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MessageListViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<Integer>() {
                    @Override
                    public void onSuccess(Integer resultBean) {
                        Bundle bundle = new Bundle();
                        bundle.putString("messageData", new Gson().toJson(data));
                        startActivity(MessageDetailActivity.class, bundle);
                    }
                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }
                });
    }


    public void getMessageList() {
        model.getMessageList(flag, page)
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MessageListViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<MessageBean>() {
                    @Override
                    public void onSuccess(List<MessageBean> resultBean) {

                        if (page == 1) {
                            messageBeanList.postValue(resultBean);
                        } else {
                            List<MessageBean> messageBeans = messageBeanList.getValue();
                            messageBeans.addAll(resultBean);
                            messageBeanList.postValue(messageBeans);
                        }
                    }
                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }
                    @Override
                    public void getTotal(int total) {
                        totalPage = (total - 1) / 10 + 1;
                    }

                });
    }

}


