package com.xx.hbhconsumer.ui.mine;

import android.app.Application;
import android.os.Bundle;
import android.util.Log;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;
import androidx.lifecycle.LiveData;
import androidx.lifecycle.MutableLiveData;

import com.huantansheng.easyphotos.callback.SelectCallback;
import com.huantansheng.easyphotos.models.album.entity.Photo;
import com.xx.hbhconsumer.data.http.requst.MineRequest;
import com.xx.hbhconsumer.data.http.respons.CollectionBean;
import com.xx.hbhconsumer.data.http.respons.Filebean;
import com.xx.hbhconsumer.data.http.respons.MemberInfoBean;
import com.xx.hbhconsumer.data.http.respons.MessageBean;
import com.xx.hbhconsumer.data.http.respons.UserBean;
import com.xx.hbhconsumer.data.http.respons.UserInfoBean;
import com.xx.hbhconsumer.data.local.LocalData;
import com.xx.hbhconsumer.ui.credit.MyCreditActivity;
import com.xx.hbhconsumer.ui.creditorder.CreditOrderActivity;
import com.xx.hbhconsumer.ui.messagecenter.MessageCenterActivity;
import com.xx.hbhconsumer.ui.mycollection.MyCollectionActivity;
import com.xx.hbhconsumer.ui.mycoupon.MyCouponActivity;
import com.xx.hbhconsumer.ui.order.OrderActivity;
import com.xx.hbhconsumer.ui.park.MyParkActivity;
import com.xx.hbhconsumer.ui.settings.SettingsActivity;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;
import me.goldze.mvvmhabit.utils.ToastUtils;

public class MineViewModel extends BaseViewModel<MineRequest> {
    //头像的绑定
    public MutableLiveData<String> avatarImageUrl = new MutableLiveData<>();
    public MutableLiveData<CollectionBean> collectionBean = new MutableLiveData<>(null);
    //昵称的绑定
    public MutableLiveData<Boolean> nickNameEditFlag = new MutableLiveData<>(false);
    public ObservableField<String> nickName = new ObservableField<>("");
    public MutableLiveData<Integer> integralTotal = new MutableLiveData<>(0);
    public MutableLiveData<String> memberCoupon = new MutableLiveData<>("0");
    public MutableLiveData<String> memberName = new MutableLiveData<>("0");
    //创建时间的绑定
    public ObservableField<String> createTime = new ObservableField<>("");
    //职位的绑定
    public ObservableField<String> roleName = new ObservableField<>("");
    public MutableLiveData<UserBean> userBean = new MutableLiveData<>(null);

    public MutableLiveData<Boolean> hasUnReadMessage = new MutableLiveData<>(false);

    ChangeAvatarDialog changeAvatarDialog;
    /*获取会员头像路径*/
    File file = new File("");

    public MineViewModel(@NonNull Application application) {
        super(application);
    }

    public MineViewModel(@NonNull Application application, MineRequest model) {
        super(application, model);
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();

        getUserInfo();
        memberInfo();
        getMessageList();
        memberCollectionList();
    }

    public void changeAvatar(View view) {
        changeAvatarDialog = new ChangeAvatarDialog(view.getContext(), this);
        changeAvatarDialog.show();
    }

    public BindingCommand editNickname = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            nickNameEditFlag.postValue(!nickNameEditFlag.getValue());
            if (nickNameEditFlag.getValue()) {
                updateUser();
            }
        }

    });

    public void choosePhoto() {
        startPhotoPage(true,"申请的是摄像头和照片视频读取权限，用于设置头像", new SelectCallback() {
            @Override
            public void onResult(ArrayList<Photo> photos, boolean isOriginal) {
                file = new File(photos.get(0).path);
                model.upLoadFile(file).compose(RxUtils.schedulersTransformer()) //线程调度
                        .doOnSubscribe(MineViewModel.this)
                        .doOnSubscribe(new Consumer<Disposable>() {
                            @Override
                            public void accept(Disposable disposable) throws Exception {
//                                showDialog("请稍等");
                            }
                        }).subscribe(new ApiDisposableObserver<List<Filebean>>() {
                            @Override
                            public void onSuccess(List<Filebean> resultBean) {
                                changeAvatarDialog.dismiss();
                                dismissDialog();
                                uploadPicture(resultBean.get(0).getBusinessId());
                            }

                            @Override
                            public void onError(String Error) {
                                dismissDialog();
                            }


                        });
            }

            @Override
            public void onCancel() {

            }
        });
    }

    private void uploadPicture(String memberPicture) {
        model.uploadPicture(memberPicture).compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MineViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<Integer>() {
                    @Override
                    public void onSuccess(Integer resultBean) {
                        dismissDialog();
                        ToastUtils.showShort("修改成功");
                        /*最后执行这个*/
                        memberInfo();
                        getUserInfo();
                        changeAvatarDialog.dismiss();
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }

    public void getUserInfo() {
        model.getUserInfo()
                .compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                .doOnSubscribe(MineViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<UserInfoBean>() {
                    @Override
                    public void onSuccess(UserInfoBean resultBean) {
                        //将用户信息存储到本地
                        LocalData.saveUser(resultBean.getUser());
                        userBean.postValue(resultBean.getUser());
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }

    public void updateUser() {
        model.updateUser(nickName.get(), userBean.getValue().getPhonenumber(), userBean.getValue().getUserId(), userBean.getValue().getSex())
                .compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                .doOnSubscribe(MineViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<String>() {
                    @Override
                    public void onSuccess(String resultBean) {
                        ToastUtils.showShort("修改成功");
                        getUserInfo();
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }

    public void takePhoto() {
        startPhotoPage(true, "申请的是摄像头和照片视频读取权限，用于个人头像维护中读取和写入相册和文件内容",new SelectCallback() {
            @Override
            public void onResult(ArrayList<Photo> photos, boolean isOriginal) {

                /*Bitmap mBitmap = BitmapFactory.decodeFile(photos.get(0).path);*/
                File file = new File(photos.get(0).path);
                model.upLoadFile(file).compose(RxUtils.schedulersTransformer()) //线程调度
                        .doOnSubscribe(MineViewModel.this)
                        .doOnSubscribe(new Consumer<Disposable>() {
                            @Override
                            public void accept(Disposable disposable) throws Exception {
//                                showDialog("请稍等");
                            }
                        }).subscribe(new ApiDisposableObserver<List<Filebean>>() {
                            @Override
                            public void onSuccess(List<Filebean> resultBean) {
                                uploadPicture(resultBean.get(0).getBusinessId());
                                ToastUtils.showShort("修改成功");
                                changeAvatarDialog.dismiss();
                                dismissDialog();
                            }

                            @Override
                            public void onError(String Error) {
                                dismissDialog();
                            }


                        });
            }

            @Override
            public void onCancel() {

            }
        });
    }

    /**
     * 获取积分
     */
    private void memberInfo() {
        model.memberInfo().compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MineViewModel.this)
                .doOnSubscribe((Consumer<Disposable>) disposable -> {
                }).subscribe(new ApiDisposableObserver<MemberInfoBean>() {
                    @Override
                    public void onSuccess(MemberInfoBean resultBean) {
                        /*头像赋值*/
                        String memberPicture = resultBean.getMemberPicture();
                        if (memberPicture != null && !memberPicture.isEmpty()) {
                            Log.v("头像头像", resultBean.getMemberPicture());
                            avatarImageUrl.setValue(memberPicture);
                        } else {
                            memberPicture="";
                            avatarImageUrl.setValue(memberPicture);
                        }
                        integralTotal.postValue(resultBean.getUsableIntegral());
                        memberCoupon.postValue(resultBean.getMemberCoupon());
                        memberName.postValue(resultBean.getGradeName());
                    }


                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                });
    }

    public void getMessageList() {
        model.getMessageList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MineViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<MessageBean>() {
                    @Override
                    public void onSuccess(List<MessageBean> messageBeanList) {
                        if (messageBeanList != null && messageBeanList.size() > 0) {
                            hasUnReadMessage.postValue(true);
                        } else {
                            hasUnReadMessage.postValue(false);
                        }
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                    @Override
                    public void getTotal(int total) {

                    }


                });
    }


    public void memberCollectionList() {
        model.memberCollectionList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(MineViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<CollectionBean>() {
                    @Override
                    public void onSuccess(List<CollectionBean> collectionBeanList) {
                        if (collectionBeanList != null && !collectionBeanList.isEmpty()) {
                            collectionBean.postValue(collectionBeanList.get(0));
                        }
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                    @Override
                    public void getTotal(int total) {

                    }


                });
    }

    private void setValueToNickName() {
        nickName.set(LocalData.getUser().getNickName());
        createTime.set(LocalData.getUser().getCreateTime());
        roleName.set(LocalData.getUser().getRoles().get(0).getRoleName());

    }

    public void refreshNickName() {
        setValueToNickName();
    }

    //跳转修改密码界面
    public BindingCommand goMyCoupon = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(MyCouponActivity.class);
        }

    });

    public BindingCommand goMyCredit = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(MyCreditActivity.class);
        }

    });    //跳转修改密码界面
    public BindingCommand goOrder = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(OrderActivity.class);
        }

    });

    public BindingCommand goNoPayOrder = new BindingCommand(() -> goOrderDetail(1));
    public BindingCommand goFinishedOrder = new BindingCommand(() -> goOrderDetail(2));
    public BindingCommand goClosedOrder = new BindingCommand(() -> goOrderDetail(3));

    private void goOrderDetail(Integer index) {
        Bundle bundle = new Bundle();
        bundle.putInt("index", index);
        startActivity(OrderActivity.class, bundle);
    }


    public BindingCommand goFinishedCreditOrder = new BindingCommand(() -> goCreditOrderDetail(2));
    public BindingCommand goUnclaimedCreditOrder = new BindingCommand(() -> goCreditOrderDetail(1));

    public BindingCommand goCreditOrder = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(CreditOrderActivity.class);
        }

    });

    private void goCreditOrderDetail(Integer index) {
        Bundle bundle = new Bundle();
        bundle.putInt("index", index);
        startActivity(CreditOrderActivity.class, bundle);
    }

    //跳转我的收藏
    public BindingCommand goMessageCenter = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(MessageCenterActivity.class);
        }

    });
    //跳转我的停车
    public BindingCommand goMyPark = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(MyParkActivity.class);
        }

    });

    //跳转我的收藏
    public BindingCommand goMyCollection = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(MyCollectionActivity.class);
        }

    });

    //跳转修改手机号界面
    public BindingCommand goSettings = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            startActivity(SettingsActivity.class);
        }

    });
}