package com.xx.hbhconsumer.ui.mycoupon;

import android.os.Bundle;
import android.view.View;

import androidx.lifecycle.Observer;
import androidx.recyclerview.widget.GridLayoutManager;

import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.CouponGoodsAdapter;
import com.xx.hbhconsumer.adapter.GoodsAdapter;
import com.xx.hbhconsumer.data.http.requst.CouponRequest;
import com.xx.hbhconsumer.data.http.respons.GoodsBean;
import com.xx.hbhconsumer.databinding.ActivityCouponGoodsListBinding;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;

public class CouponGoodsListActivity extends BaseActivity<ActivityCouponGoodsListBinding, CouponGoodsListViewModel> {

    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_coupon_goods_list;
    }

    @Override
    public int initVariableId() {
        return BR.couponGoodsListViewModel;
    }

    @Override
    public void initData() {
        super.initData();

        viewModel.showPriceFlag.observe(this, showPriceFlag -> {
            if (showPriceFlag) {
                binding.rlSearchArea.setVisibility(View.VISIBLE);
                binding.llPriceSearch.setVisibility(View.VISIBLE);

                viewModel.showSortFlag.postValue(false);
            } else {

                binding.llPriceSearch.setVisibility(View.GONE);
            }
            if (!viewModel.showPriceFlag.getValue() && !viewModel.showSortFlag.getValue()) {
                binding.rlSearchArea.setVisibility(View.GONE);
            }
        });

        viewModel.showSortFlag.observe(this, showSortFlag -> {
            if (showSortFlag) {
                binding.rlSearchArea.setVisibility(View.VISIBLE);
                binding.llSortSelect.setVisibility(View.VISIBLE);

                viewModel.showPriceFlag.postValue(false);
            } else {
                binding.llSortSelect.setVisibility(View.GONE);
            }
            if (!viewModel.showPriceFlag.getValue() && !viewModel.showSortFlag.getValue()) {
                binding.rlSearchArea.setVisibility(View.GONE);
            }
        });

        viewModel.sortType.observe(this, sortType -> {
            if (sortType == 0) {
                binding.tvSortDefaultLabel.setTextColor(getColor(R.color.text_foreground));
                binding.ivSortDefault.setVisibility(View.VISIBLE);

                binding.tvSortPriceDescLabel.setTextColor(getColor(R.color.price_black));
                binding.ivSortPriceDesc.setVisibility(View.GONE);

                binding.tvSortPriceAscLabel.setTextColor(getColor(R.color.price_black));
                binding.ivSortPriceAsc.setVisibility(View.GONE);
            } else if (sortType == 1) {
                binding.tvSortDefaultLabel.setTextColor(getColor(R.color.price_black));
                binding.ivSortDefault.setVisibility(View.GONE);

                binding.tvSortPriceDescLabel.setTextColor(getColor(R.color.text_foreground));
                binding.ivSortPriceDesc.setVisibility(View.VISIBLE);

                binding.tvSortPriceAscLabel.setTextColor(getColor(R.color.price_black));
                binding.ivSortPriceAsc.setVisibility(View.GONE);
            } else {
                binding.tvSortDefaultLabel.setTextColor(getColor(R.color.price_black));
                binding.ivSortDefault.setVisibility(View.GONE);

                binding.tvSortPriceDescLabel.setTextColor(getColor(R.color.price_black));
                binding.ivSortPriceDesc.setVisibility(View.GONE);

                binding.tvSortPriceAscLabel.setTextColor(getColor(R.color.text_foreground));
                binding.ivSortPriceAsc.setVisibility(View.VISIBLE);
            }
        });
        //获取适配器上下文
        CouponGoodsAdapter goodsAdapter = new CouponGoodsAdapter(CouponGoodsListActivity.this);
        //获取适配器上下文
        GridLayoutManager manager = new GridLayoutManager(CouponGoodsListActivity.this,2);
        binding.rvGoodsList.setLayoutManager(manager);
        //把adapterset进去
        binding.rvGoodsList.setAdapter(goodsAdapter);
        goodsAdapter.setOnItemClick((position, data) -> viewModel.goGoodsDetail(data.getBusinessId()));
        viewModel.goodsBeanList.observe(this, goodsBeanList -> {
            if (goodsBeanList == null || goodsBeanList.isEmpty()) {
                binding.rlNoData.setVisibility(View.VISIBLE);
                binding.rvGoodsList.setVisibility(View.GONE);
            } else {
                binding.rlNoData.setVisibility(View.GONE);
                binding.rvGoodsList.setVisibility(View.VISIBLE);
            }
            goodsAdapter.mList = goodsBeanList;
            goodsAdapter.notifyDataSetChanged();

        });
    }

    @Override
    public CouponGoodsListViewModel initViewModel() {
        CouponRequest model = new CouponRequest();
        String couponId = getIntent().getStringExtra("couponId");
        return new CouponGoodsListViewModel(getApplication(), model, couponId);
    }
}
