package com.xx.hbhconsumer.ui.mycoupon;

import android.os.Bundle;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.lifecycle.Observer;

import com.google.android.material.tabs.TabLayout;
import com.scwang.smart.refresh.layout.api.RefreshLayout;
import com.scwang.smart.refresh.layout.listener.OnLoadMoreListener;
import com.scwang.smart.refresh.layout.listener.OnRefreshListener;
import com.xx.hbhconsumer.BR;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.MyCouponAdapter;
import com.xx.hbhconsumer.data.http.requst.CouponRequest;
import com.xx.hbhconsumer.data.http.respons.MyCouponBean;
import com.xx.hbhconsumer.databinding.ActivityMyCouponBinding;

import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;

public class MyCouponActivity extends BaseActivity<ActivityMyCouponBinding, MyCouponViewModel> implements OnRefreshListener, OnLoadMoreListener {

    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_my_coupon;
    }

    @Override
    public void initData() {
        super.initData();

        binding.refresh.setOnRefreshListener(this);
        binding.refresh.setOnLoadMoreListener(this);

        /*切换状态Tab*/
        binding.tabLayout.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            /*订单状态 1-待付款 2-已完成 3-已关闭*/
            public void onTabSelected(TabLayout.Tab tab) {
                viewModel.page = 1;
                viewModel.couponState = tab.getPosition();
                viewModel.loadData();
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {
            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {
            }
        });

        MyCouponAdapter orderListAdapter = new MyCouponAdapter(MyCouponActivity.this, viewModel);
        binding.rvCouponList.setAdapter(orderListAdapter);
        viewModel.myCouponBeanList.observe(this, orderBeanList -> {

            if (orderBeanList == null || orderBeanList.isEmpty()) {
                binding.llNoData.setVisibility(View.VISIBLE);
                binding.rvCouponList.setVisibility(View.GONE);
            } else {
                binding.llNoData.setVisibility(View.GONE);
                binding.rvCouponList.setVisibility(View.VISIBLE);
            }

            orderListAdapter.mList = orderBeanList;
            orderListAdapter.notifyDataSetChanged();

            if (viewModel.page == 1) {
                binding.refresh.finishRefresh();
            } else {
                binding.refresh.finishLoadMore();
            }

            if (viewModel.page == viewModel.totalPage) {
                binding.refresh.setEnableLoadMore(false);
            } else {
                binding.refresh.setEnableLoadMore(true);
            }
        });
    }
    @Override
    public int initVariableId() {
        return BR.myCouponViewModel;
    }

    @Override
    public void onPointerCaptureChanged(boolean hasCapture) {
        super.onPointerCaptureChanged(hasCapture);
    }

    @Override
    public MyCouponViewModel initViewModel() {
        CouponRequest loginRequest = new CouponRequest();
        return new MyCouponViewModel(getApplication(), loginRequest);
    }

    @Override
    public void onLoadMore(@NonNull RefreshLayout refreshLayout) {
        viewModel.page++;

        if (viewModel.page > viewModel.totalPage) {
            binding.tvNoMore.setVisibility(View.VISIBLE);
        } else if (viewModel.page == viewModel.totalPage) {
            binding.refresh.setEnableLoadMore(false);
            viewModel.loadData();
            binding.tvNoMore.setVisibility(View.VISIBLE);
        } else {
            viewModel.loadData();
        }
    }

    @Override
    public void onRefresh(@NonNull RefreshLayout refreshLayout) {
        viewModel.page=1;
        viewModel.loadData();
        binding.refresh.setEnableLoadMore(true);
    }
}
