package com.xx.hbhconsumer.ui.mycoupon;


import android.app.Application;
import android.os.Bundle;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.CouponRequest;
import com.xx.hbhconsumer.data.http.respons.MyCouponBean;
import com.xx.hbhconsumer.ui.credit.CreditDetailActivity;
import com.xx.hbhconsumer.ui.home.SignDialog;
import com.xx.xxviewlibrary.base.xxBaseDialog;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class MyCouponViewModel extends BaseViewModel<CouponRequest> {
    public int page = 1;
    public int totalPage = 1;
    public int couponState = 0;
    public MutableLiveData<List<MyCouponBean>> myCouponBeanList = new  MutableLiveData<>(new ArrayList<>());

    public MyCouponViewModel(@NonNull Application application, CouponRequest model) {
        super(application, model);
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        loadData();
    }

    public void loadData() {
        if (couponState == 0) {
            getUnUsedCouponList();
        } else {
            getUsedCouponList();
        }
    }

    private void getUnUsedCouponList() {
        model.getUnUsedCouponList(page)
                .compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                .doOnSubscribe(MyCouponViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<MyCouponBean>() {
                    @Override
                    public void onSuccess(List<MyCouponBean> orderBeanList) {
                        if (page == 1) {
                            myCouponBeanList.postValue(orderBeanList);
                        } else {
                            List<MyCouponBean> list = myCouponBeanList.getValue();
                            list.addAll(orderBeanList);
                            myCouponBeanList.postValue(list);
                        }

                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                    @Override
                    public void getTotal(int total) {
                        totalPage = (total - 1) / 10 + 1;
                    }


                });
    }

    private void getUsedCouponList() {
        model.getUsedCouponList(page)
                .compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                .doOnSubscribe(MyCouponViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<MyCouponBean>() {
                    @Override
                    public void onSuccess(List<MyCouponBean> orderBeanList) {
                        if (page == 1) {
                            myCouponBeanList.postValue(orderBeanList);
                        } else {
                            List<MyCouponBean> list = myCouponBeanList.getValue();
                            list.addAll(orderBeanList);
                            myCouponBeanList.postValue(list);
                        }
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                    @Override
                    public void getTotal(int total) {
                        totalPage = (total - 1) / 10 + 1;
                    }


                });
    }

    public void goCouponGoods(String businessId) {
        Bundle bundle = new Bundle();
        bundle.putString("couponId", businessId);
        startActivity(CouponGoodsListActivity.class, bundle);
    }

    public void showGiftQrCode(View view, String couponId, String giftName) {
        ReceiveGiftDialog dialog = new ReceiveGiftDialog(view.getContext(), couponId, giftName);
        dialog.setDialogClickListener((xxBaseDialog.onDialogClickListener<SignDialog.SignCurrent>) (code, data) -> startActivity(CreditDetailActivity.class));
        dialog.show();
    }
}


