package com.xx.hbhconsumer.ui.newproducts;

import android.os.Bundle;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.lifecycle.Observer;
import androidx.recyclerview.widget.GridLayoutManager;

import com.scwang.smart.refresh.layout.api.RefreshLayout;
import com.scwang.smart.refresh.layout.listener.OnLoadMoreListener;
import com.scwang.smart.refresh.layout.listener.OnRefreshListener;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.CollectionGoodsAdapter;
import com.xx.hbhconsumer.adapter.NewProductsGoodsAdapter;
import com.xx.hbhconsumer.data.http.requst.CollectionRequest;
import com.xx.hbhconsumer.data.http.requst.NewCommodityRequest;
import com.xx.hbhconsumer.data.http.respons.CollectionBean;
import com.xx.hbhconsumer.data.http.respons.NewCommodityBean;
import com.xx.hbhconsumer.data.http.respons.OrderBean;
import com.xx.hbhconsumer.databinding.ActivityNewProductsBinding;
import com.xx.hbhconsumer.ui.mycollection.MyCollectionActivity;
import com.xx.hbhconsumer.ui.mycollection.MyCollectionViewModel;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import java.util.ArrayList;
import java.util.List;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;

public class NewProductsActivity extends BaseActivity<ActivityNewProductsBinding, NewProductsViewModel> implements OnRefreshListener, OnLoadMoreListener {
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_new_products;
    }

    @Override
    public int initVariableId() {
        return BR.newProductsViewModel;
    }

    @Override
    public void initData() {
        super.initData();
        binding.refresh.setOnRefreshListener(this);
        binding.refresh.setOnLoadMoreListener(this);
        GridLayoutManager manager = new GridLayoutManager(NewProductsActivity.this,2);
        binding.rvGoodsList.setLayoutManager(manager);
        //获取适配器上下文
        NewProductsGoodsAdapter orderListAdapter = new NewProductsGoodsAdapter(NewProductsActivity.this);
        //把adapterset进去
        binding.rvGoodsList.setAdapter(orderListAdapter);
        orderListAdapter.setOnItemClick((position, data) -> viewModel.goShopGoodsDetail(data.getBusinessId()));
        viewModel.newCommodityList.observe(this, collectionBeanList -> {
            orderListAdapter.mList = collectionBeanList;
            orderListAdapter.notifyDataSetChanged();
            if (viewModel.page == 1) {
                binding.refresh.finishRefresh();
            } else {
                binding.refresh.finishLoadMore();
            }

            if (viewModel.page == viewModel.totalPage) {
                binding.refresh.setEnableLoadMore(false);
                binding.tvNoMore.setVisibility(View.VISIBLE);
            }
        });

    }

    @Override
    public NewProductsViewModel initViewModel() {
        NewCommodityRequest lm = new NewCommodityRequest();
        return new NewProductsViewModel(getApplication(), lm);
    }

    @Override
    public void onLoadMore(@NonNull RefreshLayout refreshLayout) {
        viewModel.page++;

        if (viewModel.page > viewModel.totalPage) {
            binding.tvNoMore.setVisibility(View.VISIBLE);
        } else if (viewModel.page == viewModel.totalPage) {
            binding.refresh.setEnableLoadMore(false);
            viewModel.loadData();
            binding.tvNoMore.setVisibility(View.VISIBLE);
        } else {
            viewModel.loadData();
        }
    }

    @Override
    public void onRefresh(@NonNull RefreshLayout refreshLayout) {
        viewModel.page=1;
        viewModel.loadData();
        binding.refresh.setEnableLoadMore(true);
    }
}
