package com.xx.hbhconsumer.ui.newproducts;

import android.app.Application;
import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.NewCommodityRequest;
import com.xx.hbhconsumer.data.http.respons.CreditRecordBean;
import com.xx.hbhconsumer.data.http.respons.NewCommodityBean;
import com.xx.hbhconsumer.data.local.LocalData;
import com.xx.hbhconsumer.ui.goods.GoodsDetailActivity;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposablePageObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class NewProductsViewModel extends BaseViewModel<NewCommodityRequest> {

    public int page = 1;
    public int totalPage = 1;

    public MutableLiveData<List<NewCommodityBean>> newCommodityList = new  MutableLiveData<>(new ArrayList<>());

    public NewProductsViewModel(@NonNull Application application) {
        super(application);
    }

    public NewProductsViewModel(@NonNull Application application, NewCommodityRequest model) {
        super(application, model);
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        loadData();
    }

    public void goShopGoodsDetail(String goodsId) {
        Bundle bundle = new Bundle();
        bundle.putString("goodsId", goodsId);
        startActivity(GoodsDetailActivity.class, bundle);
    }

    public void loadData() {
        model.newCommodity(LocalData.getAffiliatedCompany(), page)
                .compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                .doOnSubscribe(NewProductsViewModel.this)
                .doOnSubscribe (new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposablePageObserver<NewCommodityBean>() {
                    @Override
                    public void onSuccess(List<NewCommodityBean> newCommodityBeanList) {
                        if (page == 1) {
                            newCommodityList.postValue(newCommodityBeanList);
                        } else {
                            List<NewCommodityBean> list = newCommodityList.getValue();
                            list.addAll(newCommodityBeanList);
                            newCommodityList.postValue(list);
                        }
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                    @Override
                    public void getTotal(int total) {
                        totalPage = (total - 1) / 10 + 1;
                    }


                });
    }

}
