package com.xx.hbhconsumer.ui.news;

import android.Manifest;
import android.content.pm.PackageManager;
import android.os.Bundle;
import android.util.Log;
import android.webkit.JavascriptInterface;

import androidx.core.app.ActivityCompat;

import com.tencent.smtt.sdk.WebChromeClient;
import com.tencent.smtt.sdk.WebView;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.requst.NewsRequest;
import com.xx.hbhconsumer.databinding.ActivityNewsDetailBinding;
import com.xx.hbhconsumer.utils.RetrofitClient;

import org.json.JSONException;
import org.json.JSONObject;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;
import wendu.dsbridge.DWebView;

public class NewsDetailActivity extends BaseActivity<ActivityNewsDetailBinding, NewsDetailViewModel> {

    private static final String TAG = "NewsDetailActivity";

    @Override
    public void initData() {
        super.initData();

        String newsUrl = getIntent().getStringExtra("newsUrl");
        String url = RetrofitClient.baseH5Url + newsUrl;
        // set debug mode
        DWebView.setWebContentsDebuggingEnabled(true);
        binding.webview.addJavascriptObject(new JavaScriptInterfaceApi(), null);
        binding.webview.setWebChromeClient(new WebChromeClient(){
            @Override
            public void onProgressChanged(WebView webView, int i) {
                super.onProgressChanged(webView, i);
                if (i == 100) {
                    viewModel.hideDialog();
                }
            }
        });
        binding.webview.loadUrl(url);
    }

    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_news_detail;
    }

    @Override
    public int initVariableId() {
        return BR.newsDetailViewModel;
    }

    class JavaScriptInterfaceApi {

        @JavascriptInterface
        public String downloadInfo(Object msg)  {

            int permission = ActivityCompat.checkSelfPermission(NewsDetailActivity.this,
                    Manifest.permission.READ_EXTERNAL_STORAGE);//缺少什么权限就写什么权限
            if (permission != PackageManager.PERMISSION_GRANTED) {
                // We don't have permission so prompt the user
                ActivityCompat.requestPermissions(NewsDetailActivity.this, new String[]{Manifest.permission.READ_EXTERNAL_STORAGE,}, 0);
            }
            int permission2 = ActivityCompat.checkSelfPermission(NewsDetailActivity.this,
                    Manifest.permission.WRITE_EXTERNAL_STORAGE);//缺少什么权限就写什么权限
            if (permission2 != PackageManager.PERMISSION_GRANTED) {
                // We don't have permission so prompt the user
                ActivityCompat.requestPermissions(NewsDetailActivity.this, new String[]{Manifest.permission.WRITE_EXTERNAL_STORAGE,}, 0);
            }
            else {

                JSONObject jsonObject = (JSONObject) msg;
                Log.i(TAG, "downloadInfo 接收到的参数：" + jsonObject.toString());
                try {
                    String url = RetrofitClient.baseImgUrl + jsonObject.getString("informationAttachment");
                    viewModel.downloadFile(url);
                } catch (JSONException e) {
                    throw new RuntimeException(e);
                }
            }

            return "success";
        }

    }
    @Override
    public NewsDetailViewModel initViewModel() {
        NewsRequest model = new NewsRequest();
        return new NewsDetailViewModel(this.getApplication(), model);
    }
}
