package com.xx.hbhconsumer.ui.news;

import android.app.Application;
import android.os.Environment;
import android.util.Log;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.NewsRequest;
import com.xx.hbhconsumer.data.http.requst.PhoneRequest;
import com.xx.hbhconsumer.data.http.respons.OrderBean;

import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.net.URLDecoder;

import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.utils.ToastUtils;
import okhttp3.ResponseBody;

public class NewsDetailViewModel extends BaseViewModel<NewsRequest> {
    private static final String TAG = "NewsDetailViewModel";
    public NewsDetailViewModel(@NonNull Application application) {
        super(application);
    }

    public NewsDetailViewModel(@NonNull Application application, NewsRequest model) {
        super(application, model);
    }
    @Override
    public void onCreate() {
        super.onCreate();
        showDialog("正在请求...");
    }

    public void hideDialog() {
        dismissDialog();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
    }


    public void downloadFile(String url) {
        try {
            String[] arr = url.split("/");
            String fileName = arr[arr.length - 1];
            fileName = URLDecoder.decode(fileName, "UTF-8");
            String path = Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_DOWNLOADS).getPath();
            String filePath = path + "/" + fileName;
            try {
                // 获取 ResponseBody 并进行文件写入
                ResponseBody response = model.downloadFileWithUrlSync(url).execute().body();
                if (response != null) {
                    InputStream in = response.byteStream();
                    FileOutputStream fos = new FileOutputStream(new File(filePath));
                    byte[] buffer = new byte[1024];
                    int len;
                    while ((len = in.read(buffer)) != -1) {
                        fos.write(buffer, 0, len);
                    }
                    fos.flush();
                    fos.close();
                    in.close();
                    ToastUtils.showShort("下载完成，请到下载中查看");
                }
            } catch (Exception e) {

            }
        } catch (Exception e) {

        }

    }
}
