package com.xx.hbhconsumer.ui.news;

import android.app.Application;
import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.NewsRequest;
import com.xx.hbhconsumer.data.http.respons.AppInformationBean;
import com.xx.hbhconsumer.data.http.respons.Children;
import com.xx.hbhconsumer.ui.home.HomeViewModel;
import com.xx.hbhconsumer.ui.pdf.PDFWebViewActivity;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class NewsListViewModel extends BaseViewModel<NewsRequest> {

    public MutableLiveData<List<Children>> appInformationBeanList = new  MutableLiveData<>(new ArrayList<>());

    String classificationId;
    public NewsListViewModel(@NonNull Application application, NewsRequest model, String classificationId) {
        super(application, model);
        this.classificationId = classificationId;
    }

    public void goNewsDetail(Children children) {
        if ("1".equals(children.isView())) {

            model.addView(children.getBusinessId())
                    .compose(RxUtils.schedulersTransformer()) //线程调度
                    .doOnSubscribe(NewsListViewModel.this)
                    .doOnSubscribe(new Consumer<Disposable>() {
                        @Override
                        public void accept(Disposable disposable) throws Exception {
                            showDialog("正在请求...");
                        }
                    }).subscribe(new ApiDisposableObserver<String>() {
                        @Override
                        public void onSuccess(String messageBeanList) {
                            Bundle bundle=new Bundle();
                            bundle.putString("url", children.getFileUrl());
                            bundle.putString("name", children.getInformationTitle());
                            startActivity(PDFWebViewActivity.class, bundle);
                        }

                        @Override
                        public void onError(String Error) {
                            dismissDialog();
                        }
                    });


        } else {
            Bundle bundle=new Bundle();
            bundle.putString("newsUrl", children.getInformationUrl());
            startActivity(NewsDetailActivity.class, bundle);
        }
    }


    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        loadData();
    }

    public void loadData() {
        model.queryAppInformationList()
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(NewsListViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<AppInformationBean>>() {
                    @Override
                    public void onSuccess(List<AppInformationBean> resultBean) {

                        List<AppInformationBean> newResultBean = new ArrayList<>();
                        for (AppInformationBean item : resultBean) {
                            if (item.getClassificationId().equals(classificationId)) {
                                appInformationBeanList.postValue(item.getChildren());
                            }
                        }

                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }

                });
    }
}


