package com.xx.hbhconsumer.ui.order

import android.content.Context
import android.view.Gravity
import android.view.View
import android.view.WindowManager
import com.google.android.material.tabs.TabLayout
import com.xx.hbhconsumer.R
import com.xx.hbhconsumer.adapter.AvailableCouponAdapter
import com.xx.hbhconsumer.adapter.NotAvailableCouponAdapter
import com.xx.hbhconsumer.data.http.respons.AvailableCoupon
import com.xx.hbhconsumer.data.http.respons.ClaimedCoupon
import com.xx.hbhconsumer.databinding.DialogChooseCouponBinding
import com.xx.xxviewlibrary.base.xxBaseDialog
import me.jessyan.autosize.utils.AutoSizeUtils

class ChooseCouponDialog(context:Context, var data: ClaimedCoupon, var viewModel: OrderDetailViewModel): xxBaseDialog<DialogChooseCouponBinding>(context) {

    override fun InitView(): DialogSet {
        return DialogSet(
            R.layout.dialog_choose_coupon,true,
            Gravity.BOTTOM,true, WindowManager.LayoutParams.MATCH_PARENT,
            AutoSizeUtils.dp2px(context,
            468.0F));
    }
    lateinit var orderListAdapter: AvailableCouponAdapter
    lateinit var notAvailableCouponAdapter: NotAvailableCouponAdapter
    override fun InitData() {
        binding.chooseCouponDialog = this

        binding.btnConfirm.setOnClickListener {
            lateinit var coupon: AvailableCoupon
            (0..(data.availableCoupons.size - 1)).forEach{
                if (data.availableCoupons[it].checkStatus) {
                    coupon = data.availableCoupons[it]
                }
            }
            dismiss()
            viewModel.confirmCoupon(coupon)
        }

        orderListAdapter = AvailableCouponAdapter(context, this@ChooseCouponDialog, viewModel);
        binding.rvCouponList.setAdapter(orderListAdapter)
        orderListAdapter.mList = data.availableCoupons

        binding.tabLayout.addOnTabSelectedListener(object :
            TabLayout.OnTabSelectedListener {
            override fun onTabSelected(tab: TabLayout.Tab) {
                when (tab.position) {
                    0 -> {
                        orderListAdapter = AvailableCouponAdapter(context, this@ChooseCouponDialog, viewModel);
                        binding.rvCouponList.setAdapter(orderListAdapter)
                        orderListAdapter.mList = data.availableCoupons
                        orderListAdapter.notifyDataSetChanged()
                    }
                    1 -> {
                        //获取适配器上下文
                        val notAvailableCouponAdapter = NotAvailableCouponAdapter(context)
                        binding.rvCouponList.setAdapter(notAvailableCouponAdapter)
                        notAvailableCouponAdapter.mList = data.unavailableCoupons
                        notAvailableCouponAdapter.notifyDataSetChanged()
                    }
                }
            }

            override fun onTabUnselected(tab: TabLayout.Tab) {}
            override fun onTabReselected(tab: TabLayout.Tab) {}
        })

        binding.tabLayout.getTabAt(0)?.select()

    }
    data class SignCurrent(val context:String)

    fun typeClickDialog(view: View) {
        if (DialogClickListener != null) {
            DialogClickListener.dialogClickBack(view.id, null)
        }
        dismiss()
    }

    fun check(checkStatus: Boolean, index: Int) {
        (0..(data.availableCoupons.size - 1)).forEach{
            data.availableCoupons[it].checkStatus = false
        }
        data.availableCoupons[index].checkStatus = checkStatus
        orderListAdapter.mList = data.availableCoupons
        orderListAdapter.notifyDataSetChanged()
    }
}