package com.xx.hbhconsumer.ui.order;

import android.content.res.ColorStateList;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import com.bumptech.glide.Glide;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.OrderGoodsAdapter;
import com.xx.hbhconsumer.data.http.requst.OrderRequest;
import com.xx.hbhconsumer.data.http.respons.CouponBean;
import com.xx.hbhconsumer.databinding.ActivityOrderDetailBinding;
import com.xx.hbhconsumer.utils.RetrofitClient;

import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.goldze.mvvmhabit.utils.StringUtils;
import me.tatarka.bindingcollectionadapter2.BR;

public class OrderDetailActivity extends BaseActivity<ActivityOrderDetailBinding, OrderDetailViewModel> {

    private CountDownTimer countDownTimer;
    private Integer preUserSeconds;
    private Integer userSeconds;
    @Override
    public void initData() {
        super.initData();

        //获取适配器上下文
        OrderGoodsAdapter creditGoodsAdapter = new OrderGoodsAdapter(this);
        //把adapterset进去
        binding.rvGoodsList.setAdapter(creditGoodsAdapter);
        viewModel.orderBean.observe(this, orderBean -> {
            if (orderBean != null) {
                creditGoodsAdapter.mList = orderBean.getCommodityList();
                creditGoodsAdapter.notifyDataSetChanged();

                if ("1".equals(orderBean.getOrderStatus())) {
                    binding.ivStatusIcon.setImageDrawable(getDrawable(R.mipmap.dingdanxiangqing_icon_daifukuan));
                    binding.tvStatus.setText("等待付款");
                    binding.rlButton.setVisibility(View.VISIBLE);

                    binding.tvDiscountLabel.setVisibility(View.GONE);
                    binding.llDiscountPrice.setVisibility(View.GONE);

                    binding.llGift.setVisibility(View.GONE);
                    binding.viewDivider2.setVisibility(View.GONE);
                    binding.llNoPay.setVisibility(View.VISIBLE);

                    binding.tvPayTimeLabel.setVisibility(View.GONE);
                    binding.tvPayTime.setVisibility(View.GONE);

                    binding.tvCloseTimeLabel.setVisibility(View.GONE);
                    binding.tvCloseTime.setVisibility(View.GONE);

                    String price = String.valueOf(orderBean.getOrderAmount());
                    if (!StringUtils.isEmpty(price) && price.contains(".")) {
                        binding.tvOrderPriceInteger.setText(price.split("\\.")[0]);
                        binding.tvOrderPriceDecimal.setText("." + price.split("\\.")[1]);
                    }

                    if ("1".equals(orderBean.getInPay())) {
                        binding.llCoupon.setVisibility(View.GONE);
                        binding.llDiscountPrice.setVisibility(View.VISIBLE);
                        String discountAmount = "0";
                        if (orderBean.getCouponList() != null && !orderBean.getCouponList().isEmpty()) {
                            for (CouponBean couponBean : orderBean.getCouponList()) {
                                if (couponBean.getCouponType().equals("1")) {
                                    discountAmount = String.valueOf(couponBean.getDiscountAmount());
                                    String arr[] = discountAmount.split("\\.");
                                    binding.tvDiscountPriceInteger.setText(arr[0]);
                                    if (arr.length == 2) {
                                        binding.tvDiscountPriceDecimal.setText("." + arr[1]);
                                    } else {
                                        binding.tvDiscountPriceDecimal.setText(".00");
                                    }
                                }
                            }
                        }

                        BigDecimal actualPayment = new BigDecimal(String.valueOf(viewModel.orderBean.getValue().getOrderAmount())).subtract(new BigDecimal(discountAmount));
                        String actualPaymentStr = actualPayment.stripTrailingZeros().toPlainString();
                        String actualPaymentArr[] = actualPaymentStr.split("\\.");
                        binding.tvActualPriceInteger.setText(actualPaymentArr[0]);
                        binding.tvPaymentRequiredPriceInteger.setText(actualPaymentArr[0]);
                        if (actualPaymentArr.length == 2) {
                            binding.tvActualPriceDecimal.setText(actualPaymentArr[1]);
                            binding.tvPaymentRequiredPriceDecimal.setText("." + actualPaymentArr[1]);
                        } else {
                            binding.tvActualPriceDecimal.setText(".00");
                            binding.tvPaymentRequiredPriceDecimal.setText(".00");
                        }

                    } else {
                        binding.llCoupon.setVisibility(View.VISIBLE);

                        binding.tvPaymentRequiredPriceInteger.setText(price.split("\\.")[0]);
                        binding.tvPaymentRequiredPriceDecimal.setText("." + price.split("\\.")[1]);

                        binding.tvActualPriceInteger.setText(price.split("\\.")[0]);
                        binding.tvActualPriceDecimal.setText("." + price.split("\\.")[1]);
                    }

                    long currentTime = System.currentTimeMillis() / 1000; // 获取当前时间的毫秒数
                    Log.v("当前时间的秒数", String.valueOf(currentTime));
                    SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                    try {
                        Date createDate = format.parse(orderBean.getCreateTime()); // 将 createTime 字符串转换为日期对象
                        long createTimeMillis = createDate.getTime(); // 获取 createTime 的毫秒数
                        long currentTimeMillis = System.currentTimeMillis(); // 获取当前时间的毫秒数
                        long seconds = (currentTimeMillis - createTimeMillis) / 1000; // 计算秒数
                        preUserSeconds = Math.toIntExact(seconds);
                        userSeconds = 24 * 60 * 60 - preUserSeconds;
                    } catch (ParseException e) {
                        e.printStackTrace();
                    }
                    /*倒计时!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!24 * 60 * 60 * 1000*/
                    /*初始值是距创建时间开始的24小时*/
                    countDownTimer = new CountDownTimer(userSeconds*1000, 1000) {
                        @Override
                        public void onTick(long millisUntilFinished) {
                            // 每秒钟调用一次此方法，用于更新倒计时的显示
                            long seconds = millisUntilFinished / 1000;
                            long hours = seconds / 3600;
                            long minutes = (seconds % 3600) / 60;
                            seconds = seconds % 60;

                            String countdownText = String.format("%02d小时%02d分%02d秒", hours, minutes, seconds);
                            TextView countDownTextView = findViewById(R.id.tv_countdown);
                            countDownTextView.setText("剩余：" + countdownText);
                        }
                        /*
                         * 将时分秒转为秒数
                         * */
                        @Override
                        public void onFinish() {
                            // 倒计时完成后调用此方法
                            TextView countDownTextView = findViewById(R.id.tv_countdown);
                            countDownTextView.setText("剩余：00小时00分00秒");
                            /*设置到时间后底部提交按钮禁用-并置灰*/
                            Button button = binding.btnPay;
                            button.setEnabled(false);
                            // 将按钮的背景颜色更改为灰色
                            button.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(android.R.color.darker_gray)));

                            Button btnCancel = binding.btnCancel;
                            btnCancel.setEnabled(false);
                            // 将按钮的背景颜色更改为灰色
                            btnCancel.setBackgroundTintList(ColorStateList.valueOf(getResources().getColor(android.R.color.darker_gray)));

                            viewModel.loadGoodsData();
                        }
                    };
                    countDownTimer.start(); // 启动倒计时

                } else if ("2".equals(orderBean.getOrderStatus())) {
                    binding.ivStatusIcon.setImageDrawable(getDrawable(R.mipmap.dingdanxiangqing_icon_wancheng));
                    binding.tvStatus.setText("订单状态：已完成");
                    binding.rlButton.setVisibility(View.GONE);

                    binding.tvDiscountLabel.setVisibility(View.VISIBLE);
                    binding.llDiscountPrice.setVisibility(View.VISIBLE);
                    binding.llCoupon.setVisibility(View.GONE);
                    binding.llNoPay.setVisibility(View.GONE);

                    binding.tvPayTime.setText(orderBean.getUpdateTime());

                    binding.tvCloseTimeLabel.setVisibility(View.GONE);
                    binding.tvCloseTime.setVisibility(View.GONE);

                    String actualPayment = String.valueOf(orderBean.getActualPayment());
                    binding.tvActualPriceInteger.setText(actualPayment.split("\\.")[0]);
                    binding.tvActualPriceDecimal.setText("." + actualPayment.split("\\.")[1]);

                    String price = String.valueOf(orderBean.getOrderAmount());
                    if (!StringUtils.isEmpty(price) && price.contains(".")) {
                        binding.tvOrderPriceInteger.setText(price.split("\\.")[0]);
                        binding.tvOrderPriceDecimal.setText("." + price.split("\\.")[1]);
                    }

                    if (orderBean.getCouponList() != null && !orderBean.getCouponList().isEmpty()) {
                        for (CouponBean couponBean : orderBean.getCouponList()) {
                            if (couponBean.getCouponType().equals("1")) {
                                String discountAmount = String.valueOf(couponBean.getDiscountAmount());
                                String arr[] = discountAmount.split("\\.");
                                binding.tvDiscountPriceInteger.setText(arr[0]);
                                if (arr.length == 2) {
                                    binding.tvDiscountPriceDecimal.setText("." + arr[1]);
                                } else {
                                    binding.tvDiscountPriceDecimal.setText(".00");
                                }

                            }
                        }
                    }

                    boolean showReceiveFlag = true;
                    String giftName = "";
                    for (CouponBean couponBean : orderBean.getCouponList()) {
                        if ("2".equals(couponBean.getCouponType())) {
                            showReceiveFlag = false;
                            giftName = couponBean.getGiftName();
                        }
                    }

                    if (showReceiveFlag) {
                        binding.llGift.setVisibility(View.GONE);
                    } else {
                        binding.llGift.setVisibility(View.VISIBLE);
                        binding.tvGift.setText("赠品：" + giftName);
                    }

                } else if ("3".equals(orderBean.getOrderStatus())) {
                    binding.ivStatusIcon.setImageDrawable(getDrawable(R.mipmap.dingdanxiangqing_icon_guanbi));
                    binding.tvStatus.setText("订单状态：交易关闭");

                    String actualPayment = String.valueOf(orderBean.getActualPayment());
                    binding.tvActualPriceInteger.setText(actualPayment.split("\\.")[0]);
                    binding.tvActualPriceDecimal.setText("." + actualPayment.split("\\.")[1]);

                    String price = String.valueOf(orderBean.getOrderAmount());
                    if (!StringUtils.isEmpty(price) && price.contains(".")) {
                        binding.tvOrderPriceInteger.setText(price.split("\\.")[0]);
                        binding.tvOrderPriceDecimal.setText("." + price.split("\\.")[1]);
                    }

                    binding.tvDiscountLabel.setVisibility(View.GONE);
                    binding.llDiscountPrice.setVisibility(View.VISIBLE);
                    binding.llCoupon.setVisibility(View.GONE);
                    binding.llNoPay.setVisibility(View.GONE);
                    binding.llGift.setVisibility(View.GONE);
                    binding.viewDivider2.setVisibility(View.GONE);
                    binding.rlButton.setVisibility(View.GONE);

                    binding.tvPayTimeLabel.setVisibility(View.GONE);
                    binding.tvPayTime.setVisibility(View.GONE);

                    binding.tvCloseTime.setText(orderBean.getUpdateTime());
                    binding.tvCloseTimeLabel.setVisibility(View.VISIBLE);
                    binding.tvCloseTime.setVisibility(View.VISIBLE);

                }

                Glide.with(this)
                        .load(RetrofitClient.baseImgUrl + orderBean.getMerchant().getCompanyLogoFile().getFilePath())
                        .into(binding.ivShopLogo);

                binding.tvShopName.setText(orderBean.getMerchant().getStoreName());
                binding.tvTotalNum.setText("共" + orderBean.getQuantity() + "件");
                binding.tvOrderNumber.setText(orderBean.getOrderNumber());
                binding.tvCreateTime.setText(orderBean.getCreateTime());


            }
        });

        viewModel.claimedCoupon.observe(this, claimedCoupon -> {
            if (claimedCoupon != null && claimedCoupon.getAvailableCoupons() != null) {
                binding.tvCouponNum.setText(claimedCoupon.getAvailableCoupons().size() + "张可用");
            }
        });

        viewModel.checkCouponFlag.observe(this, checkCouponFlag -> {
            if (checkCouponFlag) {
                binding.tvCheckCoupon.setVisibility(View.VISIBLE);
                binding.llCoupon.setVisibility(View.GONE);
                binding.llCouponDiscount.setVisibility(View.VISIBLE);
                binding.tvCouponNum.setVisibility(View.GONE);
            } else {
                binding.tvCheckCoupon.setVisibility(View.GONE);
                binding.llCoupon.setVisibility(View.VISIBLE);
                binding.llCouponDiscount.setVisibility(View.GONE);
                binding.tvCouponNum.setVisibility(View.VISIBLE);
            }
        });

        viewModel.coupon.observe(this, coupon -> {
            if (coupon != null ) {
                String discountAmount = String.valueOf(coupon.getDiscountAmount());
                String arr[] = discountAmount.split("\\.");
                binding.tvDiscountInteger.setText(arr[0]);
                if (arr.length == 2) {
                    binding.tvDiscountDecimal.setText("." + arr[1]);
                } else {
                    binding.tvDiscountDecimal.setText(".00");
                }
                BigDecimal actualPayment = new BigDecimal(String.valueOf(viewModel.orderBean.getValue().getOrderAmount())).subtract(new BigDecimal(String.valueOf(coupon.getDiscountAmount())));
                String actualPaymentStr = actualPayment.stripTrailingZeros().toPlainString();
                String actualPaymentArr[] = actualPaymentStr.split("\\.");
                binding.tvActualPriceInteger.setText(actualPaymentArr[0]);
                binding.tvPaymentRequiredPriceInteger.setText(actualPaymentArr[0]);
                if (actualPaymentArr.length == 2) {
                    binding.tvActualPriceDecimal.setText(actualPaymentArr[1]);
                    binding.tvPaymentRequiredPriceDecimal.setText("." + actualPaymentArr[1]);
                } else {
                    binding.tvActualPriceDecimal.setText(".00");
                    binding.tvPaymentRequiredPriceDecimal.setText(".00");
                }
            }
        });

    }

    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_order_detail;
    }

    @Override
    public int initVariableId() {
        return BR.orderDetailViewModel;
    }

    @Override
    public OrderDetailViewModel initViewModel() {
        OrderRequest lm = new OrderRequest();
        String orderId = getIntent().getStringExtra("orderId");
        return new OrderDetailViewModel(getApplication(), lm, orderId);
    }
}
