package com.xx.hbhconsumer.ui.order

import android.content.Context
import android.view.Gravity
import android.view.View
import android.view.WindowManager
import cn.bingoogolapple.qrcode.zxing.QRCodeEncoder
import com.xx.hbhconsumer.R
import com.xx.hbhconsumer.databinding.DialogOrderPayBinding
import com.xx.xxviewlibrary.base.xxBaseDialog
import me.jessyan.autosize.utils.AutoSizeUtils

class OrderPayDialog(context:Context, var data: String, var price: String): xxBaseDialog<DialogOrderPayBinding>(context) {
    override fun InitView(): DialogSet {
        return DialogSet(
            R.layout.dialog_order_pay,true,
            Gravity.BOTTOM,true, WindowManager.LayoutParams.MATCH_PARENT,
            AutoSizeUtils.dp2px(context,
            333.0F));
    }

    override fun InitData() {
        binding.orderPayDialog = this

        binding.tvCancel.setOnClickListener {
            dismiss()
        }
        var qrCode = QRCodeEncoder.syncEncodeQRCode("orderId=" + data, 144)
        binding.ivOrderQrCode.setImageBitmap(qrCode)

        binding.tvOrderPriceInteger.text =
            price.split("\\.".toRegex()).dropLastWhile { it.isEmpty() }
                .toTypedArray()[0]
        if (price.split("\\.".toRegex()).dropLastWhile { it.isEmpty() }.toTypedArray().size == 2) {
            binding.tvOrderPriceDecimal.text =
                "." + price.split("\\.".toRegex()).dropLastWhile { it.isEmpty() }
                    .toTypedArray()[1]
        } else {
            binding.tvOrderPriceDecimal.text = ".00"
        }

    }
    data class SignCurrent(val context:String)

    fun typeClickDialog(view: View) {
        if (DialogClickListener != null) {
            DialogClickListener.dialogClickBack(view.id, null)
        }
        dismiss()
    }
}