package com.xx.hbhconsumer.ui.order

import android.content.Context
import android.view.Gravity
import android.view.View
import android.view.WindowManager
import com.xx.hbhconsumer.R
import com.xx.hbhconsumer.adapter.CouponAdapter
import com.xx.hbhconsumer.data.http.respons.AvailableCouponBean
import com.xx.hbhconsumer.databinding.DialogReceiveCouponBinding
import com.xx.xxviewlibrary.base.xxBaseDialog
import me.jessyan.autosize.utils.AutoSizeUtils

class ReceiveCouponDialog(context:Context, var data: List<AvailableCouponBean>, var viewModel: OrderListViewModel): xxBaseDialog<DialogReceiveCouponBinding>(context) {

    override fun InitView(): DialogSet {
        return DialogSet(
            R.layout.dialog_receive_coupon,true,
            Gravity.BOTTOM,true, WindowManager.LayoutParams.MATCH_PARENT,
            AutoSizeUtils.dp2px(context,
            608.0F));
    }

    override fun InitData() {
        if (data == null || data.isEmpty()) {
            binding.rlNoData.visibility = View.VISIBLE
            binding.rvCouponList.visibility = View.GONE
        } else {
            binding.rvCouponList.visibility = View.VISIBLE
            binding.rlNoData.visibility = View.GONE
        }
        binding.receiveCouponDialog = this
        val couponAdapter = CouponAdapter(context, viewModel)
        binding.rvCouponList.setAdapter(couponAdapter)
        couponAdapter.mList = data
    }
    data class SignCurrent(val context:String)

    fun typeClickDialog(view: View) {
        if (DialogClickListener != null) {
            DialogClickListener.dialogClickBack(view.id, null)
        }
        dismiss()
    }
}