package com.xx.hbhconsumer.ui.phone;

import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;

import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.requst.PhoneRequest;
import com.xx.hbhconsumer.data.http.requst.PwdRequest;
import com.xx.hbhconsumer.data.local.LocalData;
import com.xx.hbhconsumer.databinding.ActivityChangePhoneBinding;
import com.xx.hbhconsumer.ui.pwd.PwdViewModel;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;

public class PhoneActivity extends BaseActivity<ActivityChangePhoneBinding, PhoneViewModel> {
    private static final String TAG = "PhoneActivity";
    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_change_phone;
    }

    @Override
    public int initVariableId() {
        return BR.phoneViewModel;
    }

    @Override
    public void initData() {
        super.initData();
        binding.tvSendCode.setClickable(false);
        binding.etNewPhone.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence charSequence, int i, int i1, int i2) {

            }

            @Override
            public void onTextChanged(CharSequence charSequence, int i, int i1, int i2) {
                Log.i(TAG, "onTextChanged: ");
                if (charSequence.toString().length() == 11) {
                    binding.tvSendCode.setTextColor(getColor(R.color.foreground));
                    binding.tvSendCode.setClickable(true);
                } else {
                    binding.tvSendCode.setTextColor(getColor(R.color.not_available_foreground));
                    binding.tvSendCode.setClickable(false);
                }
            }

            @Override
            public void afterTextChanged(Editable editable) {

            }
        });
    }

    @Override
    public PhoneViewModel initViewModel() {
        PhoneRequest lm = new PhoneRequest();
        return new PhoneViewModel(getApplication(), lm);
    }

}
