package com.xx.hbhconsumer.ui.pwd;

import static me.goldze.mvvmhabit.utils.Utils.Interceptor_TOKEN;

import android.app.Application;
import android.text.TextUtils;

import androidx.annotation.NonNull;
import androidx.databinding.ObservableField;

import com.xx.hbhconsumer.data.http.requst.PwdRequest;
import com.xx.hbhconsumer.ui.login.LoginActivity;
import com.xx.hbhconsumer.ui.main.MainActivity;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;
import me.goldze.mvvmhabit.utils.ToastUtils;

public class PwdViewModel extends BaseViewModel<PwdRequest> {
    Boolean needChangeTimeLongPassword;
    //旧密码的绑定
    public ObservableField<String> oldPassword = new ObservableField<>("");
    //新密码的绑定
    public ObservableField<String> password = new ObservableField<>("");
    //新密码的绑定
    public ObservableField<String> repeatPassword = new ObservableField<>("");
    public PwdViewModel(@NonNull Application application) {
        super(application);
    }

    public PwdViewModel(@NonNull Application application, PwdRequest model, Boolean needChangeTimeLongPassword) {
        super(application, model);
        this.needChangeTimeLongPassword = needChangeTimeLongPassword;
    }
    //触发修改按钮
    public BindingCommand changePwd = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            if (TextUtils.isEmpty(oldPassword.get().toString())) {
                ToastUtils.showShort("请输入原密码！");
            } else if (TextUtils.isEmpty(password.get().toString())) {
                ToastUtils.showShort("请输入新的登录密码！");
            } else if (TextUtils.isEmpty(repeatPassword.get().toString())) {
                ToastUtils.showShort("请重复新的登录密码！");
            } else if (!password.get().toString().equals(repeatPassword.get().toString())) {
                ToastUtils.showShort("前后密码不一致！");
            } else {
                model.ChangePwd(oldPassword.get().toString(), password.get().toString())
                        .compose(RxUtils.schedulersTransformer()) //线程调度
//                        .compose(RxUtils.exceptionTransformer()) // 网络错误的异常转换, 这里可以换成自己的ExceptionHandle
                        .doOnSubscribe(PwdViewModel.this)
                        .doOnSubscribe(new Consumer<Disposable>() {
                            @Override
                            public void accept(Disposable disposable) throws Exception {
                                showDialog("正在请求...");
                            }
                        }).subscribe(new ApiDisposableObserver<String>() {
                            @Override
                            public void onSuccess(String resultBean) {
                                //是指token
                                Interceptor_TOKEN = "Bearer " + resultBean;
                                //临时关闭
//                                getuserInfo();
                                if (needChangeTimeLongPassword) {
                                    startActivity(MainActivity.class);
                                    finish();
                                } else {
                                    startActivity(LoginActivity.class);
                                    finish();
                                }

                            }

                            @Override
                            public void onError(String Error) {
                                dismissDialog();
                            }

                        });
            }
        }
    });
}
