package com.xx.hbhconsumer.ui.recruit;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.Nullable;

import com.xx.hbhconsumer.BR;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.RecruitAdapter;
import com.xx.hbhconsumer.data.http.requst.RecruitRequest;
import com.xx.hbhconsumer.databinding.FragmentRecruitListBinding;

import java.util.ArrayList;
import java.util.List;

import me.goldze.mvvmhabit.base.BaseFragment;

public class RecruitListFragment extends BaseFragment<FragmentRecruitListBinding, RecruitListViewModel> {

    public static RecruitListFragment newInstance(Integer recruitType) {
        Bundle args = new Bundle();
        args.putInt("recruitType", recruitType + 1);
        RecruitListFragment fragment = new RecruitListFragment();
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void initData() {
        //获取适配器上下文
        RecruitAdapter orderListAdapter = new RecruitAdapter(getActivity(), viewModel);
        //把adapterset进去
        binding.rvOrderList.setAdapter(orderListAdapter);
        orderListAdapter.setOnItemClick((position, data) -> viewModel.goDetail(data.getBusinessId()));
        viewModel.recruitBeanList.observe(this, recruitBeanList -> {

            if (recruitBeanList == null || recruitBeanList.isEmpty()) {
                binding.rlNoData.setVisibility(View.VISIBLE);
                binding.tvNoMore.setVisibility(View.GONE);
                binding.rvOrderList.setVisibility(View.GONE);
            } else {
                binding.rlNoData.setVisibility(View.GONE);
                binding.tvNoMore.setVisibility(View.VISIBLE);
                binding.rvOrderList.setVisibility(View.VISIBLE);
            }

            orderListAdapter.mList = recruitBeanList;
            orderListAdapter.notifyDataSetChanged();
        });
    }

    @Override
    public int viewModelType() {
        return 1;
    }

    @Override
    public int initContentView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return R.layout.fragment_recruit_list;
    }

    @Override
    public int initVariableId() {
        return BR.recruitListViewModel;
    }

    @Override
    public RecruitListViewModel initViewModel() {
        RecruitRequest model = new RecruitRequest();
        Bundle args = getArguments();
        Integer recruitType = args.getInt("recruitType");
        return new RecruitListViewModel(getActivity().getApplication(), model, String.valueOf(recruitType));
    }
}
