package com.xx.hbhconsumer.ui.search;

import android.os.Bundle;
import android.view.View;

import androidx.recyclerview.widget.GridLayoutManager;

import com.google.android.flexbox.FlexDirection;
import com.google.android.flexbox.FlexWrap;
import com.google.android.flexbox.FlexboxLayoutManager;
import com.google.android.material.tabs.TabLayout;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.adapter.SearchGoodsAdapter;
import com.xx.hbhconsumer.adapter.SearchHistoryAdapter;
import com.xx.hbhconsumer.adapter.SearchShopAdapter;
import com.xx.hbhconsumer.data.http.requst.SearchRequest;
import com.xx.hbhconsumer.databinding.ActivitySearchBinding;
import com.xx.xxviewlibrary.base.xxBaseRecyclerViewAdapter;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.goldze.mvvmhabit.utils.StringUtils;
import me.tatarka.bindingcollectionadapter2.BR;

public class SearchActivity extends BaseActivity<ActivitySearchBinding, SearchViewModel> {

    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_search;
    }

    @Override
    public int initVariableId() {
        return BR.searchViewModel;
    }

    @Override
    public void initData() {
        super.initData();
        binding.etSearch.requestFocus();

        viewModel.showPriceFlag.observe(this, showPriceFlag -> {
            if (showPriceFlag) {
                binding.rlSearchArea.setVisibility(View.VISIBLE);
                binding.llPriceSearch.setVisibility(View.VISIBLE);

                viewModel.showSortFlag.postValue(false);

                binding.ivPriceShowIcon.setImageDrawable(getDrawable(R.mipmap.sousuo_icon_jiangxu2));
            } else {
                binding.ivPriceShowIcon.setImageDrawable(getDrawable(R.mipmap.sousuo_icon_jiangxu1));
                binding.llPriceSearch.setVisibility(View.GONE);
            }
            if (!viewModel.showPriceFlag.getValue() && !viewModel.showSortFlag.getValue()) {
                binding.rlSearchArea.setVisibility(View.GONE);
            }
        });

        viewModel.showSortFlag.observe(this, showSortFlag -> {
            if (showSortFlag) {
                binding.rlSearchArea.setVisibility(View.VISIBLE);
                binding.llSortSelect.setVisibility(View.VISIBLE);

                viewModel.showPriceFlag.postValue(false);
                binding.ivSortShowIcon.setImageDrawable(getDrawable(R.mipmap.sousuo_icon_jiangxu2));
            } else {
                binding.llSortSelect.setVisibility(View.GONE);
                binding.ivSortShowIcon.setImageDrawable(getDrawable(R.mipmap.sousuo_icon_jiangxu1));
            }
            if (!viewModel.showPriceFlag.getValue() && !viewModel.showSortFlag.getValue()) {
                binding.rlSearchArea.setVisibility(View.GONE);
            }
        });

        viewModel.searchType.observe(this, searchType -> {
            if (searchType == 0) {
                binding.rvSearchHistory.setVisibility(View.VISIBLE);
                binding.rlSearchHistoryBar.setVisibility(View.VISIBLE);
                binding.rvSearchGoodsList.setVisibility(View.GONE);
                binding.tvGoodsNoMore.setVisibility(View.GONE);
                binding.tvShopNoMore.setVisibility(View.GONE);
                binding.rvSearchShopList.setVisibility(View.GONE);
                binding.rlSearchTab.setVisibility(View.GONE);
                binding.rlSearchArea.setVisibility(View.GONE);
                binding.rlSearchBar.setVisibility(View.GONE);
                binding.rlBackTop.setVisibility(View.GONE);
            } else {
                binding.rlBackTop.setVisibility(View.GONE);
                binding.rvSearchHistory.setVisibility(View.GONE);
                binding.rlSearchHistoryBar.setVisibility(View.GONE);
                if (searchType == 1) {
                    binding.rvSearchGoodsList.setVisibility(View.VISIBLE);
                    binding.tvGoodsNoMore.setVisibility(View.VISIBLE);
                    binding.tvShopNoMore.setVisibility(View.GONE);
                    binding.rvSearchShopList.setVisibility(View.GONE);
                    binding.rlSearchBar.setVisibility(View.VISIBLE);
                    binding.nsvGoods.setVisibility(View.VISIBLE);
                    binding.nsvShops.setVisibility(View.GONE);
                } else {
                    binding.rvSearchGoodsList.setVisibility(View.GONE);
                    binding.tvGoodsNoMore.setVisibility(View.GONE);
                    binding.tvShopNoMore.setVisibility(View.VISIBLE);
                    binding.rvSearchShopList.setVisibility(View.VISIBLE);
                    binding.rlSearchBar.setVisibility(View.GONE);
                    binding.nsvGoods.setVisibility(View.GONE);
                    binding.nsvShops.setVisibility(View.VISIBLE);
                }
                binding.rlSearchTab.setVisibility(View.VISIBLE);
            }
        });

        viewModel.sortType.observe(this, sortType -> {
            if (sortType == 0) {
                binding.tvSortDefaultLabel.setTextColor(getColor(R.color.text_foreground));
                binding.ivSortDefault.setVisibility(View.VISIBLE);

                binding.tvSortPriceDescLabel.setTextColor(getColor(R.color.price_black));
                binding.ivSortPriceDesc.setVisibility(View.GONE);

                binding.tvSortPriceAscLabel.setTextColor(getColor(R.color.price_black));
                binding.ivSortPriceAsc.setVisibility(View.GONE);
            } else if (sortType == 1) {
                binding.tvSortDefaultLabel.setTextColor(getColor(R.color.price_black));
                binding.ivSortDefault.setVisibility(View.GONE);

                binding.tvSortPriceDescLabel.setTextColor(getColor(R.color.text_foreground));
                binding.ivSortPriceDesc.setVisibility(View.VISIBLE);

                binding.tvSortPriceAscLabel.setTextColor(getColor(R.color.price_black));
                binding.ivSortPriceAsc.setVisibility(View.GONE);
            } else {
                binding.tvSortDefaultLabel.setTextColor(getColor(R.color.price_black));
                binding.ivSortDefault.setVisibility(View.GONE);

                binding.tvSortPriceDescLabel.setTextColor(getColor(R.color.price_black));
                binding.ivSortPriceDesc.setVisibility(View.GONE);

                binding.tvSortPriceAscLabel.setTextColor(getColor(R.color.text_foreground));
                binding.ivSortPriceAsc.setVisibility(View.VISIBLE);
            }
        });

        //获取适配器上下文
        SearchGoodsAdapter searchGoodsAdapter = new SearchGoodsAdapter(SearchActivity.this);
        //获取适配器上下文
        GridLayoutManager manager = new GridLayoutManager(SearchActivity.this,2);
        binding.rvSearchGoodsList.setLayoutManager(manager);
        //把adapterset进去
        binding.rvSearchGoodsList.setAdapter(searchGoodsAdapter);
        searchGoodsAdapter.setOnItemClick((position, data) -> viewModel.goGoodsDetail(data.getBusinessId()));

        viewModel.searchGoodsBeanList.observe(this, goodsBeanList -> {
            if (goodsBeanList == null || goodsBeanList.isEmpty()) {
                binding.rlNoData.setVisibility(View.VISIBLE);
                binding.rlSearchBar.setVisibility(View.GONE);
                binding.tvGoodsNoMore.setVisibility(View.GONE);
            } else {
                binding.rlNoData.setVisibility(View.GONE);
                binding.tvGoodsNoMore.setVisibility(View.VISIBLE);
                binding.rlSearchBar.setVisibility(View.VISIBLE);
            }
            searchGoodsAdapter.mList = goodsBeanList;
            searchGoodsAdapter.notifyDataSetChanged();
        });


        //获取适配器上下文
        SearchShopAdapter searchShopAdapter = new SearchShopAdapter(SearchActivity.this, viewModel);
        //把adapterset进去
        binding.rvSearchShopList.setAdapter(searchShopAdapter);
        searchShopAdapter.setOnItemClick((position, data) -> viewModel.goShopDetail(data.getBusinessId()));

        viewModel.searchShopBeanList.observe(this, searchShopBeanList -> {
            searchShopAdapter.mList = searchShopBeanList;
            searchShopAdapter.notifyDataSetChanged();

            if (searchShopBeanList == null || searchShopBeanList.isEmpty()) {
                binding.rlNoData.setVisibility(View.VISIBLE);
                binding.tvShopNoMore.setVisibility(View.GONE);
            } else {
                binding.rlNoData.setVisibility(View.GONE);
                binding.tvShopNoMore.setVisibility(View.VISIBLE);
            }
        });


        FlexboxLayoutManager flexboxLayoutManager = new FlexboxLayoutManager(this, FlexDirection.ROW, FlexWrap.WRAP);
        binding.rvSearchHistory.setLayoutManager(flexboxLayoutManager);
        //获取适配器上下文
        SearchHistoryAdapter searchHistoryAdapter = new SearchHistoryAdapter(this);
        //把adapterset进去
        binding.rvSearchHistory.setAdapter(searchHistoryAdapter);

        searchHistoryAdapter.setOnItemClick(new xxBaseRecyclerViewAdapter.OnItemClick<String>() {
            @Override
            public void itemClickCalBack(int position, String data) {
                viewModel.searchWordClick(data);
                binding.etSearch.clearFocus();
            }
        });
        viewModel.searchWordList.observe(this, searchWordList -> {
            searchHistoryAdapter.mList = searchWordList;
            searchHistoryAdapter.notifyDataSetChanged();
            if (searchWordList.isEmpty()) {
                binding.rlSearchHistoryBar.setVisibility(View.GONE);
                binding.rvSearchHistory.setVisibility(View.GONE);
            } else {
                binding.rlSearchHistoryBar.setVisibility(View.VISIBLE);
                binding.rvSearchHistory.setVisibility(View.VISIBLE);
            }
        });

        /*切换状态Tab*/
        binding.tabLayout.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            public void onTabSelected(TabLayout.Tab tab) {
                switch (tab.getPosition()) {
                    case 0:
                        viewModel.search(1);
                        break;
                    case 1:
                        viewModel.showPriceFlag.postValue(false);
                        viewModel.showSortFlag.postValue(false);
                        viewModel.search(2);
                        break;
                }
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {
            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {
            }
        });

        binding.rlBackTop.setOnClickListener(view -> {
            if (viewModel.searchType.getValue() == 1) {
                binding.rvSearchGoodsList.scrollToPosition(0);
            } else {
                binding.rvSearchShopList.scrollToPosition(0);
            }
        });

        binding.tvBlank.setOnClickListener(view -> {
            viewModel.showPriceFlag.postValue(false);
            viewModel.showSortFlag.postValue(false);
        });
    }

    @Override
    public SearchViewModel initViewModel() {
        SearchRequest model = new SearchRequest();
        String keyWord = getIntent().getStringExtra("keyWord");
        return new SearchViewModel(getApplication(), model, keyWord);
    }
}
