package com.xx.hbhconsumer.ui.shop;

import android.app.Application;
import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.ShopRequest;
import com.xx.hbhconsumer.data.http.respons.ShopAndGoodsBean;
import com.xx.hbhconsumer.data.http.respons.ShopBean;
import com.xx.hbhconsumer.data.local.LocalData;

import java.util.ArrayList;
import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.binding.command.BindingAction;
import me.goldze.mvvmhabit.binding.command.BindingCommand;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class ShopViewModel extends BaseViewModel<ShopRequest> {
    //昵称的绑定
    public MutableLiveData<ShopBean> shopBean = new  MutableLiveData<>(new ShopBean());
    public MutableLiveData<List<ShopBean>> shopBeanList = new  MutableLiveData<>(new ArrayList<>());
    public MutableLiveData<List<ShopAndGoodsBean>> shopAndGoodsBeanList = new  MutableLiveData<>(new ArrayList<>());

    public ShopViewModel(@NonNull Application application) {
        super(application);
    }

    public ShopViewModel(@NonNull Application application, ShopRequest model) {
        super(application, model);
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        getTopShop();
        shopBeanList();
        getShopList();
    }

    public void getShopList() {
        model.getShopList(LocalData.getAffiliatedCompany())
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(ShopViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<ShopAndGoodsBean>>() {
                    @Override
                    public void onSuccess(List<ShopAndGoodsBean> resultBean) {

                        if (resultBean != null && resultBean.size() <= 5) {
                            shopAndGoodsBeanList.postValue(resultBean);
                        }
                        if (resultBean != null && resultBean.size() > 5) {
                            shopAndGoodsBeanList.postValue(resultBean.subList(0, 5));
                        }
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }
    public void shopBeanList() {
        model.getTopShopList(LocalData.getAffiliatedCompany())
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(ShopViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<ShopBean>>() {
                    @Override
                    public void onSuccess(List<ShopBean> resultBean) {
                        shopBeanList.postValue(resultBean);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }

    public void getTopShop() {
        model.getTopShop(LocalData.getAffiliatedCompany())
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(ShopViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<ShopBean>() {
                    @Override
                    public void onSuccess(ShopBean resultBean) {
                        shopBean.postValue(resultBean);
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }


                });
    }

    public void goShopDetail(String merchantId) {
        Bundle bundle = new Bundle();
        bundle.putString("merchantId", merchantId);
        startActivity(ShopDetailActivity.class, bundle);
    }

    //跳转修改手机号界面
    public BindingCommand goShopDetail = new BindingCommand(new BindingAction() {
        @Override
        public void call() {
            goShopDetail(shopBean.getValue().getStoreBusinessId());
        }

    });
}