package com.xx.hbhconsumer.ui.storeservices;

import android.graphics.Typeface;
import android.os.Bundle;
import android.text.SpannableString;
import android.text.Spanned;
import android.text.style.AbsoluteSizeSpan;
import android.text.style.StyleSpan;
import android.view.View;
import android.widget.TextView;

import com.google.android.material.tabs.TabLayout;
import com.xx.hbhconsumer.R;
import com.xx.hbhconsumer.data.http.requst.AgreementRequest;
import com.xx.hbhconsumer.databinding.ActivityStoreServicesBinding;
import com.xx.hbhconsumer.utils.RetrofitClient;

import me.goldze.mvvmhabit.base.BaseActivity;
import me.tatarka.bindingcollectionadapter2.BR;

public class StoreServicesActivity extends BaseActivity<ActivityStoreServicesBinding, StoreServicesViewModel> {

    @Override
    public void initData() {
        super.initData();

        TabLayout.Tab tab = binding.tabLayout.getTabAt(0);
        String selectTab = tab.getText().toString().trim();

        SpannableString spannableString = new SpannableString(selectTab);
        StyleSpan styleSpan = new StyleSpan(Typeface.BOLD);
        spannableString.setSpan(styleSpan, 0, selectTab.length(), Spanned.SPAN_INCLUSIVE_EXCLUSIVE);
        tab.setText(spannableString);

        viewModel.agreementBean.observe(this, agreementBean -> {
            if ("1".equals(viewModel.basic)) {
                binding.webview1.setVisibility(View.VISIBLE);
                binding.webview2.setVisibility(View.GONE);
                binding.webview1.loadUrl(RetrofitClient.baseH5Url + agreementBean);
            } else {
                binding.webview1.setVisibility(View.GONE);
                binding.webview2.setVisibility(View.VISIBLE);
                binding.webview2.loadUrl(RetrofitClient.baseH5Url + agreementBean);
            }
        });

        /*切换状态Tab*/
        binding.tabLayout.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            /*消息状态 1-未读 2-已读*/
            public void onTabSelected(TabLayout.Tab tab) {

                switch (tab.getPosition()) {
                    case 0:
                        viewModel.basic = "6";
                        viewModel.loadAgreement();
                        break;
                    case 1:
                        viewModel.basic = "7";
                        viewModel.loadAgreement();
                        break;
                }


                String selectTab = tab.getText().toString().trim();
                SpannableString spannableString = new SpannableString(selectTab);
                StyleSpan styleSpan = new StyleSpan(Typeface.BOLD);
                spannableString.setSpan(styleSpan, 0, selectTab.length(), Spanned.SPAN_INCLUSIVE_EXCLUSIVE);
                tab.setText(spannableString);
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {
                String selectTab = tab.getText().toString().trim();
                SpannableString spannableString = new SpannableString(selectTab);
                StyleSpan styleSpan = new StyleSpan(Typeface.NORMAL);
                spannableString.setSpan(styleSpan, 0, selectTab.length(), Spanned.SPAN_INCLUSIVE_EXCLUSIVE);
                tab.setText(spannableString);
            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {
            }
        });
    }

    @Override
    public int initContentView(Bundle savedInstanceState) {
        return R.layout.activity_store_services;
    }

    @Override
    public int initVariableId() {
        return BR.storeServicesViewModel;
    }

    @Override
    public StoreServicesViewModel initViewModel() {
        AgreementRequest loginRequest = new AgreementRequest();
        return new StoreServicesViewModel(getApplication(), loginRequest);
    }
}
