package com.xx.hbhconsumer.ui.storeservices;

import android.app.Application;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;

import com.xx.hbhconsumer.data.http.requst.AgreementRequest;
import com.xx.hbhconsumer.data.http.requst.PhoneRequest;
import com.xx.hbhconsumer.data.http.respons.AgreementBean;
import com.xx.hbhconsumer.ui.useragreement.UserAgreementViewModel;

import java.util.List;

import io.reactivex.rxjava3.disposables.Disposable;
import io.reactivex.rxjava3.functions.Consumer;
import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.http.ApiDisposableObserver;
import me.goldze.mvvmhabit.utils.RxUtils;

public class StoreServicesViewModel extends BaseViewModel<AgreementRequest> {

    public MutableLiveData<String> agreementBean = new  MutableLiveData<>(null);

    public StoreServicesViewModel(@NonNull Application application) {
        super(application);
    }

    public StoreServicesViewModel(@NonNull Application application, AgreementRequest model) {
        super(application, model);
    }

    public String basic = "6";

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onStart() {
        super.onStart();
    }

    @Override
    public void onResume() {
        super.onResume();
        loadAgreement();
    }

    public void loadAgreement() {
        model.getContent(basic)
                .compose(RxUtils.schedulersTransformer()) //线程调度
                .doOnSubscribe(StoreServicesViewModel.this)
                .doOnSubscribe(new Consumer<Disposable>() {
                    @Override
                    public void accept(Disposable disposable) throws Exception {
                    }
                }).subscribe(new ApiDisposableObserver<List<String>>() {
                    @Override
                    public void onSuccess(List<String> resultBean) {
                        if (resultBean != null && !resultBean.isEmpty()) {
                            agreementBean.postValue(resultBean.get(0));
                        }
                    }

                    @Override
                    public void onError(String Error) {
                        dismissDialog();
                    }
                });
    }
}
